Tue Jun 01 21:40:20 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Request_Mux_Strategy.h:
          MSVC does not like forward declaration of struct as class

        * tao/TAO.dsp:
        * tao/TAO_Static.dsp:
          Added new files to the project

Tue Jun  1 21:54:56 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Connector_Registry.cpp:
        * tao/Acceptor_Registry.cpp:
          Remove all the elements from the acceptor and connector
          registries when their close_all() method is invoked.

Tue Jun  1 21:50:16 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Pluggable.cpp:
          Added missing #include

        * tao/UIOP_Transport.cpp:
        * tao/IIOP_Transport.cpp:
          Removed pesky warnings about unreached statements

Tue Jun  1 19:48:12 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * Merged in the changes from ami_phase1_start to
          ami_phase1_end. The main trunk *before* the merge is tagged as
          pre_ami_phase1_merge and after the merge is pos_ami_phase1_merge

        * This change is the first phase in the quest for supporting
          asynchronous messaging in TAO, it involved a somewhat large
          re-organization of the critical path to:

        * Decouple the waiting strategy for the protocol implementations:
          a new strategy in incorporated that can handle any of the
          current waiting modes (on read, select or the leader-follower
          set) using *any* protocol.

        * Allowing multiple simultaneous requests over the same
          connection, this is also strategized so low-latency or QoS
          enabled applications can obtain better guarantees. Currently
          only the "exclusive" strategy is implemented.

        * Decoupling the thread that sends a request from the thread that
          receives the reply: a new object is introduced, the
          Reply_Dispatcher that will process the reply. Currently the
          Synch_Reply_Dispatcher is a noop and simply stores the CDR
          stream and reply status.  The thread that initiated the request
          then process the reply.  In the future an
          Asynch_Reply_Dispatcher will process the reply as soon as it
          arrives and pass it up to the Reply_Handlers specified by the
          user when making asynchronous invocations.

        * Most of the work on this branch was done by Alexander Babu
          Arulanthu <alex@cs.wust.edu> I'm just helping him with the
          merge.  Please check
          http://www.cs.wustl.edu/~alex/Messaging/messaging_design.html
          for more details on these changes.

Tue Jun  1 18:00:23 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_server/Audio_Control_State.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_server/Audio_Control_i.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_server/Globals.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_server/Video_Control_State.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_server/Video_Control_i.cpp:
          Added missing template instantiation pragmas.

        * orbsvcs/tests/AVStreams/mpeg/source/server/as.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/server/augmented_server.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/server/server.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/server/vs.cpp:
          Added missing template instantiation pragmas.

        * orbsvcs/tests/AVStreams/mpeg/source/server/Property_Exporter.cpp:
         Fixed a Any reference to CORBA::Any.

Tue Jun  1 17:27:49 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_typecode/typecode_defn.cpp:
          Removed ACE_NTOHL macro from code generated for
          32-bit union case label values (long, ulong and enum).
          The bytes were getting swapped one too many times.
          Thanks to Carlos for his explanation of the byte-
          swapping that goes on in typecode generation.

Tue Jun  1 14:08:46 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * docs/releasenotes/orbcore.html:
          Documented the new (and correct) behavior of ORB_init()

Tue Jun  1 14:37:14 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * examples/Simple/time-date: Got this example to work on UNIX
          platforms, as well as NT.

Tue Jun  1 13:56:09 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        Replaced ACE_U_LongLong * ACE_UINT64 with
        ACE_U_LongLong * ACE_UINT32 in the following files :

        * orbsvcs/orbsvcs/Time/TAO_Time_Service_Server.cpp
        * orbsvcs/orbsvcs/Time/TAO_Time_Service_Clerk.cpp
        * orbsvcs/orbsvcs/Time/Timer_Helper.cpp

Tue Jun 01 12:33:53 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/TAO.cpp (init_child_poa and init): Added new methods that
          take the addition orb name parameter.

        * performance-tests/Cubit/TAO/MT_Cubit/Cubit_Task.cpp
          (initialize_orb): Fixed orb initialization such that a different
          orb name is specified for every new ORB.

Tue Jun 01 10:45:04 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/Request.cpp: added TAO_Object_Manager<CORBA_Request>
          explicit instantiation.

        * tao/ValueFactory_Map.cpp: added ACE_Hash_Map_Iterator_Ex
          and ACE_Hash_Map_Reverse_Iterator_Ex explicit instantiations.

Tue Jun  1 09:57:42 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * TAO-INSTALL.html: Updated the list of platforms that TAO is
          supported on.

        * tao/Policy.pidl: Removed a stray '_' at the end of the file.
          Thanks to David Levine for reporting this.

        * examples/Simple/Simple_util: Fixed more inconsistent programming
          style.  Thanks to David Levine for reporting this.

Tue Jun  1 09:37:20 1999 Fred Kuhns <fredk@cs.wustl.edu>

        * removed the explicit instantiation of ACE_Node<ACE_CString>,
          ACE_Unbounded_Set<ACE_CString> and
          ACE_Unbounded_Set_Iterator<ACE_CString> from params.cpp.  These
          are already instantiated in Service_Config.cpp.  Thanks to David
          Levine for reporting this.

Mon May 31 20:34:26 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/InterOp-Naming/: Fixed NT project files.

        * performance-tests/POA/Object_Creation_And_Registration/registration.cpp
          (parse_args): Fixed signed/unsigned comparison.

        * tao/orb.idl: Included the Policy.pidl file in orb.idl.  This
          will bring the Policy interface into the CORBA module.

        * tao/Policy.pidl: Added ending pragmas and appropriate #defines
          for file inclusion.

Mon May 31 19:32:29 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * docs/releasenotes/ec.html:
        * examples/POA/Default_Servant/README:
        * examples/POA/Forwarding/README:
        * examples/POA/Generic_Servant/README:
        * examples/POA/On_Demand_Activation/README:
        * examples/Simulator/README:
        * orbsvcs/Naming_Service/README:
        * orbsvcs/orbsvcs/Event/RT_Task.cpp:
        * orbsvcs/tests/start_services:
        * orbsvcs/tests/AVStreams/benchmark/server.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_client/Command_Handler.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/server/augmented_server.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/server/server.cpp:
        * orbsvcs/tests/EC_Multiple/README:
        * orbsvcs/tests/EC_Multiple/run_dynamic:
        * orbsvcs/tests/EC_Multiple/run_latency:
        * orbsvcs/tests/EC_Multiple/run_overhead:
        * orbsvcs/tests/EC_Multiple/run_schedule:
        * orbsvcs/tests/EC_Multiple/run_throughput:
        * orbsvcs/tests/EC_Multiple/run_utilization:
        * performance-tests/Cubit/COOL/IDL_Cubit/README:
        * performance-tests/Cubit/CORBAplus/MT_Cubit/server/svr.cpp:
        * performance-tests/Cubit/TAO/DII_Cubit/README:
        * performance-tests/Thruput/CORBAplus/run_server:
        * performance-tests/Thruput/TAO/new_server_test:
        * performance-tests/Thruput/TAO/run_server:
        * tests/NestedUpcall/MT_Client_Test/README:
        * tests/NestedUpcall/Reactor/README:
        * tests/NestedUpcall/Triangle_Test/README:
          Removed all references to the -ORBhost or -ORBport options,
          first because the default values work in most cases and second
          because the options are obsolete (-ORBendpoint replaces both).

Mon May 31 19:21:59 1999  Ossama Othman  <othman@cs.wustl.edu>

        * tao/UIOP_Acceptor.cpp:

          Enabled and fixed default UIOP endpoint creation code.

Mon May 31 18:09:22 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tests/InterOp-Naming/InterOp-Naming.dsw:
        * tests/InterOp-Naming/INS_client.dsp:
        * tests/InterOp-Naming/INS_server.dsp:
        * tests/InterOp-Naming/InterOp_test.dsp:
          Updated the MSVC project files, thanks to Vishal for updating
          this example.

Mon May 31 18:19:01 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/encode.cpp: Removed a superfluous cast to ACE_Message_Block*
          in TAO_Marshal_Union::encode().

Mon May 31 17:45:56 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Stub.cpp: Made a change in do_dynamic_call() in the case
          where the 'return' Any contains only a message block. This was
          one of those 'how did this code ever work?' situations, but it's
          possible that this branch had never been tested.  After making
          this small mod, I saw a way to eliminate two CDR stream
          constructions (I think). I left the original code (with the
          small fix) commented out, so it can be quickly restored if
          anyone sees something I missed or if there are resulting
          problems. This fixes a problem reported by Dale/Christine Wood
          <dale_wood@Mitel.COM>.

Mon May 31 17:35:51 1999  Ossama Othman  <othman@cs.wustl.edu>

        * docs/Options.html: Updated -ORBendpoint documentation with new
          "default endpoint" description.

Mon May 31 15:55:07 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        * orbsvcs/orbsvcs/Time/TAO_Time_Service_Server.cpp,
          orbsvcs/orbsvcs/Time/TAO_Time_Service_Clerk.cpp,
          orbsvcs/orbsvcs/Time/Timer_Helper.cpp: Fixed a warning on
          VxWorks. Replaces long int * ACE_UINT64 with ACE_UINT64 *
          ACE_UINT64.

        * Removed tests/InterOp-Naming/InterOp_test.cpp as it was
          obsolete.

Mon May 31 16:44:22 1999  Ossama Othman  <othman@cs.wustl.edu>

        * tao/Acceptor_Registry.{h,cpp} (close_all): Added an
          Acceptor_Registry::close_all() method that closes all registered
          open acceptors.

        * tao/Acceptor_Registry.{h,cpp} (open, open_default): Updated to
          accept "empty string" endpoints. If an endpoint is specified
          with only the protocol, e.g. `uiop://', then open an Acceptor
          with a default endpoint. This conforms to the "iioploc" syntax.
          All TAO pluggable protocols will be expected to have the ability
          to create a default endpoint.

          Minor cosmetic changes.

        * tao/Connector_Registry.cpp (close_all): Minor cosmetic changes.

        * tao/ORB_Core.cpp (fini): Added calls to
          Connector_Registry::close_all() and
          Acceptor_Registry::close_all() to make sure all connectors and
          acceptors are shutdown properly.

        * tao/IIOP_Profile.cpp (set): Added a comment about passing in
          TAO_ORB_Core as a parameter, instead of using the TAO_ORB_Core
          singleton.

        * tao/UIOP_Connector.cpp: Fixed pragma template instantiation that
          was split between two lines without a backslash.

        * tao/UIOP_Profile.cpp (parse_string): Corrected memory
          allocation/deallocation mismatch.  Memory was being allocated
          using CORBA::string_alloc() but deallocated by delete [].

        * tao/params.cpp: ACE_Unbounded_Set_Iterator<ACE_CString> template
          was being incorrectly instantiated with a second template
          argument.  In addition, ACE_CString was mispelled "ACE_Cstring."

Mon May 31 15:55:07 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        Converted the INS test to a stand-alone. It was previously
        working in conjunction with the bank server.The test can be used
        to locate the Naming Service or any arbitrary service through
        iioploc IORs. Added the following files :

        * tests/InterOp-Naming/INS.idl: Defines a simple interface with
          a single operation.

        The following files define the INS test server capable of being
        located through iiopoc IORs.
        * tests/InterOp-Naming/Server_i.h:
        * tests/InterOp-Naming/Server_i.cpp:
        * tests/InterOp-Naming/INS_test_server:

        The following files define the servant implementation.
        * tests/InterOp-Naming/INS_i.cpp:
        * tests/InterOp-Naming/INS_i.h:

        The test client :
        * tests/InterOp-Naming/INS_test_client.cpp:

        Changed the Makefile and README according to the above changes.
        * tests/InterOp-Naming/README:
        * tests/InterOp-Naming/Makefile:

Mon May 31 14:50:07 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/default_resource.cpp (init_protocol_factories): This routine
          needs to provide default protocol factories for both IIOP and
          UIOP if it cannot get ones from Service_Config.  Otherwise,
          programs that skip TAO_Internal::open_services() won't work.

Mon May 31 13:49:17 1999  Ossama Othman  <othman@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/server.cpp:

          Removed all occurrences of -ORBhost and -ORBport, and updated
          to use new -ORBendpoint option instead.  This removes all of the
          run-time warnings regarding the usage of -ORBhost and -ORBport.

Mon May 31 11:56:43 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * performance-tests/Cubit/TAO/IDL_Cubit/collocation_test.cpp
          (main): Removed unused <env>.  Rearranged code.

        * performance-tests/Cubit/TAO/IDL_Cubit/Cubit_Server.cpp
          (~Cubit_Server): No need to deactivate the factory object
          because by the time we reach the destructor, the ORB has already
          been shut down.

        * performance-tests/Cubit/TAO/IDL_Cubit/Cubit_Client.cpp
          (init,shutdown_server): Changed to toggle collocation
          optimization directly from the ORB.  We cannot do this thru
          TAO_ORB_Core_instance anymore because it gives you back the
          "default" ORB which is not the one we want in collocation_test.

        * performance-tests/Cubit/TAO/IDL_Cubit/collocation/svc.conf:
          Changed obsolete option -ORBreactorlock to -ORBreactortype.
          Changed to use reactive concurrency model.  Currently, ORB
          cannot shutdown the acceptor thread if we use
          thread-per-connection model.

Mon May 31 11:22:53 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * examples/Simple/time-date: Added a new example that illustrates
          how to dynamically link the TAO ORB into an application using
          the ACE Service Configurator.  Thanks to Michael Kircher for
          helping with this implementation.

        * examples/Simple/Simple_Util: Fixed a few inconsistencies in the
          programming style.

        * tao/ORB_Core.cpp (init),
          tao/TAO_Internal.cpp (close_services): Added the
          SkipServiceConfigOpen option to ensure the ORB doesn't try to
          perform the Service Config open() processing, which is important
          if the ORB is already being linked by the ACE Service
          Configurator.

Sun May 30 21:23:31 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/sfp.idl :
        * orbsvcs/orbsvcs/AV/sfp.cpp:

          Fixed the case-only difference in IDL by suffixing a _Msg to all
          enumerators as a temporary fix until the OMG AVStreams RTF fixes
          the SFP idl.

Sun May 30 16:23:17 1999  Ossama Othman  <othman@cs.wustl.edu>

        * docs/releasenotes/index.html:
        * docs/releasenotes/orbcore.html:

          Updated Pluggable Protocol release notes and updated all
          references of the now deprecated "-ORBhost" and "-ORBport"
          options with "-ORBendpoint."

Sun May 30 13:51:18 1999  Ossama Othman  <othman@cs.wustl.edu>

        * tao/Acceptor_Registry.cpp:
        * tao/Connector_Registry.cpp:
        * tao/Protocol_Factory.cpp:
        * tao/Resource_Factory.cpp:

          Removed semi-colons at end of pragma template instantiations.

Sun May 30 13:39:47 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * docs/compiler.html:
          Added new IDL compiler options -Cw and -Ce to the
          releasenotes, along with an explanation of the
          current inconsistency between OMG's identifier
          spelling rule and its sfp.idl file.

Sat May 29 20:25:10 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/include/UTL_Identifier.h:
        * TAO_IDL/include/UTL_Error.h:
        * TAO_IDL/include/IDL_Global.h:
        * TAO_IDL/util/UTL_Identifier.cpp:
        * TAO_IDL/util/UTL_Scope.cpp:
        * TAO_IDL/util/UTL_Global.cpp:
        * TAO_IDL/util/UTL_String.cpp:
        * TAO_IDL/util/UTL_Error.cpp:
        * TAO_IDL/driver/DRV_Args.cpp:
          Started out as an attempt to have the IDL compiler output
          an error if two identifiers in the same scope differ only
          in the case of one or more or their characters. However, it
          was discovered that sfp.idl (which is derived from the spec)
          contains such errors - some enum values clash with struct
          names, and since enums don't generate their own scope...
          So what we did was to default the IDl compiler to produce
          a warning if this happens. This behavior can also be
          specified explicitly by the command line option -Cw. To
          be more strict and produce errors instead, use the command
          line option -Ce.

Sat May 29 17:48:24 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Object.cpp (_non_existent): This function is not required
          with minimum CORBA.

        * tao/POAC: Forwarding exception is not supported with minimum
          CORBA.

        * tao/UIOP_Connect.cpp (handle_locate):
        * tao/Connect.cpp (handle_locate):

          No need to check for Forwarding exception in the case of minimum
          CORBA.

        * tao/orbconf.h: With minimum CORBA, we don't have the
          ForwardRequest exception.  Therefore, we can't support the INS
          forwarding agent.

Sat May 29 16:33:13 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO/tests/DynAny_Test/da_tests.idl:
        * TAO/tests/DynAny_Test/test_dynenum.cpp:
        * TAO/tests/DynAny_Test/test_dynunion.cpp:
          Changed some enum value names in the IDl file to
          be not so likely to clash with something else in the
          namespace. Hopefully this will get rid of some DU
          errors, reported by David Levine.

Sat May 29 13:40:41 1999  Marina Spivak  <marina@cs.wustl.edu>

        * tao/TAO.{h, cpp} (TAO_ORB_Manager):
        added <activate_poa_manager> method to put the POA manager into
        the <Active> state for processing the requests.  This is useful
        for clients, which are not going to call "orb->run", yet want to
        be able to process incoming CORBA requests while waiting on CORBA
        requests sent to servers.
        * orbsvcs/tests/Simple_Naming/client.cpp:
        added a call to TAO_ORB_Manager::activate_poa_manager in client
        initialization code, so client can respond to incoming requests
        (this fixes a problem in Exception test that surfaced due to
        recent updates to the POA).

Fri May 28 23:11:56 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Connect.cpp:
          Instead of constructing a CORBA::Environment on the stack for
          each upcall we use the one allocated on TSS storage. This saves
          a little time since each Environment has its one mutex that
          needs to be initialized in that case.

        * performance-tests/Cubit/TAO/IDL_Cubit/client.cpp:
        * performance-tests/Cubit/TAO/IDL_Cubit/server.cpp:
          The server and client try to put themselves on the real-time
          scheduling class, if they cannot make it they just print a
          warning.

Fri May 28 16:21:02 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/ORB.cpp:
          Removed 'ACE_INLINE' from the create_dyn_* functions,
          which had eveidently been moved out of ORB.i. Thanks
          to Carlos for reporting the resulting link errors
          on CC.

Fri May 28 15:51:18 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        Fixed the overflow problem in some expressions. Thanks to
        Byron Harris <harris_b@ociweb.com> for reporting this and
        suggesting the fix.

        * orbsvcs/orbsvcs/Time/Timer_Helper.cpp:
        * orbsvcs/orbsvcs/Time/TAO_Time_Service_Server.cpp:
        * orbsvcs/orbsvcs/Time/TAO_Time_Service_Clerk.cpp:

Fri May 28 12:09:27 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Object.cpp:
          Added missing #include

Fri May 28 09:56:29 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_root/root.cpp:
          Fixed bug in processing for forward declarations.

Fri May 28 04:41:30 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * docs/compiler.html: Added documentation for -Gv flag (to
          generate code that supports OBV.)

        * TAO_IDL/ast/ast_module.cpp (AST_Module): Symbols in module CORBA
          should only be added to the table once.

        * tao/orb.idl: Added macros to avoid including this file twice.

        * tao/GIOP_Server_Request.i (principal): Changed to return
          Principal_var::ptr() directly to avoid type ambiguity.

        * tao/Stub.i: Reordered function definitions to avoid inline
          functions being used before declared inlined.

Thu May 27 23:15:53 1999  Marina Spivak  <marina@cs.wustl.edu>

        * orbsvcs/orbsvcs/Naming/Naming_Utils.cpp (init_new_naming):
        Modified to add the object reference to the root naming context to
        the orb's ior lookup table, so that Naming Service can be located
        through iioploc IORs.

Thu May 27 22:00:07 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Any.cpp:
        * tao/Object.cpp:
          If an object is extracted from an InputCDR stream that doesn't
          have an ORB Core configured then the default ORB core is
          used. This is common in extraction from Anys.
          Thanks to Jeff Parsons for tracking this down.

        * TAO_IDL/driver/drv_preproc.cpp:
          Added missing '/' between ACE_ROOT and TAO/tao to find the
          orb.idl file

Thu May 27 21:42:28 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_array.cpp:
          Fixed a typo.

Thu May 27 21:02:54 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/Makefile:
        * TAO_IDL/be/be_decl.cpp:
        * TAO_IDL/be/be_visitor_array.cpp:
        * TAO_IDL/be/be_visitor_enum.cpp:
        * TAO_IDL/be/be_visitor_exception.cpp:
        * TAO_IDL/be/be_visitor_factory.cpp:
        * TAO_IDL/be/be_visitor_field.cpp:
        * TAO_IDL/be/be_visitor_interface.cpp:
        * TAO_IDL/be/be_visitor_root.cpp:
        * TAO_IDL/be/be_visitor_sequence.cpp:
        * TAO_IDL/be/be_visitor_structure.cpp:
        * TAO_IDL/be/be_visitor_typedef.cpp:
        * TAO_IDL/be/be_visitor_union.cpp:
        * TAO_IDL/be/be_visitor_union_branch.cpp:
        * TAO_IDL/be/be_visitor_valuetype.cpp:
        * TAO_IDL/be/be_visitor_array/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_array/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_enum/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_enum/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_exception/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_exception/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_exception/exception.cpp:
        * TAO_IDL/be/be_visitor_field/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_field/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_interface/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_interface/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_interface/interface.cpp:
        * TAO_IDL/be/be_visitor_module/module.cpp:
        * TAO_IDL/be/be_visitor_root/root.cpp:
        * TAO_IDL/be/be_visitor_sequence/cdr_op_ch.cpp:
        * TAO_IDL/be/be_visitor_sequence/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_sequence/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_structure/cdr_op_ch.cpp:
        * TAO_IDL/be/be_visitor_structure/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_structure/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_structure/structure.cpp:
        * TAO_IDL/be/be_visitor_typedef/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_typedef/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_typedef/typedef.cpp:
        * TAO_IDL/be/be_visitor_union/cdr_op_ch.cpp:
        * TAO_IDL/be/be_visitor_union/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_union/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_union/union.cpp:
        * TAO_IDL/be/be_visitor_union_branch/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_union_branch/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_valuetype/cdr_op_ci.cpp:
        * TAO_IDL/be/be_visitor_valuetype/cdr_op_cs.cpp:
        * TAO_IDL/be/be_visitor_valuetype/field_cdr_ci.cpp:
        * TAO_IDL/be/be_visitor_valuetype/valuetype.cpp:
        * TAO_IDL/be_include/be_codegen.h:
        * TAO_IDL/be_include/be_visitor_array.h:
        * TAO_IDL/be_include/be_visitor_enum.h:
        * TAO_IDL/be_include/be_visitor_exception.h:
        * TAO_IDL/be_include/be_visitor_field.h:
        * TAO_IDL/be_include/be_visitor_interface.h:
        * TAO_IDL/be_include/be_visitor_sequence.h:
        * TAO_IDL/be_include/be_visitor_structure.h:
        * TAO_IDL/be_include/be_visitor_typedef.h:
        * TAO_IDL/be_include/be_visitor_union.h:
        * TAO_IDL/be_include/be_visitor_union_branch.h:
        * TAO_IDL/be_include/be_visitor_valuetype.h:
        * TAO_IDL/be_include/be_visitor_array/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_array/cdr_op_cs.h:
        * TAO_IDL/be_include/be_visitor_enum/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_enum/cdr_op_cs.h:
        * TAO_IDL/be_include/be_visitor_exception/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_exception/cdr_op_cs.h:
        * TAO_IDL/be_include/be_visitor_field/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_field/cdr_op_cs.h:
        * TAO_IDL/be_include/be_visitor_interface/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_sequence/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_structure/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_structure/cdr_op_cs.h:
        * TAO_IDL/be_include/be_visitor_typedef/cdr_op_ch.h:
        * TAO_IDL/be_include/be_visitor_typedef/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_typedef/cdr_op_cs.h:
        * TAO_IDL/be_include/be_visitor_union/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_union/cdr_op_cs.h:
        * TAO_IDL/be_include/be_visitor_union_branch/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_union_branch/cdr_op_cs.h:
        * TAO_IDL/be_include/be_visitor_valuetype/cdr_op_ch.h:
        * TAO_IDL/be_include/be_visitor_valuetype/cdr_op_ci.h:
        * TAO_IDL/be_include/be_visitor_valuetype/cdr_op_cs.h:
        * TAO_IDL/be_include/be_visitor_valuetype/field_cdr_ci.h:
          Moved all the code to generate CDR extraction and insertion
          operators to the _ci files (and classes), they were in the _cs
          files due to an historic accident.
          This was no big deal, but I needed to move the CDR operators for
          sequences generated into the *C.cpp files, so I needed to
          separate the code for the C.i file from the code to the C.cpp
          file.
          With this change Param_Test compiles with both compiled and
          interpretive marshaling.

        * tests/Multiple_Profiles/Makefile:
        * tests/Multiple_Profiles/forward.cpp:
          Removed, the test was obsolete.

Thu May 27 19:16:47 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/orb.idl:
          Removed the empty "interface" definitions. Recognizing certain
          scoped names is now handled in the IDL compiler.

        * TAO_IDL/fe/fe_init.cpp:
          Removed initialization of predefined types 'TypeCode' and
          'ValueBase'. They're now added inside CORBA module, and
          must not be used in an IDL file without the CORBA::
          scoping.

        * TAO_IDL/be/be_module.cpp:
          Added code to call base class (AST_Module) constructor
          explicitly, in order to use a private function to add
          the above types to the symbol table.

        * TAO_IDL/ast/ast_module.cpp:
          If called for 'module CORBA' inside orb.idl, constructor adds
          'CORBA::TypeCode' and 'CORBA::ValueBase' to symbol
          table.

        * TAO/tests/Param_Test/param_test.idl:
          Added '#include <orb.idl>' and scoped all typecode
          test parameters with 'CORBA::'.

        * TAO/tests/Param_Test/server.dsp:
        * TAO/tests/Param_Test/Makefile:
          Removed '-Gi' from command line for IDL compiler.
          Carlos fixed the problem that made that arg necessary.

        * TAO/orbsvcs/orbsvcs/CosPropertyService.idl:
        * TAO/orbsvcs/orbsvcs/CosTradingDynamic.idl:
        * TAO/orbsvcs/orbsvcs/CosTradingRepos.idl:
          Added '#include <orb.idl>' and added 'CORBA::' to
          all 'TypeCode' parameters.

Thu May 27 18:14:26 1999  Ossama Othman  <othman@cs.wustl.edu>

        * docs/Options.html:

          Added the new `-ORBendpoint' option to the CORBA::ORB option
          table, and added a note to the `-ORBhost' and `-ORBport' options
          explaining that the `-ORBendpoint' option supercedes them.

          Updated the `-ORBpreconnect' option description to reflect the
          new endpoint format.

Thu May 27 14:27:21 1999  Ossama Othman  <othman@cs.wustl.edu>

        * tao/[IU]IOP_Connector.cpp (preconnect):

          Fixed bug where memory was being freed even if no memory was
          allocated.

          Added debugging output for successful and unsuccessful
          preconnections.

Thu May 27 12:28:45 1999  Ossama Othman  <othman@cs.wustl.edu>

        * tao/[IU]IOP_Profile.cpp (parse_string, to_string):

          Updated URL style object reference parsing and creation methods
          to conform to the "iioploc" BNF specification.  All URL style
          object references will be of the form:

            protocol://V.v@addr1,...,W.w@addrN/object_key

          The version prefix (e.g. "V.v@") is optional.  All endpoints and
          preconnects specified with the "-ORBendpoint" and
          "-ORBpreconnect" command line options should be of the above
          form (without the object key).

          NOTE: The UIOP URL style object reference uses a vertical bar
          "|" to delimit where the object key begins.  This is needed to
          avoid any ambiguities caused by the fact that UIOP endpoints can
          have forward slashes "/" in them.  The use of the vertical bar
          "|" as an object key delimiter for UIOP may change in the
          future.

        * tao/Pluggable.cpp (make_mprofile):
        * tao/params.cpp (parse_endpoint):

          Updated to support the new URL style endpoints as specified by
          the "iioploc" BNF specification.

        * tao/Acceptor_Registry.cpp (open):
        * tao/[IU]IOP_Connector.cpp (preconnect):

          Corrected a problem where the protocol version was not removed
          from the endpoint string prior to passing it to the appropriate
          acceptor/connector.

        * tao/Pluggable.h:
        * tao/[IU]IOP_Connector.{h,cpp}:

          Added "object_key_delimiter ()" method.  This method is used
          when parsing URL style IORs during MProfile creation.

        * tao/ORB_Core.cpp (init):

          Fixed the "-ORBpreconnect" option so that the preconnect strings
          get added to the preconnect set, not the endpoint set.

Thu May 27 11:55:55 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * performance-tests/POA/Object_Creation_And_Registration/registration.cpp:
          Small fixes to the quantify code.

Wed May 26 22:28:18 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * TAO: Patched a bunch of NT project files:

          - examples/TAO_Examples.dsw
          - examples/Callback_Quoter/Consumer.dsp
          - examples/Callback_Quoter/Notifier.dsp
          - examples/Callback_Quoter/Supplier.dsp
          - examples/Event_Comm/Consumer.dsp
          - examples/Event_Comm/Event_Comm.dsw
          - examples/Event_Comm/Notifier.dsp
          - examples/Event_Comm/Supplier.dsp
          - examples/OBV/Typed_Events/client.dsp
          - examples/OBV/Typed_Events/server.dsp
          - examples/POA/DSI/client.dsp
          - examples/POA/DSI/server.dsp
          - examples/POA/Default_Servant/client.dsp
          - examples/POA/Default_Servant/server.dsp
          - examples/POA/Forwarding/client.dsp
          - examples/POA/Forwarding/server.dsp
          - examples/POA/Generic_Servant/client.dsp
          - examples/POA/Generic_Servant/server.dsp
          - examples/POA/Identity/Identity.dsp
          - examples/POA/TIE/client.dsp
          - examples/POA/TIE/server.dsp
          - examples/Quoter/Factory_Finder.dsp
          - examples/Quoter/Generic_Factory.dsp
          - examples/Quoter/client.dsp
          - examples/Quoter/server.dsp
          - examples/Simple/bank/client.dsp
          - examples/Simple/bank/server.dsp
          - examples/Simple/chat/client.dsp
          - examples/Simple/chat/server.dsp
          - examples/Simple/echo/client.dsp
          - examples/Simple/echo/server.dsp
          - examples/Simple/grid/client.dsp
          - examples/Simple/grid/server.dsp
          - examples/Simple/time/client.dsp
          - examples/Simple/time/server.dsp
          - examples/Simple/time-date/Time_Date.idl
          - examples/Simple/time-date/Time_Date_Client_i.cpp
          - examples/Simple/time-date/Time_Date_Client_i.h
          - examples/Simple/time-date/Time_Date_i.cpp
          - examples/Simple/time-date/Time_Date_i.h
          - examples/Simple/time-date/client.dsp
          - examples/Simple/time-date/client_static.dsp
          - examples/Simple/time-date/server.dsp
          - examples/Simple/time-date/server_static.dsp
          - examples/Simple/time-date/time_date.dsw
          - performance-tests/TAO_Perf_Tests.dsw
          - performance-tests/POA/Object_Creation_And_Registration/registration.dsp
          - performance-tests/Pluggable/Pluggable.dsw
          - performance-tests/Pluggable/client.dsp
          - performance-tests/Pluggable/server.dsp

Thu May 27 10:05:28 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Managed_Types.i:
          Fixed initialization of TAO_String_Manager, unfortunately we
          still don't have a portable fix for TAO_WString_Manager.
          Thanks to Tim Stack <stack@cs.utah.edu> for reporting this
          problem.

Thu May 27 09:55:10 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_argument/compiled_marshal_ss.cpp:
        * TAO_IDL/be/be_visitor_argument/marshal_ss.cpp:
          Fixed problem with generated code for arrays in interpretive
          marshaling based skeletons.

        * TAO_IDL/be_include/be_codegen.h:
          Minor cosmetic fixes.

Thu May 27 09:16:17 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/decode.cpp:
        * tao/Stub.cpp:
          Changed some any_owns_data_ assignments from 1 to 0.
          In all cases, the Any's value_ had just been freed
          and set to 0.

Thu May 27 09:06:01 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corbafwd.h:
        * tao/Principal.h:
        * tao/Principal.i:
        * tao/GIOP_Server_Request.h:
        * tao/GIOP_Server_Request.cpp:
        * tao/TAO.dsp:
        * tao/TAO_Static.dsp:
          Added _var and _out code for class Principal, and
          made request_principal_ member of GIOP_Server_Request
          a _var. When a TAO server gets a request from an
          OmniORB client, the Principal pointer in the header
          is non-null, and we were leaking the memory. Thanks
          to Rebecca Sanford <Rebecca.A.Sanford@gd-is.com>
          for pointing this out.

Wed May 26 21:40:34 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * examples/POA/Adapter_Activator/run_test.pl:
        * examples/POA/Explicit_Activation/run_test.pl:
        * examples/POA/Forwarding/run_test.pl:
        * examples/POA/Loader/run_test.pl:
        * examples/POA/On_Demand_Activation/run_test.pl:
        * examples/POA/On_Demand_Loading/run_test.pl:
        * examples/POA/Reference_Counted_Servant/run_test.pl:
        * examples/Quoter/run_test.pl:
        * orbsvcs/tests/AVStreams/benchmark/run_test.pl:
        * orbsvcs/tests/ImplRepo/run_test.pl:
        * orbsvcs/tests/Time/run_test.pl:
        * performance-tests/Cubit/TAO/DII_Cubit/run_test.pl:
        * performance-tests/Cubit/TAO/IDL_Cubit/run_test.pl:
        * performance-tests/Cubit/TAO/MT_Cubit/run_test.pl:
        * tests/CDR/run_test.pl:
        * tests/NestedUpcall/MT_Client_Test/run_test.pl:
        * tests/NestedUpcall/Reactor/run_test.pl:
        * tests/NestedUpcall/Triangle_Test/run_test.pl:
        * tests/Param_Test/run_test.pl:
          Removed all uses of -ORBobjrefstyle and -ORBport from the
          run_test.pl scripts.

        * performance-tests/Cubit/TAO/MT_Cubit/client.cpp:
          Changed the deprecated -ORBport and -ORBhost options for a
          -ORBendpoint option.

        * performance-tests/POA/Object_Creation_And_Registration/registration.cpp:
          Added little methods to wrap around Quantify vs. Visual Quantify
          calls.

Wed May 26 20:44:30 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Pluggable.h:
        * tao/IIOP_Connector.h:
        * tao/IIOP_Connector.cpp:
        * tao/UIOP_Connector.h:
        * tao/UIOP_Connector.cpp:
          Declaring a method with return type "const char" is superfluous,
          "char" is enough. Some compilers don't like that.

Wed May 26 20:21:18 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Pluggable.cpp:
          A variable declared in a loop (like for(int i;;)), was declared
          again in another loop, this is not a problem in ANSI C++, but
          some compilers don't know this yet.

        * tao/TAO.dsp:
        * tao/TAO_Static.dsp:
          Added the new files (from the branch) into the project files.

Wed May 26 18:51:39 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/*:
          Merged the pluggable_testing branch. From the tag
          <pluggable_testing> to <pluggable_testing_merge1>
          The main trunk was tagged before
          (pluggable_testing_pre_merge1) and after the merge
          (pluggable_testing_pos_merge1).

          Now for the interesting stuff: this branch adds support for:

        * Multiple endpoints in the ORB, a list of TAO_Acceptors is kept
          in the acceptor registry, when the ORB needs to create an IOR it
          iterates over all the acceptors to do so.  Using either multiple
          -ORBendpoint options or several endpoints separated by ';' the
          user can specify what addresses the ORB should use.  Each
          endpoint is specified in URL format
            (ex: iiop://foo.bar.com:0), this format can be extended to
          support different protocols.

        * If the user does not specify a list of endpoints then the ORB
          creates a default endpoint for each protocol configured.

        * Support for multiple Connectors in the ORB, the ORB finds the
          correct connector based on the tag for the profile.

        * Support for multiple profiles in the IORs, when the ORB
          demarshals an IOR it queries the Connector Registry to create
          the right kind of profile for the known protocols.  If one of
          the protocols is unknown we create a special profile class
          that can only be used for marshaling and demarshaling, not
          communication.

        * Protocol can be dynamically loaded into the ORB: the default
          resource factory reads the protocol "names" from its list of
          arguments.  These protocol names are used to load an abstract
          factory via the service configurator, this factory can create
          acceptors or connectors on demand.
          By default only IIOP and UIOP are loaded.

        * Added a correct implementation of CORBA::ORB_init(), if the
          same ORBid is passed (either in the orbid argument or via an
          -ORBid option) the same ORB is returned.  WARNING: this changes
          the current behavior in TAO, which returns a different ORB on
          each thread!

        * The -ORBhost and -ORBport options are deprecated, the new
          -ORBendpoint option supercedes them, the ORB issues a warning if
          they are used.

        * The -ORBpreconnect option supports multiple protocols using the
          same URL formats that -ORBendpoint does. Notice that the old
          host:port format is supported for backwards compatibility.

        * Enabled the UIOP protocol, this protocol uses local IPC (aka
          UNIX domain) sockets as the transport mechanism.  The protocol
          is loaded by default but no endpoints are created unless an
          explicit -ORBendpoint option is used.

        * Most of these changes where implemented by Fred Kuhns and Ossama
          Othman. I am simply the humble CVS merger

        * orbsvcs/ImplRepo_Service/ImplRepo_i.cpp:
        * orbsvcs/Time_Service/IR_Helper.h:
        * orbsvcs/Time_Service/IR_Helper.cpp:
        * orbsvcs/tests/ImplRepo/IR_Helper.cpp:
          Adapted to work with the pluggable protocols framework, but
          needs a major redesign to be fully integrated.

        * */Makefile:
          Updated dependencies

Wed May 26 17:37:40 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        * tao/ORB.cpp : Used delete [] in resolve_initial_references ()
          instead of delete. Changed the signatures of add/find IORs in
          the IOR table to use consts.
        * tao/ORB.h : Changed the function declarations for the above.
        * tao/IOR_LookupTable.cpp : Removed the private members ObjectID
          and IOR table. Added comments for the class description. Used
          consts in the function declarations wherever appropriate.
        * tao/IOR_LookupTable.h : Changed the function declarations for
          the above.

Wed May 26 15:50:00 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/POAManager:

          Fixed hold_requests_i(), discard_requests_i(), and
          deactivate_i() such that there is a check for a valid
          <wait_for_completion> flag and the <wait_for_completion> flag is
          processed correctly on all the POAs that the POA Manager is
          managing.

        * tao/POA:

          Renamed <destroy_pending_> to <wait_for_completion_pending_>
          since waiting doesn't only happen on destruction.

          find_POA_i(): Check the state of the POA Manager before
          dispatching a POA creation request to the adapter activator.

          check_for_valid_wait_for_completions(): The thread that calls a
          POA/ORB function with <wait_for_completion> set to true must not
          be a dispatch thread itself.  If it is, this would lead to a
          deadlock situation.  In this case, the ORB must raise a
          CORBA::BAD_INV_ORDER() exception.

          wait_for_completions(): Waits for outstanding requests on this
          POA to complete.

          cleanup_servant(): We need to let go of the Object Adapter / POA
          lock before calling etherealize() on the servant activator.

          cleanup_servant(): Teardown of the servant lock must happen
          before the _remove_ref() or etherealize() calls since they might
          end up deleting the servant.

        * tao/Object_Adapter:

          deactivate(): The Object Adapter now keeps a list of all active
          POA Managers.  This is useful in ORB::shutdown() where we need
          to deactivate all the POA Managers.

          dispatch_servant_i(): Check the state of the POA Manager before
          dispatching the client request to the target POA.  Only if the
          POA Manager state is active is the request dispatched to the
          servant.

          dispatch_servant_i(): The single threaded POA lock must be
          acquired *after* the POA lock has been released.  This is
          necessary since we cannot block waiting for the servant lock
          while holding the POA lock. Otherwise, the thread that wants to
          release this lock will not be able to do so since it can't
          acquire the POA lock.

        * tao/ORB.cpp (shutdown): Fixed this function such that it
          properly deactivates all the POA Managers.

        * tao/Messaging_Policy_i.h: Fixed inherits via dominance warnings.

        * performance-tests/POA/Object_Creation_And_Registration/registration.cpp:
          This test was out of date and needed some maintenance.  Also,
          made the reverse map effectiveness checking optional, and added
          exception checking code.

Wed May 26 14:56:03 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * examples/OBV/Typed_Events/Event_Types_impl.h: Disabled VC
          warning 4250.  Also added macros to prevent circular inclusion.

        * examples/OBV/Typed_Events/Event_Types.dsw:
        * examples/OBV/Typed_Events/client.dsp:
        * examples/OBV/Typed_Events/server.dsp: New workspace/projects.

        * orbsvcs/orbsvcs/orbsvcs.dsp:
        * orbsvcs/orbsvcs/orbsvcs_static.dsp: Fixed build options for
          newly added template files.

Wed May 26 14:05:18 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/IOR_Multicast.cpp:
          Added missing include file.

Wed May 26 13:56:56 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/Messaging_Policy_i.h: Disabled VC warning 4250 for class
          TAO_RelativeRoundtrigTimeoutPolicy_i.

Wed May 26 11:54:39 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_union_branch/cdr_op_cs.cpp:
          Fixed extractor for pseudo objects (at least for
          the two cases TypeCode and Object. A case for
          ValueBase is still TODO).

Wed May 26 10:28:21 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_sequence/cdr_op_cs.cpp:
          Fixed extractor for bounded strings. Existing
          code assumed that CORBA::Any::to_string::bound_
          includes the terminating '\0', which it does not.
          Thanks to Keith Nichol <knichol@syscorp.com.au>
          for pointing this out.

Wed May 26 08:41:32 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/CosEvent_Utilities.cpp:
          Added several explicit .in() calls to convert from T_var into
          T_ptr, old g++ cannot handle the implicit conversion. Thanks to
          David Levine for bringing this up.

Tue May 25 17:00:08 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * examples/Callback_Quoter/Supplier_i.cpp (via_naming_service):
        * examples/Callback_Quoter/Consumer_Handler.cpp
        * examples/Callback_Quoter/Consumer_Input_Handler.cpp
        * examples/Callback_Quoter/Consumer_Signal_Handler.cpp
        * examples/Callback_Quoter/Notifier_Input_Handler.cpp
        * examples/Callback_Quoter/Notifier_i.cpp
        * examples/Callback_Quoter/Supplier_i.cpp
        * examples/Callback_Quoter/notifier.cpp : Removed some
        ACE_TRY_NEW_ENV's and cleaned up the way exception handling is
        being done.

Tue May 25 16:24:23 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/ORB_Core.cpp (set_endpoint): Seveal "reason" strings for
          "%p" directive were missing.  Thanks to Christopher Kohlhoff
          <chris@kohlhoff.com> for pointing this out.

Tue May 25 12:54:23 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Messaging_Policy_i.h:
          Fixed syntax error only IRIX catched this one.

        * tao/ORB.h:
          The throw specs need complete types in IRIX/MIPSPro, added
          include for PolicyC.h

        * tao/ORB.cpp:
          Fixed problems in resolve_initial_references.

Tue May 25 12:39:27 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/Environment.cpp,Exception.{h,cpp},Invocation.cpp,corbafwd.h:
          added support for passing location and errno through minor status
          of CORBA_SystemExceptions.

        * docs/releasenotes/orbcore.html: added mention of support
          for CORBA_SystemException minor status.

Tue May 25 12:17:00 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/Event/Performance/Connect.dsp:
        * orbsvcs/tests/Event/Performance/Throughput.dsp:
        * orbsvcs/tests/Event/lib/ECTest.dsp:
          Fixed configuration for Win32/Release

        * tao/TAO.dsp:
        * tao/TAO_Static.dsp:
          Added new files to the TAO project

Tue May 25 12:07:25 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Makefile:
          TAO_HAS_CORBA_MESSAGING is defined in the orbconf.h the user
          must comment out that definition to eliminate the CORBA
          messaging support.

        * tao/Invocation.cpp:
          Added some debugging code (currently commented out) to test the
          timeout policies.
          If the send() call fails we should return an TAO_INVOKE_RESTART,
          this needs more debugging, but the code there was broken
          anyway.

        * tao/Messaging_Policy_i.cpp:
        * tao/Messaging_Policy_i.h:
        * tao/Messaging_Policy_i.i:
          Added new file for the Messaging policy implementations.

        * tao/MessagingS.h:
          Removed declaration of skeletons, the skeletons where in fact
          removed, but somehow I missed the files.

        * tao/orbconf.h:
        * tao/MessagingC.cpp:
          Initialize the Policy_Type constants using macros in orbconf.h
          that way we can use the same macros to switch() in the code.

        * tao/ORB.h:
        * tao/ORB.cpp:
          Added the create_policy() method, it delegates on the right
          class to actually create the policy.
          In resolve_initial_references() the hard-coded object ids (such
          as "RootPOA") are searched before anything else.

        * tao/Stub.h:
        * tao/Stub.cpp:
        * tao/ORB_Core.h:
        * tao/ORB_Core.i:
          Added new method to query the default timeout policy in an
          efficient way.

        * tao/Policy_Manager.h:
        * tao/Policy_Manager.i:
        * tao/Policy_Manager.cpp:
          We keep a pointer to the RelativeRoundtripTimeoutPolicy
          *implementation* that way the ORB can speed up its lookups,
          minimize memory allocations and in general work in a more
          deterministic way.

        * tao/corbafwd.h:
          Added missing forward declaration for PolicyManager_var,
          PolicyCurrent_var and their _out classes.

Tue May 25 11:50:01 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/ORB.cpp (ORB_init): Removed out-dated comments.  Thanks to
          Irfan for pointing this out.

Tue May 25 11:40:29 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO/orbsvcs/orbsvcs/AV/sfp.cpp:
          Initialized 'result' in end_stream()to avoid a compiler
          warning.

Tue May 25 11:21:00 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/fe/idl.yy:
        * TAO_IDL/fe/y.tab.{h,cpp}:
          Added a couple of ACE_UNUSED_ARG macros to the
          yacc file and regenerated y.tab. Thanks to David
          Levine for pointing out the egcs warnings.

Tue May 25 11:03:17 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Gateway_UDP.cpp:
          Fixed errors in fragment size computation, thanks to J. Russell
          Noseworthy <rnosewor@objectsciences.com> for catching this up
          and providing a fix.

        * orbsvcs/orbsvcs/Event/EC_ObserverStrategy.cpp:
          Fixed several uses of T_var in calls to _duplicate(), old g++
          needs you to call the .in() method explicitly. Thanks to Irfan
          for catching this one.

Tue May 25 10:06:41 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Request.cpp: Moved the #endif for TAO_HAS_MINIMUM_CORBA
          after the template instantiations.  Thanks to Andreas
          <andreas.terstegge@nokia.com> for pointing this out.

Tue May 25 10:23:52 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_union.cpp:
          Fixed a signed/unsigned mismatch and an unused
          variable warning.

        * TAO_IDL/be/be_visitor_typecode/typecode_defn.cpp:
          Fixed some 'statement not reached' warnings.

Tue May 25 08:23:03 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/try_macros.h (TAO_THROW_ENV,TAO_THROW_ENV_RETURN):
          with native exceptions, added ACE_UNUSED_ARG (ENV).

        * examples/Quoter/Quoter_i.cpp (copy): wrapped final
          return statement with ACE_NOTREACHED, to please
          DU cxx 6.2-021.

        * orbsvcs/tests/Simple_Naming/client.cpp (init):
          commented out retun in catchany clause, to avoid
          warning about redundant return at end of function
          from DU cxx.

Tue May 25 01:42:03 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/Exception.h (TAO_Exceptions): Added an static ACE_Allocator
          pointer <global_allocator_> which is used when building the
          global system exception typecode.

        * tao/Exception.cpp (init,fini): Added creation and deletion of
          <global_allocator_>.
          (make_unknown_user_typecode,make_standard_typecode): Changed to
          use the TAO_Exceptions::global_allocator_ for OutputCDR's.  They
          are default to acquire allocators from the ORB.  But we have to
          move the typecode creation before the ORB_init call so we can
          throw exceptions in case ORB_init itself failed.

        * tao/ORB.cpp (ORB_init): Moved init_orb_globals method before
          oc->init because init_orb_globals no longer accesses the orb.
          This allows up to throw an exception if ORB_init failed.  TAO
          players, notice that you should not access any orb specific
          information from within init_orb_globals method because the ORB
          was not initialized when the orb globals get constructed.

Mon May 24 22:15:05 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corbafwd.h:
          Added a 'CORBA_' to one of the TypeCode typedefs so it
          cosmetically matches the other groups of typedefs.

Mon May 24 17:56:22 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_union_branch/cdr_op_cs.cpp:
          Removed '.in ()' and '.out ()' from pseudo-object
          implementations of << and >> respectively. Pseudo-
          objects are declared in unions as _ptr, not as _var.

Mon May 24 16:28:20 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Policy_Manager.cpp (implementation): Moved a couple of
          functions from the .i file to the .cpp file so that it compiles
          when inlining is turned on.

Mon May 24 16:43:17 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO/tests/Dynany_Test/test_dynarray.cpp:
        * TAO/tests/Dynany_Test/test_dynsequence.cpp:
        * TAO/tests/Dynany_Test/test_dynstruct.cpp:
          Fixed some scoping errors due to my moving AnySeq,
          FieldName and NameValuePairSeq to the CORBA
          namespace. Thanks to Irfan for reporting this
          problem.

        * TAO/tests/DynAny_Test/da_tests.idl:
          Commented out a typecode-inside-union case until
          it can be fixed in the IDL compiler.

Mon May 24 16:20:39 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO/tests/Param_Test/recursive_struct.h:
        * TAO/tests/Param_Test/recursive_struct.cpp:
        * TAO/tests/Param_Test/param_test.idl:
        * TAO/tests/Param_Test/param_test_i.h:
        * TAO/tests/Param_Test/param_test_i.cpp:
        * TAO/tests/Param_Test/driver.cpp:
        * TAO/tests/Param_Test/options.h:
        * TAO/tests/Param_Test/options.cpp:
        * TAO/tests/Param_Test/tests.h:
        * TAO/tests/Param_Test/client.dsp:
        * TAO/tests/Param_Test/run_test.pl:
        * TAO/tests/Param_Test/Makefile:
          Added new test to Param_Test to test a struct that
          contains a sequence of itself, for example:
            struct foo {
              long x;
              sequence<foo> offspring;
            };
          Also made the IDL compiler use interpreted marshaling
          until a further mod to the IDl compiler is made
          (according to Andy, his changes work now only for
          interpreted marshaling).

Mon May 24 16:03:20 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests: Modified/fixed the following NT makefiles:

          - TAO_Tests.dsw
          - DynAny_Test/DynAny_Test.dsw
          - DynAny_Test/basic_test.dsp
          - InterOp-Naming/InterOp_test.dsp
          - MT_Client/client.dsp
          - MT_Client/orb_creation.dsp
          - MT_Client/server.dsp
          - NestedUpcall/MT_Client_Test/client.dsp
          - NestedUpcall/MT_Client_Test/server.dsp
          - NestedUpcall/Reactor/client.dsp
          - NestedUpcall/Reactor/server.dsp
          - NestedUpcall/Triangle_Test/initiator.dsp
          - NestedUpcall/Triangle_Test/server_A.dsp
          - NestedUpcall/Triangle_Test/server_B.dsp

Mon May 24 15:58:14 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/CDR_Interpreter.cpp:
          Committed a fix to calc_seq_attributes() sent to me
          by Andy Gokhale <gokhale@research.bell-labs.com>,
          which corrected a problem with recursive structs.
          Thanks, Andy!

Mon May 24 15:35:57 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_union.cpp:
          Fixed a couple of MSVC warnings - a signed/unsigned
          mismatch and a 32-bit overflow caused by adding 1 to
          ACE_UINT32_MAX.

Mon May 24 15:13:14 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Policy_Current: Made changes to this class such that the
          Policy_Current class is no longer TSS.  This object belongs to
          the ORB, but its implementation (TAO_Policy_Current_Impl) is in
          TSS.  These changes are similar to the ones made to the POA
          Current classes.  The following files were changed:

          - ORB.cpp
          - ORB_Core.cpp
          - ORB_Core.h
          - Policy_Manager.cpp
          - Policy_Manager.h
          - Policy_Manager.i
          - Stub.cpp

Mon May 24 13:15:16 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/corbafwd.h:
          Use the OMG assigned number of the default minor code.

Mon May 24 12:47:45 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_union/union_ci.cpp:
          There was a missing ';' in the generated code.

Mon May 24 07:59:45 EDT 1999  Aniruddha Gokhale  <gokhale@sahyadri.research.bell-labs.com>

        * TAO_IDL/ast/ast_generator.cpp (create_union_branch):
          TAO_IDL/ast/ast_union_branch.cpp (constructor):
          TAO_IDL/be/be_generator.cpp (create_union_branch):
          TAO_IDL/be_include/be_generator.h (create_union_branch):
          TAO_IDL/be_include/be_union_branch.h (constructor):
          TAO_IDL/fe/{idl.yy, y.tab.cpp, y.tab.h}:
          TAO_IDL/include/ast_geneator.h (create_union_branch):
          TAO_IDL/include/ast_union_branch.h (constructor):

          Constructor of the union_branch node has been slightly modified
          so that now it can take a list of labels as its parameter
          instead of a single Union_Label node. This was required because
          a single union branch can be shared by several case labels as
          shown in the example below:

          union U switch (long)
          {
             case 0:
               char c;
             case 1:
             case 2:
             default:
               octet o;
          };

          We were also required to make modifications to the "actions" in
          the fe/idl.yy file for the union branch rule because previously
          it would not allow us to have a union branch node to have
          several case labels. We now create a UTL_Label_List out of all
          such shared case/default labels and then pass this list as a
          parameter to the constructor of the UnionBranch node. This
          required us to the change the create_union_branch operation
          signature in the generator classes. The fe/y.tab.{h, cpp} have
          been regenerated.

        * TAO_IDL/be/be_union.cpp:
          TAO_IDL/be_include/be_union.h:

          Added the compute_default_value and default_value methods. These
          methods will compute/return the value that must be used for the
          "default" label. There are two scenarios whenever such a value
          is required. Wheneveran explicit "default" label exists in a
          union definition, the Typecode for the default label must
          provide a value for the default case. This default value must be
          something other than that used by all other case labels and
          which is a permissible value as defined by the "type" of the
          discriminant. For example, if the discriminant type is an
          unsigned long, then the permissible value for default label is
          anything from 0 to MAX_ULONG except those already used up by the
          case labels. The second scenario where we need this default
          value is when no explicit default clause is provided in the
          union definition AND the case labels do not cover all the
          permissible values supported by the discriminant type. In such a
          scenario, the CORBA IDL->C++ mapping requires us to generate a
          method called "default ()".

          The compute_default_value () method provides the algorithm that
          takes care of computing the default value (if at all it is
          required) as demanded by the two scenarios described above. The
          "default_value" method simply returns the computed value.

        * TAO_IDL/be/be_visitor_typecode/typecode_defn.cpp:

          In the gen_encapsulation and compute_encap_len for union_branch,
          we must now account for the shared case labels as well as the
          default label that we now support. In particular, the
          modifications were necessary because union branches now contain
          a list of UnionLabels and special treatment is necessary for
          default labels. If we want optimized typecodes, we can now
          generate indirections for union branches that have several
          shared case labels. Thus, the first one will be fully specified
          and the rest will be indirections. No specific change was
          required for this part to work.

          Another cosmetic change was for "tk_objref", there was an
          indentation missing.

        * TAO_IDL/be/be_visitor_union/cdr_op_cs.cpp:
          TAO_IDL/be/be_visitor_union/union_ch.cpp:
          TAO_IDL/be/be_visitor_union/union_ci.cpp:
          TAO_IDL/be/be_visitor_union_branch/public_assign_cs.cpp:
          TAO_IDL/be/be_visitor_union_branch/public_reset_cs.cpp:
          TAO_IDL/be/be_visitor_union_branch/public_access_cs.cpp:

          Provided support to handle shared case labels and default
          label. We now generate the "default ()" method whenever it is
          required as described in the scenario above.

        * TAO_IDL/be/be_visitor_union_branch/cdr_op_cs.cpp:

          Thanks to (name unknown) gwtovrea@west.raytheon.com for pointing
          out incorrectly generated code for enums in the CDR >>
          operator.  Rather than generating the actual type for the enum,
          we were generating CORBA::Long. This is now fixed.

Sun May 23 18:06:37 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/Event/Basic/Observer.h:
        * orbsvcs/tests/Event/Basic/Observer.cpp:
          Fixed memory leak in the test

        * orbsvcs/orbsvcs/Event/EC_Gateway.cpp:
          Initialize fields to avoid UMR problems in purify.

Sun May 23 16:37:03 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/Event/lib/Driver.cpp:
          On IRIX the threads were not activated because the priority was
          too high.

Sun May 23 16:06:05 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Makefile:
        * orbsvcs/orbsvcs/Event/EC_Defaults.h:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.i:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
        * orbsvcs/orbsvcs/Event/EC_ProxyPushSupplier_Set.cpp:
          Added a new header file where the default configuration of the
          EC is defined.  The current values provide an MT-safe
          configuration, which allows delayed operations to wait for a
          long time.  This works best in most cases, but hard real-time
          applications may wish to fine tune the algorithm to avoid
          starvations of delayed changes.

        * orbsvcs/tests/Event/Basic/run_test.pl:
        * orbsvcs/tests/Event/Performance/ec.st.conf:
        * orbsvcs/tests/Event/Performance/run_test.pl:
          The configuration file now sets the configuration for a single
          threaded event channel, without any locks. The default settings
          are MT-safe so there is no need to use a file anymore.

        * orbsvcs/tests/Event/lib/Driver.cpp:
          Some fields where unitiliazed, fixed.

Sun May 23 10:06:36 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/Event/lib/README:
        * orbsvcs/tests/Event/Basic/README:
        * orbsvcs/tests/Event/Basic/run_test.pl:
        * orbsvcs/tests/Event/Performance/README:
        * orbsvcs/tests/Event/Performance/run_test.pl: Added some README
          files explaining the purpose of each test and how to run
          it. Also added some simple run_test scripts to execute the
          tests.

Sat May 22 22:16:57 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp: The busy_hwm
          should be set in the attributes now.

Sat May 22 18:43:00 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs.dsw:
        * orbsvcs/CosEvent_Service/CosEvent_Service.dsp:
        * orbsvcs/CosEvent_Service/CosEvent_Service.dsw:
        * orbsvcs/examples/CosEC/Factory/Makefile:
        * orbsvcs/examples/CosEC/Factory/Factory.dsw:
        * orbsvcs/examples/CosEC/Factory/FactoryClient.dsp:
        * orbsvcs/examples/CosEC/Factory/FactoryServer.dsp:
        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory.idl:
        * orbsvcs/orbsvcs/orbsvcs.dsp:
        * orbsvcs/orbsvcs/orbsvcs_static.dsp:
        * orbsvcs/tests/Event/Event.dsw:
        * orbsvcs/tests/Event/Basic/Basic.dsw:
        * orbsvcs/tests/Event/Basic/Observer.dsp:
        * orbsvcs/tests/Event/Basic/Reconnect.dsp:
        * orbsvcs/tests/Event/Basic/Schedule.dsp:
        * orbsvcs/tests/Event/Basic/Shutdown.dsp:
        * orbsvcs/tests/Event/Performance/Connect.dsp:
        * orbsvcs/tests/Event/Performance/ECPerformance.dsw:
        * orbsvcs/tests/Event/Performance/Throughput.dsp:
        * orbsvcs/tests/Event/lib/ECTest.dsp: Added project files for
          several new tests and examples.

Sat May 22 17:50:12 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_ConsumerAdmin.h:
        * orbsvcs/orbsvcs/Event/EC_ConsumerAdmin.i:
        * orbsvcs/orbsvcs/Event/EC_ConsumerAdmin.cpp:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp:
        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.cpp: The EC
          attributes include parameters that control the level of
          concurrency in the proxy supplier sets.

        * orbsvcs/orbsvcs/Event/EC_SupplierFiltering.h:
        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.cpp:
        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.cpp: Added
          reference counting: several threads could be pushing on one
          consumer proxy and another thread decides to disconnect from it.
          The corresponging supplier set must be deleted only once all the
          threads finish using it.  In many cases the implementation is
          trivial because there is a clear owner (ex: the ConsumerAdmin),
          and in others the locking is shared with the consumer proxy
          (Per_Supplier).

        * orbsvcs/orbsvcs/Event/EC_Gateway.h:
        * orbsvcs/orbsvcs/Event/EC_Gateway.cpp: The gateway was not
          properly synchronized. The locking in the push() method is
          interesting: we don't hold the lock during the complete
          dispatch, instead we keep track of the number of threads pushing
          to the gateway.  If we receive an update_consumer() call during
          a push we post the change until all the push() call finish. Only
          the last update_consumer() is kept because they overwrite each
          other.

        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.h:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.i:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.cpp: We needed an
          unprotected accessor to the publications, to avoid dead-locks
          during connect_push_consumer call.  Use the new reference
          counting on the EC_SupplierFiltering class.

        * orbsvcs/orbsvcs/Event/EC_ObserverStrategy.cpp: We were holding
          locks during upcalls to the gateways and not setting the QoS
          parameters correctly.  The update_consumer/update_supplier
          messages were backwards.

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp: Fixed several race
          conditions related to connect/disconnect calls during pushes.

        * orbsvcs/orbsvcs/Event/EC_ProxyPushSupplier_Set_T.cpp: Removed
          debug messages.

        * orbsvcs/tests/Event/Basic/Observer.h:
        * orbsvcs/tests/Event/Basic/Observer.cpp:
        * orbsvcs/tests/Event/Basic/svc.conf: Fixed minor problems with
          the test itself.

Sat May 22 17:10:11 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * TAO version 0.3.23 released.

Sat May 22 14:07:57 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/AVStreams_i.{h,cpp}
          (TAO_Forward_FlowSpec_Entry): Prefixed the enumerations with
          TAO_AV to avoid name clash. Thanks to David Levine for reporting
          this error.

Fri May 21 22:09:09 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao: Modified the following files to make minimum CORBA work
          again.

          - Connect.cpp
          - DomainC.cpp
          - DomainS.cpp
          - ORB_Core.cpp
          - POA.cpp
          - POAC.h
          - POAManager.h
          - POAManager.i
          - POAS.cpp
          - PolicyS.cpp
          - Request.cpp
          - WrongTransactionC.cpp
          - WrongTransactionC.h
          - corbafwd.h
          - orbconf.h

        * examples/Simple/Simple_util.cpp (test_for_ins): Removed
          unnecessary bank dependencies that Vishal had added to this
          generic code.

        * tao/Connect.cpp (svc):
        * tao/ORB_Core.cpp (inherit_from_parent_thread):

          Redid (with the help of Carlos) these methods in view of the new
          architecture.  ORB_Core is no longer TSS, only
          TAO_ORB_Core_TSS_Resources is.  This will fix a bug in all
          applications using the new architecture, TSS resources and
          thread per connection (like the ImplRepo).

        * tao/Connect.cpp (handle_message): Changed the length of the INS
          lookup string from <TAO_POA::TAO_OBJECTKEY_PREFIX_SIZE> to
          <request.object_key ().length ()>.  Since Vishal always tested
          with the "bank" string, he got lucky with this since
          <TAO_POA::TAO_OBJECTKEY_PREFIX_SIZE> is 4 and strlen ("bank") is
          also 4.

          Thanks to Vyacheslav A. Batenin <slavikb@iname.com> for
          reporting this.

Fri May 21 16:19:08 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO/tests/Param_Test/param_test.idl:
        * TAO/tests/Param_Test/complex_any.h:
        * TAO/tests/Param_Test/complex_any.cpp:
        * TAO/tests/Param_Test/options.h:
        * TAO/tests/Param_Test/options.cpp:
        * TAO/tests/Param_Test/driver.cpp:
        * TAO/tests/Param_Test/param_test_i.h:
        * TAO/tests/Param_Test/param_test_i.cpp:
        * TAO/tests/Param_Test/tests.h:
        * TAO/tests/Param_Test/client.dsp:
        * TAO/tests/Param_Test/Makefile:
          Added new test. The data type is a complex Any, suggested
          by a real-world use case submitted by
          Frank Buschmann <Frank.Buschmann@mchp.siemens.de>. See
          comment in complex_any.cpp above reset_parameters for
          the Any structure.

        * TAO/tests/Param_Test/any.cpp:
          Fixed some indentation and removed a memory leak related
          to gen_string.

Fri May 21 12:27:16 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/AVStreams_i.{h,cpp}:
        * orbsvcs/orbsvcs/AV/sfp.cpp:
          Fixed g++ template errors and warnings. Thanks to David and Andy
          for reporting these errors.

Fri May 21 09:20:10 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/GIOP.cpp:
          Changed character literals in the GIOP magic number to numeric
          constants, otherwise it does not work in EBCDIC (or machines
          that are not ASCII for that matter).  Thanks to Jim Rogers
          <jrogers@viasoft.com> for pointing out this problem.

        * orbsvcs/tests/Property/Makefile:
          Updated dependencies

Fri May 21 09:31:32 EDT 1999  Aniruddha Gokhale  <gokhale@sahyadri.research.bell-labs.com>

        * orbsvcs/orbsvcs/Makefile: ran "make depend".

Thu May 20 23:09:32 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/examples/CosEC/Factory/FactoryClient.cpp:
        * orbsvcs/CosEvent_Service/CosEvent_Service.cpp:
          Added error checks in the <create_factory> and
          <locate_naming_service> methods.

Thu May 20 21:49:42 1999  David L. Levine  <levine@cs.wustl.edu>

        * all run_test*pl scripts: moved comment line(s) from head
          of file so that it is not interpreted as a csh file.  Thanks
          to Gregory W Ross <gwross@notes.west.raytheon.com> for
          reporting problems with the comment lines.

Thu May 20 21:28:25 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/AVStreams_i.{h,cpp}:
          Fixed a few MSVC warnings and prefixed the Direction enumeration
          to DIR_ since IN,OUT and INOUT are MSVC keywords.

Thu May 20 21:09:29 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/DomainC.cpp:
          Added #include "tao/POA_CORBA.h" so we can compile on
          IBM OpenEdition. Thanks to Jim Rogers <jrogers@viasoft.com>
          for pointing this out.

Thu May 20 20:29:16 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/ORB.i (orb_core): Added accessor.

        * tao/POA.cpp (implementation): Removed extra semi-colon.

        * orbsvcs/ImplRepo_Service/ImplRepo_i.cpp (invoke): Needed fixing
          since the POA Current changed.

Thu May 20 20:34:35 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/Makefile:
          Added sfp to Makefile and updated dependencies.

Thu May 20 20:00:08 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/decode.cpp:
          Added a typecode release call to TAO_Marshal_Any::decode()
          to plug a memory leak occurring with inout Any parameters.

Thu May 20 19:52:49 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/AVStreams_i.{h,cpp}:
          Changed TAO_StreamEndPoint from a template to non-template and
          added MSVC dominance warning disabling pragma and moved it from
          AVStreams_i_T.{h,cpp} to these files. Also Added a flowspec
          class to parse the flowSpec string into different components.

        * orbsvcs/orbsvcs/AV/AVStreams_i_T.{h,cpp}:
          Removed the AVStreams_i_T.{h,cpp} as they're no longer needed.

        * orbsvcs/orbsvcs/Property/CosPropertyService_i.{h,cpp}:
          Changed TAO_PropertySet from a template to non-template and
          added MSVC dominance warning disabling pragma and moved it from
          CosPropertyService_i_T.{h,cpp} to these files.

        * orbsvcs/orbsvcs/Property/CosPropertyService_i_T.{h,cpp}:
          Removed these files as they're no longer needed.

          The above fixes solves the template errors/warnings in orbsvcs seen on
          HP-UX,SunOS 5.6 and Digital Unix.
          Thanks to John R. Taylor
          <jrtaylor@george.lbl.gov>,gwtovrea@west.raytheon.com,
          Andy Gokhale<gokhale@cs.wustl.edu> and David
          Levine<levine@cs.wustl.edu> for reporting these errors.

        * orbsvcs/orbsvcs/Makefile:
          Updated dependencies.

Thu May 20 18:46:44 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/examples/CosEC/Factory/Makefile:
          updated dependencies.

        * orbsvcs/orbsvcs/CosEC_Utility_Methods_T.{h,cpp}:
          Removed this file. templates seem to be an overkill here.

        * orbsvcs/orbsvcs/CosEvent_Utilities.h:
          added TAO_ORBSVCS_Export.
          added a #pragma for msvc warning 4250

        * orbsvcs/orbsvcs/Makefile:
          removed CosEC_Utility_Methods_T

        * orbsvcs/orbsvcs/CosEvent_Utilities.cpp:
        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp
        * orbsvcs/CosEvent_Service/CosEvent_Service.cpp:
          removed CosEC_Utility_Methods usage.

        * orbsvcs/CosEvent_Service/CosEvent_Service.h
          added a <locate_rtec> method.

        * orbsvcs/CosEvent_Service/README
          modified the README to reflect the change in parameter options.

Thu May 20 17:39:50 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * TAO/tao/TAO.dsp:
        * TAO/TAO_IDL/tao_idl.dsp:
        * orbsvcs/orbsvcs/orbsvcs.dsp: Fixed Alpha configurations.  Thanks
          to Christian Schuderer <Christian.Schuderer@erl9.siemens.de> for
          reporting this.

        * TAO/TAO_IDL/tao_idl_static.dsp: Removed definitions of
          IDL_CFE_VERSION.

Thu May 20 17:11:02 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Typecode_Constants.cpp:
          Added _tc_Pollable, _tc_DIIPollable, and
          _tc_PollableSet to fini().

Thu May 20 15:22:49 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/default_resource.cpp (get_reactor): The problem was that
          when the reactor implementation was given to the reactor
          interface class, it was not instructed to delete the
          implementation.  Once this was fixed, the change below by Carlos
          was not necessary.

        * tao/POA_Current: Changed the POA Current from a TSS specific
          object to a global object owned by the ORB.  Its state, however,
          is still managed by a TSS object (this new object is called
          TAO_POA_Current_Impl).  All the POA, Object_Adapter,
          TSS_Resources, and Servant Base classes were changed to use this
          new class.

          Also, cleaned up the POA Current implementation class.  There
          were many extra methods that not used in the new scheme.

          Thanks to Jon Biggar <jon@biggar.org> for pointing out that the
          original scheme was not compliant.

        * examples/POA/DSI:

          - Changed access to POA Current.  Previously, we use to ask the
            ORB everytime.  Now we only ask once and keep it around as a
            state variable.

          - Added shutdown() method.

          - Fixed exception handling.

          - Added more debugging info to the server.

Thu May 20 15:00:37 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Pluggable.h:
        * tao/IIOP_Acceptor.h:
        * tao/IIOP_Acceptor.cpp:
        * tao/default_resource.cpp:
          Added a close() method to the TAO_Acceptor class to orderly
          cleanup the resources on shutdown.

Thu May 20 13:53:11 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/Event/Basic/Makefile:
        * orbsvcs/tests/Event/Basic/Observer.h:
        * orbsvcs/tests/Event/Basic/Observer.cpp:
        * orbsvcs/tests/Event/Basic/observer.conf:
        * orbsvcs/tests/Event/lib/Consumer.h:
        * orbsvcs/tests/Event/lib/Consumer.cpp:
        * orbsvcs/tests/Event/lib/Driver.h:
        * orbsvcs/tests/Event/lib/Driver.cpp:
          New test for the observers and dynamic
          connection/reconnections. It compiles, but needs more testing
          and I cannot do that on Linux.

        * orbsvcs/orbsvcs/Event/EC_Gateway.h:
        * orbsvcs/orbsvcs/Event/EC_Gateway.cpp:
          Minor fixes to support configurations without an scheduling
          service.

Thu May 20 12:17:36 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Any.h:
        * tao/Any.cpp:
        * tao/GIOP_Server_Request.cpp:
        * tao/NVList.cpp:
          Changed the signature of

            void _tao_replace (CORBA::TypeCode_ptr,
                     const ACE_Message_Block *mb,
                     CORBA::Boolean any_owns_data,
                     CORBA::Environment &TAO_IN_ENV =
                       CORBA::default_environment ());

          to

            void _tao_replace (CORBA::TypeCode_ptr,
                     const ACE_Message_Block *mb,
                     CORBA::Environment &TAO_IN_ENV =
                       CORBA::default_environment ());

          Also modified Any's copy contructor and assignment
          operator to set any_own_data_ to 0. In all these cases,
          the void* value_ is freed, but not set to anything.
          Also changed the calls to _tao_replace() in the last
          two files to reflect the new signature.


Thu May 20 12:14:20 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp:
          Added missing template instantiations.

Thu May 20 11:06:25 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/orbsvcs/CosEvent_Utilities.cpp:
          Fixed a bug in parsing QOS parameters - thanks to Paul Calabrese
          <calabrese_p@ociweb.com> for reporting this and providing a fix.
        * orbsvcs/orbsvcs/CosEC_Utility_Methods_T.cpp:
          removed an extra ";"

Wed May 19 18:14:41 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * orbsvcs/orbsvcs/orbsvcs_static.dsp:
        * performance-tests/Cubit/TAO/IDL_Cubit/client.dsp
        * performance-tests/Cubit/TAO/IDL_Cubit/collocation_test.dsp
        * performance-tests/Cubit/TAO/IDL_Cubit/server.dsp: Fixed Release
          configuations.

Wed May 19 16:21:11 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/default_resource.cpp:
          Fixed incorrect use of ACE_WIN32, ACE_HAS_FL and ACE_HAS_XT
          macros, thanks to Jeff Parsons for reporting this.

Wed May 19 15:54:53 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Typecode_Constants.cpp:
          Added some typecodes to fini() that I had forgotten to
          add before.

Wed May 19 15:25:00 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/corbafwd.h:
        * tao/corbafwd.i:
        * tao/ORB.h:
        * tao/ORB.i:
        * tao/ORB.cpp:
        * tao/CDR_Interpreter.cpp:
        * tao/Managed_Types.cpp:
        * tao/Managed_Types.h:
        * tao/Managed_Types.i:
        * tao/Marshal.i:
        * tao/POA.cpp:
        * tao/POA.h:
        * tao/Request.cpp:
        * tao/Typecode_Constants.cpp:
        * orbsvcs/tests/EC_Custom_Marshal/ECM_Supplier.cpp:
        * orbsvcs/tests/Logger/Logging_Test_i.cpp:
        * orbsvcs/tests/Logger/client_i.cpp:
        * orbsvcs/tests/Property/client.cpp:
        * orbsvcs/tests/Property/main.cpp:
        * performance-tests/Cubit/TAO/IDL_Cubit/svc.conf:
        * tests/Param_Test/options.cpp:
          Added support for CORBA::WString_var and CORBA::WString_out,
          also did a quick cleanup for the WString_Manager classes.
          Thanks to Lothar Werzinger <lwerzinger@krones.de> for providing
          this fixes.
          Also removed all uses of string_copy which is a non-standard TAO
          extension.

        * docs/releasenotes/TODO.html:
          More EC updates

        * orbsvcs/orbsvcs/Event/EC_ObserverStrategy.cpp:
          Added copy-on-read to avoid dead-locks during dispatch.

Wed May 19 15:12:26 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/CosEvent_Service/CosEvent_Service.cpp:
        * orbsvcs/CosEvent_Service/svc.conf:
          Use the TAO_EC_Default_Factory for the Rtec Event Channel and
          configure it using a svc.conf file.

        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp:
          Fixed more template instantiation problems.

Wed May 19 13:07:06 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/CosEvent_Utilities.cpp:
          Fixed several syntax errors, at least it compiles now.

Wed May 19 00:20:08 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/orbsvcs/CosEvent_Utilities.{h,cpp}:
        * orbsvcs/orbsvcs/CosEC_Utility_Methods_T.{h,cpp}:
          Added these files to provide utility base classes and
          useful methods for implementing CosEC applications.

        * orbsvcs/orbsvcs/Makefile:
          added CosEvent_Utilities and CosEC_Utility_Methods_T
          to the CosEvent section.

        * orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i{h,cpp}:
          Removed these files - All the functionality of this implementation
          has been moved to the <CosEC_ServantBase> class defined in
          orbsvcs/orbsvcs/CosEvent_Utilities.h

        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp
          modified to use the <CosEC_ServantBase> class.

        * orbsvcs/examples/CosEC/Factory/FactoryClient.cpp
          Added an extra debug message in the <create> method.

        * orbsvcs/examples/CosEC/Factory/Makefile
          removed FactoryCosEventChannel_i.

        * orbsvcs/CosEvent_Service/CosEvent_Service.{h,cpp}:
          All redone now to use the <CosEC_ServantBase> class.

Tue May 18 22:19:36 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Resource_Factory.h:
        * tao/Resource_Factory.cpp:
        * tao/default_resource.h:
        * tao/default_resource.i:
        * tao/default_resource.cpp:
        * docs/Options.html:
          The default resource factory can select any of the "exotic" ACE
          reactors (XtReactor, FlReactor, WFMO_Reactor, Msg_WFMO_Reactor)
          as well as the regular Select reactor (with or without locking).
          The old option (-ORBreactorlock) is obsolete and should be
          removed after a couple of beta kits.

        * tests/Makefile:
        * tests/FL_Cube/Makefile:
        * tests/FL_Cube/client.cpp:
        * tests/FL_Cube/server.cpp:
        * tests/FL_Cube/svc.conf:
        * tests/FL_Cube/test.idl:
        * tests/FL_Cube/test_i.cpp:
        * tests/FL_Cube/test_i.h:
        * tests/FL_Cube/test_i.i:
          A small example that illustrates how TAO can work with the
          FlReactor.  A simple server displays a cube using the FL toolkit
          for the GUI elements and OpenGL for the graphics, its CORBA
          interface lets the client control the viewpoint for the cube.
          A simple client uses GUI elements to let the user control the
          remote cube displayer.

Tue May 18 11:05:23 1999  David L. Levine  <levine@cs.wustl.edu>

        * TAO_IDL/Makefile: removed DU cxx and Green Hills gcx warning
          suppressions because they're no longer necessary (at least with
          cxx 6.2-020).

Mon May 17 19:41:04 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corbafwd.h:
        * tao/POA_CORBA.h:
        * tao/Typecode_Constants.cpp:
        * tao/DynAnyC.{h,i,cpp}:
        * tao/dynAnyS.cpp:
        * tao/DynArray_i.{h,cpp}:
        * tao/DynSequence_i.{h,cpp}:
        * tao/DynStruct_i.{h,cpp}: Moved AnySeq, FieldName, NameValuePair,
          and NameValuePairSeq to the CORBA namespace. They had previously
          been in the global namespace.  Generated new typecodes for
          these, to reflect the new scoping, and moved the typecodes to
          Typecode_Constants.cpp. Thanks to Serge Du <du@lal.in2p3.fr> for
          pointing out a namespace clash with AnySeq in his application
          that led to all this.

Mon May 17 18:17:42 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * tao/UIOP_Transport.cpp,
          tao/IIOP_Transport.cpp: Removed ACE_DEFAULT_WRITEV_MAX and
          replaced it with IOV_MAX.

Mon May 17 15:25:40 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/tests/Event_Latency/run_tests.sh: replaced
          hard-coded user name with $login, which is derived using
          the same logic as in orbsvcs/tests/start_services.
          Thanks to Lothar Werzinger <lwerzinger@krones.de> for
          reporting this.

Mon May 17 15:17:50 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tests/Event/Makefile:
        * tests/Event/Performance/Connect.cpp:
        * tests/Event/Performance/Connect.h:
        * tests/Event/Performance/Makefile:
        * tests/Event/Performance/Throughput.cpp:
        * tests/Event/Performance/Throughput.h:
        * tests/Event/Performance/ec.mt.conf:
        * tests/Event/Performance/ec.st.conf:
        * tests/Event/lib/Consumer.h:
        * tests/Event/lib/Driver.cpp:
        * tests/Event/lib/Driver.h:
        * tests/Event/lib/Supplier.h:
          Added new test to measure the throughput/latency of the EC and
          the time it takes to connect/disconnect from it.

        * orbsvcs/orbsvcs/Event_Service_Constants.h:
        * orbsvcs/Event/Event_Channel.cpp:
          In some applications we need to use recursive mutexes in the
          Event Channel otherwise it dead-locks. Thanks to Mike Mazurek
          <mmazurek@std.saic.com> for finding this bug and providing the
          fixes.

Mon May 17 14:40:09 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/ORB_Core.cpp (init): Removed extra call to
          orb_params()->use_dotted_decimal_addresses.

Mon May 17 11:31:48 1999  Marina Spivak  <marina@cs.wustl.edu>

        * orbsvcs/orbsvcs/Naming/Naming_Utils.cpp
        * orbsvcs/orbsvcs/Naming/Hash_Naming_Context.cpp:
        Added "ACE_UNUSED_ARG (c_impl);" to avoid DEC compiler warning.

Mon May 17 11:04:02 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/tests/Param_Test/ub_any_seq.cpp:
          Changed the logic of check_validity() so that *all* the
          elements of the sequence get checked instead of just the
          first one (this should also get rid of a DU warning),
          added a constant representing the number of possible
          types tested in the sequence, and removed some
          unnecessary switch cases in init_parameters() and
          reset_parameters().

Sun May 16 21:07:34 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * rules.tao.GNU: Merged the stub and skeleton rules for flick
          compiler together.

        * TAO_IDL/Makefile:
        * TAO_IDL/fe/Makefile.am: lex.yy.cpp needs to be patched with
          lex.yy.cpp.diff.

        * TAO_IDL/fe/idl.ll: Applied ACE_NOTREACHED to unreachable
          break's.

        * TAO_IDL/fe/lex.yy.cpp: Patched with lex.yy.cpp.diff.

        * TAO_IDL/fe/lex.yy.cpp.diff: Added this file to preserve patches
          that can't be done using 'sed'.  It also prevents me from
          throwing tantrums.

Sun May 16 18:47:38 1999  Douglas C. Schmidt  <schmidt@cs.wustl.edu>

        * TAO version 0.3.22 released.

Sun May 16 18:25:26 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
          Fixed default concurrency high water mark.

Sun May 16 10:59:12 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i.cpp:
        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp:
          Added missing template instantiations, at least IRIX/MIPSPro
          needs them.

        * TAO_IDL/be/be_visitor_typecode/typecode_defn.cpp:
          Removed unused variable

        * TAO_IDL/be/be_visitor_union/any_op_cs.cpp:
          The generated code produced a warning in the extraction operator
          of unions from anys.

Sun May 16 10:35:17 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp:
          Fixed a compile warning regarding checking nil pointers.

Sat May 15 23:04:55 1999  David L. Levine  <levine@cs.wustl.edu>

        * TAO_IDL/fe/lex.yy.cpp (TAO_YY_BREAK): removed the ACE_NOTREACHED
          because it caused tao_idl to fail on IRIX and DU.
          Ref: Sat May 15 11:38:59 1999  Nanbor Wang  <nanbor@cs.wustl.edu>.

Sat May 15 22:15:20 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp:
        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.h:
          Added some more @@ comments for Pradeep, in response to his
          questions.

        * tao/Connect.cpp:
          Remvoed yet another call to ORB_Core_instance()

Sat May 15 22:16:06 1999  Marina Spivak  <marina@cs.wustl.edu>

        * orbsvcs/orbsvcs/Naming/Persistent_Context_Index_T.cpp:
        Added <status> variable to store the return value in the <init>
        method.  This is to avoid various compiler warnings regarding
        "reaching the end of non-void function".

        * orbsvcs/orbsvcs/Naming/Naming_Utils.cpp
        * orbsvcs/orbsvcs/Naming/Naming_Utils.cpp:
        Fixed an incorrect comment.

1999-05-15  Vishal Kachroo  <vishal@cs.wustl.edu>

        * performance-tests/POA/Demux/poa_names_100.dat:
        * performance-tests/POA/Demux/demux_test_server.h
        * performance-tests/POA/Demux/demux_test_server.cpp

        Removed the restriction on the no. of servants on the server
        side.

Sat May 15 16:51:08 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        * tao/ObjectIDList.i : Fixed some warnings on VxWorks. Thanks to
          David Levine for pointing this out.

Sat May 15 16:26:49 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.cpp:
          Fixed placement new expression, thanks to David Levine for
          pointing this out.

Sat May 15 14:45:28 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/ImplRepo_Service/Repository.h:
          added #include of ace/SString.h.

        * orbsvcs/ImplRepo_Service/Repository.h,ImplRepo_i.h:
          change multiple #include protection to #ifndef.

        * orbsvcs/ImplRepo_Service/ImplRepo_i.cpp (activate_object):
          commented out unused local "new_addr".

Sat May 15 14:35:48 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/ObjectIDList.*: fixed RCS Id string.

Sat May 15 14:11:37 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/Makefile:
        * TAO_IDL/be/be_visitor_argument/compiled_marshal_ss.cpp:
        * TAO_IDL/be/be_visitor_argument/marshal_ss.cpp:
        * TAO_IDL/be/be_visitor_argument/post_upcall_ss.cpp:
        * TAO_IDL/be/be_visitor_argument/vardecl_ss.cpp:
        * TAO_IDL/be/be_visitor_operation/argument.cpp:
        * TAO_IDL/be/be_visitor_operation/argument_marshal.cpp:
        * TAO_IDL/be/be_visitor_operation/compiled_marshal.cpp:
        * TAO_IDL/be/be_visitor_operation/operation_cs.cpp:
        * TAO_IDL/be/be_visitor_operation/operation_ss.cpp:
        * TAO_IDL/be/be_visitor_operation/rettype_post_docall_cs.cpp:
        * TAO_IDL/be/be_visitor_operation/rettype_post_upcall_ss.cpp:
        * TAO_IDL/be/be_visitor_operation/rettype_vardecl_cs.cpp:
        * TAO_IDL/be/be_visitor_operation/rettype_vardecl_ss.cpp:
        * TAO_IDL/be_include/be_visitor_argument.h:
        * TAO_IDL/be_include/be_visitor_argument/post_upcall_ss.h:
        * TAO_IDL/be_include/be_visitor_operation/rettype_post_docall_cs.h:
        * TAO_IDL/be_include/be_visitor_operation/rettype_post_upcall_ss.h:
          Fixed warnings in generated code if the arguments of an
          operation where arrays.  The changes have been tested for both
          fixed sized and variable sized arrays in Param_Test.
          This should also fix the compilation problem on HP-UX and other
          platforms.

Sat May 15 11:38:59 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * TAO_IDL/fe/lex.yy.cpp (TAO_YY_BREAK): Reapplied my old change
          that handles not-reached break statement.  How did it get lost?

Sat May 15 10:22:52 EDT 1999  Aniruddha Gokhale  <gokhale@sahyadri.research.bell-labs.com>

        * TAO_IDL/be/be_array.cpp:
          TAO_IDL/be_include/be_array.h:
          TAO_IDL/be/be_enum.cpp:
          TAO_IDL/be_include/be_enum.h:
          TAO_IDL/be/be_enum_val.cpp:
          TAO_IDL/be_include/be_enum_val.h:
          TAO_IDL/be/be_exception.cpp:
          TAO_IDL/be_include/be_exception.h:
          TAO_IDL/be/be_field.cpp:
          TAO_IDL/be_include/be_field.h:
          TAO_IDL/be/be_interface.cpp:
          TAO_IDL/be_include/be_interface.h:
          TAO_IDL/be/be_interface_fwd.cpp:
          TAO_IDL/be_include/be_interface_fwd.h:
          TAO_IDL/be/be_predefined_type.cpp:
          TAO_IDL/be_include/be_predefined_type.h:
          TAO_IDL/be/be_scope.cpp:
          TAO_IDL/be_include/be_scope.h:
          TAO_IDL/be/be_sequence.cpp:
          TAO_IDL/be_include/be_sequence.h:
          TAO_IDL/be/be_string.cpp:
          TAO_IDL/be_include/be_string.h:
          TAO_IDL/be/be_structure.cpp:
          TAO_IDL/be_include/be_structure.h:
          TAO_IDL/be/be_typedef.cpp:
          TAO_IDL/be_include/be_typedef.h:
          TAO_IDL/be/be_union.cpp:
          TAO_IDL/be_include/be_union.h:
          TAO_IDL/be/be_union_branch.cpp:
          TAO_IDL/be_include/be_union_branch.h:

          Removed the gen_encapsulation, gen_typecode, tc_size, and
          tc_encap_len methods. All this has been moved to the typecode
          visitor (be_visitor_typecode_defn).

        * TAO_IDL/be/be_decl.cpp:
          TAO_IDL/be_include/be_decl.h:

          Removed the data members encap_len_, and the methods
          gen_encapsulation, gen_typecode, tc_encap_len, tc_size,
          tc_name2long, repoID_encap_len, and name_encap_len. All this has
          been moved to the be_visitor_typecode_defn visitor.

        * TAO_IDL/be/be_helper.cpp:
          TAO_IDL/be_include/be_helper.h:

          Added more operator<< for various ACE_CDR types.

        * TAO_IDL/be/be_sequence.cpp:
          TAO_IDL/be_include/be_sequence.h:
          TAO_IDL/be/be_structure.cpp:
          TAO_IDL/be_include/be_structure.h:
          TAO_IDL/be/be_type.cpp:
          TAO_IDL/be_include/be_type.h:
          TAO_IDL/be/be_union.cpp:
          TAO_IDL/be_include/be_union.h:

          Added a method (in_recursion) that returns a boolean result that
          indicates whether the sequence's element type is involved in a
          direct or indirect recursion. An example of such a scenario is:

          struct foo
          {
             // other fields
             sequence <foo> bar;
          };

          The be_type's in_recursion method always returns 0 because all
          other subclasses of be_type except be_sequence, be_structure,
          and be_union will never be involved in the limited recursion
          allowed by the CORBA spec.

        * TAO_IDL/be/be_visitor_typecode.cpp:

          Added explicit template instantiations for templates used in the
          typecode_defn.cpp file. See below.

        * TAO_IDL/be/be_visitor_argument_post_docall_cs.cpp:

          In the visit interface method, we were not handling the out
          type. Now we correctly narrow the type and release the base type.

        * TAO_IDL/be/be_visitor_array/cdr_op_cs.cpp:
          TAO_IDL/be/be_visitor_attribute/attribute.cpp:
          TAO_IDL/be/be_visitor_sequence/cdr_op_cs.cpp:

          Added default cases to switch statements to eliminate warnings
          produced by EGCS about enums not handled.

        * TAO_IDL/be_include/be_codegen.h:

          Added new substate enumerations for use in typecode generation.

        * TAO_IDL/be/be_valuetype.cpp:
          TAO_IDL/be_include/be_valuetype.h:

          Commented out the typecode related methods. These need to be
          added later to the typecode visitor. This is still TO-DO.

        * TAO_IDL/be/be_visitor_enum/enum_cs.cpp:
          TAO_IDL/be/be_visitor_exception/exception_cs.cpp:
          TAO_IDL/be/be_visitor_interface/interface_cs.cpp:
          TAO_IDL/be/be_visitor_structure/structure_cs.cpp:
          TAO_IDL/be/be_visitor_typedef/typedef_cs.cpp:
          TAO_IDL/be/be_visitor_union/union_cs.cpp:

          Added a step where we set the context substate to typecode
          generation. This way we can then generate the top-level typecode
          encapsulation for the type we are dealing with. Nested typecodes
          are then generated by the visitor itself by setting the
          appropriate substate.

        * TAO_IDL/be/be_visitor_operation/operation_cs.cpp:

          Rearranged the invocation of the POST_INVOKE_CS
          visitor. Otherwise some code was getting duplicated.
          This was also necessary because for interpreted marshaling, we
          had to do some cleaning up of local variables. However, this was
          not required for the compiled marshaling stubs.

        * TAO_IDL/be/be_visitor_sequence/sequence_ch.cpp:
          TAO_IDL/be/be_visitor_sequence/sequence_cs.cpp:

          Commented out the code that generates typecodes for anonymous
          sequences. Once we are sure that nothing breaks, we will remove
          this code.

        * TAO_IDL/be/be_visitor_typecode/typecode_defn.cpp:
          TAO_IDL/be_include/be_visitor_typecode/typecode_defn.h:

          All the typecode generation is now handled by this visitor
          rather than individual files such as be_array.cpp, and
          others. Added all the methods for typecode generation such as
          gen_typecode, gen_encapsulation, tc_size, tc_encap_len,
          repoID_encap_len, name_ID_len, and name2long. Also added data
          members to track the computed sizes. We were required to add all
          the visit_* methods to deal with all the types.

          The most prominent addition to this visitor is the capability to
          generate typecodes for recursive types and the ability to
          generate optimized typecodes. Optimized typecodes use sharing of
          typecodes for repeated types. This is achieved via
          indirections. We do not optimize for typecodes of primitive
          types.

        * TAO_IDL/be/be_visitor_union_branch/public_access.cpp
        (visit_interface):

          The access method for object references was incorrect. We have
          now come up we a new way of returning the value from the acces
          method. In particular, instead of casting the value to
          CORBA::Object_ptr and then to void *, we simply return a pointer
          to TAO_Object_Field_T<TYPE>. In the decode and encode methods of
          the marshaling engine (see ChangeLog entry below), we invoke the
          appropriate upcast method to give us the right CORBA::Object_ptr
          value. This fix has now led to successful working of the
          Param_Test test for obj references that use interpretive
          marshaling.

        * TAO_IDL/driver/drv_args.cpp:

          Enabled optimized typecode handling. Also, we were checking for
          -Go option instead of -Gt option. This is now fixed.

        * tao/CDR_Interpreter.cpp:

          Handled indirected streams properly so that it will allow us to
          cross encapsulation boundaries. Previously, it wouldn't allow us
          to do so.

        * tao/Typecode.h:
          tao/Typecode.cpp:

          Added two data members called tc_base_ and root_tc_base_. The
          tc_base_ points to our tk_kind field in the CDR
          representation. The root_tc_base_ is for children typecodes
          (i.e., nested typecodes who have parents) and it points to the
          tk_kind field of the topmost level typecode.

          Also note that in the CTOR for complex typecodes, we now
          allocate 8 bytes in addition to the length parameter. The first
          two words occupy the top-level typecode's tk_kind value and the
          encapsulation length. The buffer_ member still points to the
          encapsulation so that no other change in the entire file is
          required. The reason why we had to have these extra 8 bytes at
          the start is to handle the recursive typecodes. For example

          struct foo
          {
              // fields
              sequence <foo> bar;
          };

          The encaspulation for the above will generate an indirection
          whose offset will point to the tk_kind field of "foo". However,
          prior to the change described here, we only maintained the CDR
          representation of the encapsulation. So the offset would have
          pointed to 8 bytes before the encapsulation which really diod
          not exist. We would have required unnecessary code to handle
          such a case. So the best way was to maintain the entire typecode
          representation.

        * tao/decode.cpp:
          tao/encode.cpp:

          Indirected streams are now constructed properly such that we can
          cross encapsulation boundaries. We were not required to make any
          changes to the CTORs of ACE_InputCDR.

          We also properly handle the object reference fields of
          unions. The access method gives us a TAO_Object_Field_T<>
          pointer and then we invoke the _upcast method to give us the
          CORBA::Object_ptr.

        * tests/Param_Test/param_test.idl:
          tests/Param_Test/big_union.cpp:

          cosmetic changes.

        TO-DO

          for anonymous sequences whose element type gives rise to a
          recursion, we must generate the <<, >> compiled marshaling
          operators in the *.cpp file else we get a circular dependency.

Fri May 14 23:55:47 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Request.{h,i,cpp}:
          Added Context_ptr member ctx_ to class CORBA_Request, along
          with accessor and mutator methods. Although Contexts are not
          implmented by TAO, these methods do not throw
          CORBA::NO_IMPLEMENT. Since I didn't see any functions in
          CORBA_Request using environment variables, I kept to that
          scheme and therefore could not use ACE_THROW or related
          macros. The accessor simply returns the member (which is
          set to 0 in all constructors) and the mutator does nothing
          but throw away its arg. For the record, these were actually
          checked in a few days ago, but I neglected to make a
          ChangeLog entry at the time.

Fri May 14 20:27:59 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.{h,cpp}:
        * orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i.{h,cpp}:
        * orbsvcs/examples/CosEC/Factory/FactoryClient.cpp:
        * orbsvcs/examples/CosEC/Factory/main.cpp:
          code review changes and compile error fixes.

Fri May 14 17:00:43 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * tao/IIOP_Transport.cpp (send),
          tao/UIOP_Transport.cpp (send): Removed the local const for
          TAO_WRITEV_MAX and replaced it with the new
          ACE_DEFAULT_WRITEV_MAX.

Fri May 14 17:14:12 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.cpp:
          Removed bogus ACE_INLINE, left over when moved from .i file.

Fri May 14 16:15:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * orbsvcs/orbsvcs/Sched/Reconfig_Scheduler.{cpp, h}: more on a
          very rough draft of the initial implementation.

Fri May 14 15:25:18 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/orbsvcs.dsp:
        * orbsvcs/orbsvcs/orbsvcs_static.dsp: Added new files in the EC
          implementation

        * orbsvcs/tests/Event/Event.dsw:
        * orbsvcs/tests/Event/Basic/Basic.dsw:
        * orbsvcs/tests/Event/Basic/Schedule.dsp: Added new project for
          the Schedule test.

        * orbsvcs/orbsvcs/Event/EC_Sched_Filter_Builder.cpp: Fixed type
          conversions problem.

Fri May 14 15:06:47 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * docs/releasenotes/OBV.html: Added releases notes contributed by
          Torsten Kuepper.

Fri May 14 12:34:27 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/DomainC.i:
        * tao/DomainC.cpp: Moved CORBA_DomainManager::_nil () from
          DomainC.i to DomainC.cpp file.

        * tao/Request.i:
        * tao/Request.cpp: Moved two methods CORBA::release () and
          CORBA_Request::_nil () from the Request.i to Request.cpp. This
          would help us to avoid annoying warnings with Sun_g++ which was
          complaining about these two methods being inline as they were
          used before they were declared so. This seems to be a easier way
          to get around this.

Fri May 14 12:20:38 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/ValueBase.h:
        * tao/ValueBase.i:
        * tao/ValueBase.cpp: Added new patches from Torsten Kuepper, this
          should eliminate the warnings about enums.

        * */Makefile: Updated all the dependencies

Fri May 14 09:30:14 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * Integrated scheduling back into the EC, this is still
          experimental.

        * orbsvcs/orbsvcs/Event/EC_Scheduling_Strategy.h:
        * orbsvcs/orbsvcs/Event/EC_Scheduling_Strategy.i:
        * orbsvcs/orbsvcs/Event/EC_Scheduling_Strategy.cpp:
        * orbsvcs/orbsvcs/Event/EC_Null_Scheduling.h:
        * orbsvcs/orbsvcs/Event/EC_Null_Scheduling.i:
        * orbsvcs/orbsvcs/Event/EC_Null_Scheduling.cpp:
        * orbsvcs/orbsvcs/Event/EC_Priority_Scheduling.h:
        * orbsvcs/orbsvcs/Event/EC_Priority_Scheduling.i:
        * orbsvcs/orbsvcs/Event/EC_Priority_Scheduling.cpp: The scheduling
          strategy parametrize the aspects of the EC that relate to the
          Scheduler.  When using the Null_Scheduling the EC does not
          update dependencies in the Scheduler, making that a suitable
          choice for run-time execution (once the dependencies have been
          computed in configuration runs) and for systems that do not
          require scheduling.  The Priority_Scheduling strategy does
          update the dependencies in the scheduler.  Notice that many
          real-time properties of the EC do *not* depend on this, for
          example, locks are bounded to minimize priority inversion in any
          case.  Thus application that require real-time behavior but no
          scheduling can use the EC too.

        * orbsvcs/orbsvcs/Event/EC_QOS_Info.h:
        * orbsvcs/orbsvcs/Event/EC_QOS_Info.i: Add fields to carry RT_Info
          and Preemption priority information.

        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.cpp: Use the
          scheduling strategy to update the dependencies.

        * orbsvcs/orbsvcs/Event/EC_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Basic_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Basic_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.i:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Null_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Null_Factory.cpp: Added new methods to
          the factory to obtain the scheduling strategy.

        * orbsvcs/orbsvcs/Event/EC_Event_Channel.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp: The event channel
          receives an scheduler and an scheduling strategy from the
          attributes and the factory respectively.  The scheduler may be a
          nil object reference in it is not used.

        * orbsvcs/orbsvcs/Event/EC_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Filter.cpp:
        * orbsvcs/orbsvcs/Event/EC_Filter_Builder.h:
        * orbsvcs/orbsvcs/Event/EC_Filter_Builder.cpp:
        * orbsvcs/orbsvcs/Event/EC_Basic_Filter_Builder.h:
        * orbsvcs/orbsvcs/Event/EC_Basic_Filter_Builder.cpp:
        * orbsvcs/orbsvcs/Event/EC_Conjunction_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Conjunction_Filter.i:
        * orbsvcs/orbsvcs/Event/EC_Conjunction_Filter.cpp:
        * orbsvcs/orbsvcs/Event/EC_Disjunction_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Disjunction_Filter.i:
        * orbsvcs/orbsvcs/Event/EC_Disjunction_Filter.cpp:
        * orbsvcs/orbsvcs/Event/EC_Timeout_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Timeout_Filter.cpp:
        * orbsvcs/orbsvcs/Event/EC_Type_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Type_Filter.cpp: In some cases the
          Filter_Builder may need to make CORBA calls and thus requires an
          CORBA::Environment.  Added new operation to add dependencies
          between leaves of the filter tree and RT_Infos.  This operation
          is a noop if no scheduling is enabled, and in fact it is not
          even invoked.

        * orbsvcs/orbsvcs/Event/EC_Sched_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Sched_Filter.i:
        * orbsvcs/orbsvcs/Event/EC_Sched_Filter.cpp:
        * orbsvcs/orbsvcs/Event/EC_Sched_Filter_Builder.h:
        * orbsvcs/orbsvcs/Event/EC_Sched_Filter_Builder.i:
        * orbsvcs/orbsvcs/Event/EC_Sched_Filter_Builder.cpp: Added new
          type of filter, it decorates a regular filter to inform the
          scheduling service of the dependencies between the filter
          elements and finally between suppliers and consumers.

        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.h:
        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.i:
        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.cpp: Allocates the
          message blocks from a per-queue thread, also use a per-thread
          data block to minimize memory allocations.

        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.h:
        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.i:
        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.cpp: Use the
          TAO_EC_QOS_Info and the scheduling service to determine on which
          queue we should dispatch the event.

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.h:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp: Update the filtering
          aspects of this class.

        * orbsvcs/tests/Event/Basic/Makefile:
        * orbsvcs/tests/Event/Basic/Schedule.h:
        * orbsvcs/tests/Event/Basic/Schedule.cpp:
        * orbsvcs/tests/Event/Basic/sched.conf:
        * orbsvcs/tests/Event/Basic/Reconnect.cpp:
        * orbsvcs/tests/Event/lib/Driver.h:
        * orbsvcs/tests/Event/lib/Driver.cpp: Added new test that creates
          an scheduler and uses the scheduling strategies.

        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.cpp: Loop over
          consumers and then over events, not vice-versa. That improves
          throughput by reducing the locking overhead.

        * orbsvcs/orbsvcs/Makefile: Added the new files, updated
          dependencies

        * orbsvcs/Event_Service/Makefile: Added depedencies

Fri May 14 07:18:31 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/tests/Concurrency/Makefile,lex.CC_command.cpp,
          lex.CC_command.cpp.diff: hacked scanner a bit to remove
          unreachable code warning with ace_yy_wrap() #defined to 1.

Thu May 13 22:58:38 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * examples/POA/DSI/Database_i.cpp (invoke): Removed extra return.

Thu May 13 22:46:05 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/OBV/Typed_Events/Event_Types_impl.h: added "class" to a
          bunch of friend declarations.

        * examples/OBV/Typed_Events/Makefile: updated dependencies.

Thu May 13 19:33:27 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/examples/CosEC/Factory/Makefile: don't built if either
          CosEvent or Naming weren't built.

Thu May 13 18:18:50 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/DomainC.cpp: Added instantiation for
          TAO_Object_Manager<CORBA_DomainManager>

Thu May 13 14:48:22 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/corbafwd.h (CORBA):
        * tao/corbafwd.cpp: Fixed warnings on Greenhills compiler.

Thu May 13 11:44:02 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/ORB.h:
        * tao/ORB.cpp: Fixed const violation in
          resolve_initial_references()

Thu May 13 09:55:52 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/Makefile:
        * orbsvcs/examples/Makefile:
        * orbsvcs/examples/CosEC/Makefile:
        * orbsvcs/examples/CosEC/Factory/Makefile:
        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory.idl:
        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp:
        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.h:
        * orbsvcs/examples/CosEC/Factory/FactoryClient.cpp:
        * orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i.cpp:
        * orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i.h:
        * orbsvcs/examples/CosEC/Factory/FactoryDriver.h: Added several @@
          comments in the new CosEC/Factory example.

Thu May 13 00:42:38 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/ORB.h (CORBA_ORB): Rewrote the comments for <perform_work>.
          Previously, it was somewhat unclear what this function was
          doing. Thanks to Trey Grubbs <t-grubbs1@raytheon.com> for
          pointing this out.

Wed May 12 19:40:12 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Object.{h,cpp}: Changed the name of the second
          create_request function to be identical to the name of the
          first. The spec clearly indicates in some places that it is to
          be called 'create_request2', but that's wrong.

Wed May 12 19:22:28 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corba.h: Added some missing #includes which turned up in the
          branding tests.

Wed May 12 18:02:20 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Any.{h,i}: Added a non-copying version of <<= for Any into
          Any, as required by the CORBA spec (see CORBA 2.3a, section
          20.16.2, page 20-58).

Wed May 12 16:26:14 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/ORB.cpp (resolve_initial_references): Changed the const
          CORBA::String to const char * as is expected by the test suite
          and also by the CORBA v2.2 spec vide page 20-115, section
          20-39-20.

Wed May 12 16:04:39 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/TAO.dsp:
        * tao/TAO_Static.dsp: Added Bala's new files (below) to the MSVC
          projects.

Wed May 12 15:46:57 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/Makefile:
        * tao/ORB.h
        * tao/ORB.i
        * tao/ORB.i
        * tao/Managed_Types.h
        * tao/Services.h
        * tao/Services.i
        * tao/Services.cpp
        * tao/Pluggable.h
        * tao/corbafwd.cpp (New file)
        * tao/corbafwd.i (New file) Added a new method
          get_service_information in to ORB.h. This added a few circular
          dependencies which was resolved by Carlos by adding new files
          viz. corbafwd.cpp & corbafwd.i. Updated the Services.* files
          with some new headers and removed the "tao/corba.h" file
          inclusion from them as this would add a high dependency on these
          files. Managed_Types.h included ORB.h for just a few operations
          which has now been moved to corbafwd.i

Wed May 12 15:41:39 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corbafwd.h:
        * tao/Context.i:
        * tao/Environment.{h,i,cpp}: Added CORBA::is_nil() for Contexts,
          and both CORBA::release() and CORBA::is_nil() for
          Environment. In implementing the release() method, also added
          refcount_, refcount_lock_, incr_refcount() and decr_refcount()
          to Environment. All the above methods were declared in
          corbafwd.h (CORBA::is_nil (Context_ptr) was commented out), but
          not implemented.

Wed May 12 14:47:37 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp:
        * orbsvcs/orbsvcs/Event/EC_ConsumerAdmin.cpp:
        * orbsvcs/orbsvcs/Event/EC_SupplierAdmin.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.cpp:
        * orbsvcs/orbsvcs/Event/EC_Command.h:
        * orbsvcs/orbsvcs/Event/EC_Command.i:
        * orbsvcs/orbsvcs/Event/EC_Command.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxyPushSupplier_Set.h:
        * orbsvcs/orbsvcs/Event/EC_ProxyPushSupplier_Set.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxyPushSupplier_Set_T.h:
        * orbsvcs/orbsvcs/Event/EC_ProxyPushSupplier_Set_T.cpp:
        * orbsvcs/orbsvcs/Event/EC_SupplierFiltering.h:
        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.cpp:
        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.cpp: Fixed several
          memory leaks on "dirty" shutdowns of the EC (i.e. shutdowns when
          there are some consumers or suppliers still connected).
          Implemented new "delayed" shutdown operation on the
          Supplier_Sets.  Handling shutdowns while the EC is still
          processing events may prove more tricky, I'm certain that there
          are some race conditions still lurking there.

        * orbsvcs/tests/Event/Basic/Makefile: Fixed order of libraries.

        * orbsvcs/tests/Event/lib/Driver.cpp: Reset all pointers to 0
          after destruction.

Wed May 12 13:58:59 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/ORB.{h,cpp}: Added the dummy function
          list_initial_services().  For now it just throws
          CORBA::NO_IMPLEMENT.

Wed May 12 13:35:19 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/MProfile.h:
        * tao/MProfile.cpp: Fixed warnings

        * orbsvcs/ImplRepo_Service/ImplRepo_i.cpp: I forgot to fix the
          TAO_Stub constructors in this file.

        * orbsvcs/ImplRepo_Service/Makefile: Updated dependencies.

Wed May 12 12:14:41 1999  Ossama Othman  <othman@cs.wustl.edu>

        * COPYING: Additional updates/clarifications suggested by Richard
          Stallman.

Wed May 12 10:38:03 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/MProfile.h:
        * tao/MProfile.i:
        * tao/MProfile.cpp:
        * tao/Stub.h:
        * tao/Stub.i:
        * tao/Stub.cpp:
        * tao/Pluggable.h:
        * tao/Pluggable.i:
        * tao/Pluggable.cpp:
        * tao/IIOP_Profile.h:
        * tao/IIOP_Profile.i:
        * tao/IIOP_Profile.cpp:
        * tao/UIOP_Profile.h:
        * tao/UIOP_Profile.i:
        * tao/UIOP_Profile.cpp:
        * tao/Invocation.cpp:
        * tao/ORB.cpp:
        * tao/Object.cpp: Fixed memory leaks in the managment of
          MProfiles.  Use references to document and clarify the memory
          managment rules.  Implemented the forward_to() methods on
          TAO_Profile instead of TAO_IIOP_Profile, they are required for
          all protocols.

Wed May 12 10:18:34 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * docs/releasenotes/TODO.html:
        * orbsvcs/orbsvcs/Event/EC_Gateway.cpp:
        * orbsvcs/orbsvcs/Event/EC_Gateway_UDP.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp: Some servants where
          not being properly deactivated, thanks to J. Russell Noseworthy
          <rnosewor@objectsciences.com> for pointing this out.

Wed May 12 10:16:15 EDT 1999  Aniruddha Gokhale  <gokhale@sahyadri.research.bell-labs.com>

        * tao/corbafwd.h: Fixed the warnings on NT related to foward
          declaration of ServiceDetail and ServiceInformation.

        * tao/ObjectIDList.h: Fixed an error in the declaration of the CDR
          operators.

        * tao/Service.h: Fixed an error where
          TAO_Unbounded_Sequence<ServiceDetail> should have been
          TAO_Unbounded_Sequence<CORBA_ServiceDetail>

Wed May 12 08:56:40 EDT 1999  Aniruddha Gokhale  <gokhale@sahyadri.research.bell-labs.com>

        * tao/corbafwd.h
          tao/ORB.h
          tao/ObjectIDList.{h, i, cpp}: Fixed a number of compile errors
          with the newly added ObjectIdList class. We now use the same
          trick that we use for classes defined in the CORBA
          namespace. Thus, we define the ObjectIdList class as
          CORBA_ORB_ObjectIdList and then typedef it inside class
          CORBA_ORB. We needed some forward declarations in corbafwd.h.

          Removed some possibly unnecessary explicit template
          instantiation from ObjectIDList.cpp. We were trying to
          instantiate a TAO_Object_Field_T<CORBA::ORB>.

Wed May 12 02:38:52 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

          Code review changes and additions for the CosEC Factory.
          Added the following files:

        * orbsvcs/examples/CosEC/Factory/main.cpp

        * orbsvcs/examples/CosEC/Factory/FactoryDriver.{h,cpp}
          modified the following:

        * orbsvcs/examples/CosEC/Factory/FactoryClient.cpp:
          completed the test code for the factory.

        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.{h,cpp}:

        * orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i.{h,cpp}:
          code review corrections.

Tue May 11 22:39:38 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/TAO.dsp:
        * tao/TAO_Static.dsp: Added Bala's new files to these projects.

Tue May 11 21:46:52 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        Added a new type ObjectIDList to the ORB interface. This is
        required by the list_initital_references (). Handcrafted
        the IDL generated files into the following files :
        * tao/ObjectIDList.cpp
        * tao/ObjectIDList.h
        * tao/ObjectIDList.i
        Added the above files.

        Included the declaration of ObjectIDList in the CORBA_ORB class.
        * tao/ORB.h

        Included ObjectIDList into the makefile.
        * tao/Makefile

Tue May 11 21:46:29 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/DomainC.h: Removed the generated typecode declarations -
          they're unnecessary and cause warnings on VxWorks.

Tue May 11 20:40:52 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Environment.cpp: Added a check for NULL pointer before
          dereferencing the exception (to increment the refcount) in the
          copy constructor. This was causing all the DII param_tests to
          fail.

        * tao/Any.cpp: Removed the branch from value() that returns (void
          *)cdr_.  After checking through all the code in the TAO
          directory, there seems to be nothing that this endangers. Also
          ran the DII param_tests before and after committing the change -
          the results were the same. So now the functionality is cleanly
          divided: Any::value() for the void* and Any::_tao_get_cdr() for
          the cdr_.

Tue May 11 18:06:40 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/Makefile:
        * tao/corbafwd.h
        * tao/corba.h
        * tao/TypeCode_Constants.cpp
        * tao/Services.i (New file)
        * tao/Services.cpp (New file)
        * tao/Services.h (New file): Addition of new data types that we
          did not have and which is carefully checked for by the test
          suite from Open Group. The data types added include ServiceType,
          ServiceDetailType, ServiceOption, ServiceDetail,
          ServiceInformation. The defintions come from CORBA 2.2 spec,
          chapter4, pg-4.2. The above data types have been tested on SunCC
          & Linux_EGCS with some test cases in TAO liek Param_Test. They
          compiled clean and ran without any errors.

Tue May 11 17:47:30 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/append.cpp: Fixed a case (wchar) of
          TAO_Marshal_Union::append that Andy had marked as TODO and
          eliminated another shaky call to Any::value().

Tue May 11 17:19:30 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/Event/Event.dsw:
        * orbsvcs/tests/Event/Basic/Basic.dsw:
        * orbsvcs/tests/Event/Basic/Reconnect.dsp:
        * orbsvcs/tests/Event/Basic/Shutdown.dsp:
        * orbsvcs/tests/Event/lib/Consumer.h:
        * orbsvcs/tests/Event/lib/Driver.h:
        * orbsvcs/tests/Event/lib/ECTest.dsp:
        * orbsvcs/tests/Event/lib/ECTest.dsw:
        * orbsvcs/tests/Event/lib/Supplier.h:
        * orbsvcs/tests/Event/lib/ectest_export.h: Added project files,
          workspaces and export macros to compile this tests on NT.

Tue May 11 16:46:20 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Object.{h,cpp}: Added the second form of
          create_request(). It has two additional args - an exception list
          and a context list, which are both unused in this
          implementation.

Tue May 11 16:03:01 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corbafwd.h:
          Added some flags to the enum containing the ones
          for NVList. The new ones are:
          DEPENDENT_LIST
             If a sublist is added as a single item,
             this indicates that it should be freed
             when the parent list is freed.
          CTX_RESTRICT_SCOPE
             Used in Context::get_values to limit the scope of
             the search to the supplied scope arg.
          CTX_DELETE_DESCENDENTS
             Deletes child Context objects along with the parent.
          INV_NO_RESPONSE
          INV_TERM_ON_ERR
          RESP_NO_WAIT
             Used in deferred synchronous requests.

Tue May 11 14:34:56 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/IDL_Cubit/{client,server}.cpp:
          removed unnecessary #includes of "tests/test_config.h".

        * performance-tests/Cubit/TAO/IDL_Cubit/run_tests.pl: fixed check
          for existing files to work on NT, by using full path.

Tue May 11 14:17:54 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/DomainS.cpp: Added some ACE_UNUSED_ARGs for generated code
          that has been commented out, and a marshaling exception because
          this method (ConstructionPolicy::make_domain_manager) is not yet
          implemented.

Tue May 11 13:51:55 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * docs/releasenotes/TODO.html:
        * orbsvcs/orbsvcs/Event/EC_ConsumerAdmin.cpp:
        * orbsvcs/orbsvcs/Event/EC_ConsumerAdmin.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.h:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.h:
        * orbsvcs/orbsvcs/Event/EC_SupplierAdmin.cpp:
        * orbsvcs/orbsvcs/Event/EC_SupplierAdmin.h:
        * orbsvcs/tests/Event/Basic/Makefile:
        * orbsvcs/tests/Event/Basic/Reconnect.cpp:
        * orbsvcs/tests/Event/Basic/Shutdown.cpp:
        * orbsvcs/tests/Event/Basic/Shutdown.h:
        * orbsvcs/tests/Event/lib/Consumer.cpp:
        * orbsvcs/tests/Event/lib/Driver.cpp:
        * orbsvcs/tests/Event/lib/Driver.h:
        * orbsvcs/tests/Event/lib/Supplier.cpp: Completed the
          implementation of the destroy() method in the new Event
          Channel. It was not invoking the disconnect_push_XXX()
          operations on its list of suppliers and consumers.

Tue May 11 13:45:00 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/WrongTransactionC.{h,cpp}:
        * tao/corbafwd.h:
        * tao/Typecode_Constants.cpp:
        * tao/TAO.dsp:
        * tao/TAO_Staatic.dsp:
        * tao/Makefile: Added WrongTransaction exception. It applies to
          Requests so it is not part of minimum CORBA. Also, while the
          spec does not say so explicitly, it seems to be thrown only on
          the client side, so only that part of the generated code is
          here. If this turns out not to be the case, server side code
          will have to be added.

Tue May 11 13:25:40 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/IDL_Cubit/{server.dsp,client.dsp}:
          fixed path for static release builds.  Actually, Nanbor fixed
          it.

Tue May 11 12:30:45 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/ast/AST_Expression.cpp:
        * TAO_IDL/include/AST_Expression.h: Backed out the change I made
          yesterday. Not an important change by itself, but one day we'll
          have to overhaul all the basic type stuff in the IDL compiler.

Tue May 11 11:03:16 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/MT_Cubit_Test:
          support shells that don't have $OPTIND.

Tue May 11 09:48:09 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Dispatching.h:
        * orbsvcs/orbsvcs/Event/EC_ObserverStrategy.h:
        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.h:
        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.h:
          Added missing TAO_ORBSVCS_Export macros, thanks to Frank Hodum
          <fhodum@sito.saic.com> for pointing this out.

Tue May 11 09:22:08 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/DomainC.cpp: added TAO_Object_Field_T<CORBA_DomainManager>
          explicit template instantiation.

Mon May 10 22:57:37 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/DomainC.cpp:
          Added missing #include

Mon May 10 22:40:29 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * docs/releasenotes/TODO.html:
        * docs/releasenotes/ec.html:
          Updated to include the latest EC results.

Mon May 10 22:39:30 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/ast/AST_Expression.cpp:
        * TAO_IDL/include/AST_Expression.h:
          Added constructors for AST_Expressions of type
          long long and unsigned long long - bracketed with
          ifdefs concerning ACE_LACKS_LONGLONG_T.

Mon May 10 21:54:30 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/Makefile:
          Added the Event directory

        * orbsvcs/tests/Event/Basic/Reconnect.h:
        * orbsvcs/tests/Event/Basic/Reconnect.cpp:
          Added new option to control the number of disconnections, fixed
          some minor problems. Removed execution of the regular test since
          it will take too long to run thousands of consumers and
          suppliers.

        * orbsvcs/tests/Event/lib/Driver.h:
        * orbsvcs/tests/Event/lib/Driver.i:
        * orbsvcs/tests/Event/lib/Driver.cpp:
          Fixed and cleaned up memory managment for tasks.
          Fixed computation of the Supplier QOS
          Fixed argument parsing
          Fixed throughput computation

        * orbsvcs/tests/Event/lib/Supplier.cpp:
          Better error handling if the QoS is invalid

        * orbsvcs/tests/Event/lib/Consumer.cpp:
          Fixed throughput computation

        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.cpp:
          Implemented reconnection of suppliers

        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
          Fixed typo

Mon May 10 19:44:16 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * Domain.pidl:
        * DomainC.{h,i,cpp}:
        * DomainS.{h,cpp}:
        * DomainS_T.{h,i,cpp}:
          New files incorporating the (as yet unimplemented)
          classes DomainManager, ConstructionPolicy, and
          DomainManagerList.

        * corbafwd.h:
        * POA_CORBA.h:
        * Typecode_Constants.cpp:
        * TAO.dsp:
        * TAO_Static.dsp:
        * Makefile:
          All the necessary modifications corresponding to
          the above new files. Also removed the (nonexistent)
          file PolicyS.h from the two projects.

Mon May 10 17:21:52 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Event_Channel.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp:
          New class TAO_EC_Event_Channel_Attributes used to initialize the
          event channel. This will close the interface for the EC
          constructor, yet will allow us to add more (optional or
          mandatory) arguments.

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
          The event channel can be configured to support multiple
          connect() calls to the same ProxyPushSupplier.

        * orbsvcs/Event_Service/Event_Service.cpp:
        * orbsvcs/CosEvent_Service/CosEvent_Service.cpp:
        * orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
        * orbsvcs/tests/Event_Latency/Event_Latency.cpp:
        * orbsvcs/tests/EC_Mcast/EC_Mcast.cpp:
          Use the TAO_EC_Event_Channel_Attributes class to initiliaze
          TAO_EC_Event_Channel

        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.cpp:
          Minor cosmetic fixes.

        * orbsvcs/tests/EC_Throughput/ECT_Consumer.cpp:
          Removed dead code.

Mon May 10 16:46:41 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * TAO-INSTALL.html (href): Added a link to Barry Hoggard's CORBA
          page which contains TAO specific information.

Mon May 10 15:02:21 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/Exception.h:
        * tao/Exception.cpp:
        * tao/corbafwd.h: Added new exceptions in TAO_SYSTEM_EXCEPTIONS
        viz.TRANSACTION_REQUIRED, TRANSACTION_ROLLEDBACK &
        INVALID_TRANSACTION. These are part of the spec, v2.2, section
        3.5.3, page 3-39. We had not implemented this and it was flagged
        of by the branding test suite.

Mon May 10 12:47:29 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * TAO_IDL/driver/drv_preproc.cpp (DRV_cpp_init): TAO_IDL will try
          to figure out where MSVC is located if CPP_LOCATION is not
          defined.  It does this by checking if MSVCDir environment
          variable is defined.  Although this approach ties TAO_IDL closer
          to MSVC, it is probably the most widely used compiler on Win32
          platforms.  Therefore, I think it is not really a "bad taste."

          Thanks to Jonathan Biggar <jon@floorboard.com> for suggesting
          this.

Mon May 10 11:43:04 1999  Ossama Othman  <othman@cs.wustl.edu>

        * COPYING: Made some updates suggested by Richard Stallman
          <rms@gnu.org> of the Free Software Foundation
          (http://www.fsf.org/).

Mon May 10 08:24:20 1999  David L. Levine  <levine@cs.wustl.edu>

        * TAO/orbsvcs/orbsvcs/Makefile,examples/Callback_Quoter/Makefile,
          tests/MT_Client/Makefile:
          ran make depend to fix dependencies.  Thanks to Andy for reporting
          that they were missing.

Mon May 10 08:39:19 EDT 1999  Aniruddha Gokhale  <gokhale@sahyadri.research.bell-labs.com>

        * tao/Request.cpp: Explicit template instantiations for the newly
          added sequence of CORBA::Request were missing.

Mon May 10 00:36:02 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/Request.h (CORBA_Request>):
        * tao/Request.cpp : Added new definition for the class
          CORBA_ORB_RequestSeq. This was added to facilitate the testing
          process. Thanks to Carlos for helping to generate the new class
          by inheriting from TAO_Pseudo_Unbounded_Sequence ().

Sun May  9 12:47:47 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * docs/releasenotes/index.html:
        * docs/releasenotes/OBV.html:
          Added template for the OBV release notes.

Sun May 09 11:26:57 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * TAO/examples/Callback_Quoter/Makefile
          TAO/examples/Event_Comm/Makefile
          TAO/examples/OBV/Typed_Events/Makefile
          TAO/examples/POA/Adapter_Activator/Makefile
          TAO/examples/POA/DSI/Makefile
          TAO/examples/POA/Default_Servant/Makefile
          TAO/examples/POA/Explicit_Activation/Makefile
          TAO/examples/POA/Forwarding/Makefile
          TAO/examples/POA/Generic_Servant/Makefile
          TAO/examples/POA/Identity/Makefile
          TAO/examples/POA/On_Demand_Activation/Makefile
          TAO/examples/POA/Reference_Counted_Servant/Makefile
          TAO/examples/POA/TIE/Makefile
          TAO/examples/Quoter/Makefile
          TAO/examples/Simple/bank/Makefile
          TAO/examples/Simple/chat/Makefile
          TAO/examples/Simple/echo/Makefile
          TAO/examples/Simple/grid/Makefile
          TAO/examples/Simple/time/Makefile
          TAO/orbsvcs/Concurrency_Service/Makefile
          TAO/orbsvcs/CosEvent_Service/Makefile
          TAO/orbsvcs/Dump_Schedule/Makefile
          TAO/orbsvcs/Event_Service/Makefile
          TAO/orbsvcs/ImplRepo_Service/Makefile
          TAO/orbsvcs/LifeCycle_Service/Makefile
          TAO/orbsvcs/Logging_Service/Makefile
          TAO/orbsvcs/Naming_Service/Makefile
          TAO/orbsvcs/Scheduling_Service/Makefile
          TAO/orbsvcs/Time_Service/Makefile
          TAO/orbsvcs/Trading_Service/Makefile
          TAO/orbsvcs/orbsvcs/Makefile
          TAO/orbsvcs/tests/Concurrency/Makefile
          TAO/orbsvcs/tests/CosEC_Basic/Makefile
          TAO/orbsvcs/tests/CosEC_Multiple/Makefile
          TAO/orbsvcs/tests/EC_Basic/Makefile
          TAO/orbsvcs/tests/EC_Custom_Marshal/Makefile
          TAO/orbsvcs/tests/EC_Mcast/Makefile
          TAO/orbsvcs/tests/EC_Multiple/Makefile
          TAO/orbsvcs/tests/EC_Throughput/Makefile
          TAO/orbsvcs/tests/Event_Latency/Makefile
          TAO/orbsvcs/tests/ImplRepo/Makefile
          TAO/orbsvcs/tests/Logger/Makefile
          TAO/orbsvcs/tests/Property/Makefile
          TAO/orbsvcs/tests/Sched_Conf/Makefile
          TAO/orbsvcs/tests/Simple_Naming/Makefile
          TAO/orbsvcs/tests/Time/Makefile
          TAO/orbsvcs/tests/Trading/Makefile
          TAO/performance-tests/Cubit/TAO/DII_Cubit/Makefile
          TAO/performance-tests/Cubit/TAO/IDL_Cubit/Makefile
          TAO/performance-tests/Cubit/TAO/MT_Cubit/Makefile
          TAO/performance-tests/Thruput/TAO/Makefile
          TAO/tao/Makefile
          TAO/tests/MT_Client/Makefile
          TAO/tests/Multiple_Inheritance/Makefile
          TAO/tests/NestedUpcall/MT_Client_Test/Makefile
          TAO/tests/NestedUpcall/Reactor/Makefile
          TAO/tests/NestedUpcall/Triangle_Test/Makefile
          TAO/tests/OctetSeq/Makefile
          TAO/tests/Param_Test/Makefile: ran make depend after adding new
          RB_Tree interface.

Sat May 08 17:17:57 1999  David L. Levine  <levine@cs.wustl.edu>

        * TAO_IDL/be/be_valuetype.cpp,be_valuetype_fwd.cpp: removed
          extraneous ; after function definitions.

Sat May  8 16:10:33 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_valuetype/field_ch.cpp:
        * TAO_IDL/be/be_visitor_valuetype/field_cs.cpp:
          Added non-const accesor for array fields in valuetypes. Thanks
          to David Levine for pointing this out.

Sat May  8 15:02:37 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/GIOP.h (TAO_GIOP):
        * tao/GIOP.cpp:
        * tao/Connect.cpp:
        * tao/corbafwd.h: Changed the exception type defined as an enum in
          corbafwd.h as 'ExceptionType' to 'exception_type'. This is
          defined in the spec in chapter-3, pg.3-38, section 3.15.1 under
          Standard Exception Definitions in CORBAv2.2 spec. The vsOrb test
          suite also tests for this with this spelling.

          The previous spelling 'ExceptionType' seems to a
          spill out of the CORBA-COM, CORBA-OLE specs.  Changes to other
          *.cpp and *.h files listed above to acommodate the change made
          in corbafwd.h.

Sat May 08 08:42:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_ObserverStrategy.cpp: added missing
          template instantiation for ACE_RB_Tree_Reverse_Iterator.

Sat May 08 08:20:48 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/client.cpp:
          changed type of SWITCHES from int to u_int to avoid
          signed/unsigned comparisons.

Sat May 08 08:17:48 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/DynUnion_i_T.{h,cpp} (DU_Extractor): added virtual
          destructor, to please egcs 1.1.2/VxWorks.

Sat May 08 03:45:55 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * TAO/TAO_Static.dsp: Added missing source files.

        * TAO_IDL/tao_idl_static.dsp:
        * examples/Simple/time/client_static.dsp:
        * examples/Simple/time/server_static.dsp:
        * orbsvcs/orbsvcs/orbsvcs_static.dsp:
        * performance-tests/Cubit/TAO/IDL_Cubit/client.dsp:
        * performance-tests/Cubit/TAO/IDL_Cubit/server.dsp:
        * performance-tests/Cubit/TAO/MT_Cubit/client.dsp:
        * performance-tests/Cubit/TAO/MT_Cubit/server.dsp:
        * tao/TAO_Static.dsp: We should have used ACE_NO_INLINE instead of
          defining __ACE_INLINE__=0 to supress the use of inlining.
          Thanks to Nick Sawadsky <Nick_Sawadsky@BrooksSoftware.com> for
          reporting this.

Sat May 08 02:36:53 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * examples/POA/Identity/Identity.cpp (test_poas): Added testing
          for root POA.

        * tao/POA.cpp (reference_to_servant and reference_to_id): Fixed
          the checking of results from TAO_POA::parse_key().  POA names
          should not be compared when the target POA is the root POA.
          Thanks to Tommy Andreasen <tommy.andreasen@post.tele.dk> for
          pointing out this bug.

        * tao/TAO_Static.dsp and tao/TAO.dsp: Removed Sequence_T.cpp from
          compilation list; it only contains template code.

Fri May 07 23:49:38 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/default_server.cpp (parse_args): Fixed
          ORBuniqueidpolicyreversedemuxstrategy option.  Thanks to Phil
          Mesnier <mesnier_p@ociweb.com> for pointing out that the "user"
          option was extra and that the "linear" option was missing.

Fri May 07 22:45:33 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/tests/Trading/Makefile: removed -lTTest from LDLIBS
          because it now appears explicitly on the link line, because
          it is a dependency of $(BIN).  egcs complained about the
          multiple occurrences.

Fri May  7 22:34:58 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/corbafwd.h (CORBA):
        * tao/TypeCode_Constants.cpp: Added new typecode for the interface
          NamedValue. This would make us compatible with CORBA spec.

Fri May  7 19:50:41 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Sequence_T.i:
        * TAO_IDL/be/be_visitor_sequence/gen_bounded_obj_sequence_ci.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_bounded_obj_sequence_cs.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_bounded_sequence_ch.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_bounded_sequence_ci.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_bounded_sequence_cs.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_bounded_str_sequence_ch.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_bounded_str_sequence_ci.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_bounded_str_sequence_cs.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_unbounded_obj_sequence_cs.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_unbounded_sequence_ch.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_unbounded_sequence_cs.cpp:
          Fixed bug in TAO_Bounded_Sequence<T,MAX> thanks for
          Jim Rogers <jrogers@viasoft.com> for finding this out.

Fri May  7 20:57:19 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/TAO.dsp:
        * tao/TAO_Static.dsp:
          Added Sequence_T.cpp and Object_Adapter.h to the
          projects.

Fri May  7 20:39:30 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Sequence_T.i:
          Added a <T> to the argument of the copy constructor for
          TAO_Object_Manager<T>. Was causing a problem with IBM
          OpenEdition.

        * tao/Object_Adapter.h:
          Moved the classes Hint_Strategy, Active_Hint_Strategy, and
          No_Hint_Strategy to the public section of TAO_Object_Adapter.
          IBM OpenEdition didn't like the protected class Hint_Strategy
          being inherited by the other two.

        * tao/ORB.h:
          Moved forward declaration and typedefs of
          CORBA_ORB_InconsistentTypeCode outside of class
          ORBA_ORB to the beginning of the file. IBM OpenEdition
          didn't like this either.

          Thanks to Jim Rogers <jrogers@viasoft.com> for pointing
          out the problems and suggesting fixes.

Fri May  7 19:37:18 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.h:
        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.i:
        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.h:
        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.cpp:
          Eliminate one memory allocation on the priority dispatching
          case, thanks to Tom Venturella <Thomas.Venturella@MW.Boeing.com>
          for this idea.  In the future we should use a per-supplier data
          block instead of a global one, to minimize priority inversion.

Fri May  7 19:16:50 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_sunsoft.cpp:
        * TAO_IDL/ast/ast_expression.cpp:
        * TAO_IDL/include/ast_expression.h:
          Put in many many #if ! defined (ACE_LACKS_LONGLONG_T)
          brackets to avoid compile errors on GreenHills and
          IBM OpenEdition. Thanks to Jim Rogers <jrogers@viasoft.com>
          for pointing out the problem.

Fri May  7 16:55:08 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/Typecode.h (CORBA_TypeCode): Changed the _narrow definitions
          in TypeCode::BadKind and Type_code::Bounds to be of type
          static. THis will now be according to the spec. This is the
          result of test run on the header module.

        * tao/ORB.h,
        * ORB.cpp: Changed the signature of the method,
          resolve_initial_reference(). This now takes in const string and
          it was previously a non-const one. We had to make this change to
          be compatible with the spec and the vsOrb test suite checks for
          this.

Fri May  7 12:56:08 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * TAO_IDL/driver/drv_preproc.cpp (DRV_pre_proc): Integrated Byron
          Harris <harris_b@ociweb.com> 's patches for checking for \\'s in
          command line IDL file given to tao_idl.

        * orbsvcs/orbsvcs/Property/CosPropertyService_i.cpp: Fixed the
          IRIX warnings.

Fri May  7 10:00:25 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Makefile:
        * tao/Context.cpp:
        * tao/Context.h:
        * tao/DynAnyC.h:
        * tao/ORB.cpp:
        * tao/ORB.h:
        * tao/Object_Adapter.cpp:
        * tao/POA.i:
        * tao/POAC.i:
        * tao/Typecode_Constants.cpp:
        * tao/corbafwd.h:
          Several fixes to support minimum CORBA.

        * examples/Quoter/server.cpp:
          Fixed error in my use of ACE_PRINT_EXCEPTION.

Thu May  6 21:49:22 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/be/be_union_branch.cpp:
        * TAO_IDL/be/be_visitor_interface/tie_si.cpp:
        * TAO_IDL/be/be_visitor_operation/operation_ss.cpp:
        * examples/Callback_Quoter/Supplier_i.cpp:
        * examples/POA/Default_Servant/client.cpp:
        * examples/POA/Default_Servant/server.cpp:
        * examples/Quoter/server.cpp:
        * examples/Simple/Simple_util.cpp:
        * orbsvcs/Trading_Service/Trading_Service.cpp:
        * orbsvcs/orbsvcs/IOR_Multicast.cpp:
        * orbsvcs/orbsvcs/Event/EC_Gateway_UDP.cpp:
        * orbsvcs/orbsvcs/Event/Event_Channel.cpp:
        * orbsvcs/orbsvcs/Event/Timer_Module.cpp:
        * orbsvcs/tests/EC_Custom_Marshal/ECM_Consumer.cpp:
        * orbsvcs/tests/EC_Custom_Marshal/ECM_Supplier.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Consumer_Driver.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Supplier_Driver.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
        * orbsvcs/tests/Event_Latency/Event_Latency.cpp:
        * performance-tests/Thruput/TAO/ttcp_i.cpp:
        * tao/ORB_Core.cpp:
        * tao/Operation_Table.cpp:
        * tests/MT_Client/server.cpp:
        * tests/Multiple_Inheritance/client.cpp:
        * tests/Multiple_Inheritance/server.cpp:
        * utils/catior/catior.cpp:
          Fixed inconsisten use of ACE_ERROR and LM_DEBUG, also removed
          use of the DEBUG macro in favor of ACE_NDEBUG.

Thu May  6 18:34:43 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.h:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
          Fixed problem with disconnections while pushing an event, thanks
          to Pradeep Gore for finding this out.

Thu May  6 18:09:15 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_valuetype/field_cs.cpp:
        * TAO_IDL/be/be_visitor_valuetype/field_ch.cpp:
          Fixed return type for the accesor of array fields of a
          valuetype.

Thu May  6 17:52:47 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * examples/Simple/echo/README (client):
          Updated Naming Service option from -s to -n.

Thu May  6 15:46:00 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/be/be_args.cpp:
        * TAO_IDL/be/be_visitor.cpp:
          Removed characters after #endif

        * TAO_IDL/be/be_valuetype.cpp:
        * TAO_IDL/be_include/be_valuetype.h:
          Function overloaded with different signature?

        * examples/OBV/Typed_Events/Event_Types_impl.cpp:
          Fixed return expression on void function.

        * tao/ValueBase.h:
        * tao/ValueBase.i:
          No sense in passing arguments by value as const, and they gave
          Sun/CC 4.2 some headaches.
          Use unsigned quantities for enums MSVC balks at expressions like
          (-0x80000000L).

        * tao/ValueFactory_Map.cpp:
          Fixed some constness problems.

        * utils/catior/catior.cpp:
          Fixed unsigned/signed warning.

        * orbsvcs/tests/EC_Throughput/ECT_Supplier.cpp:
          No need to change the priority of this thread, it is activated
          at the right priority.

        * orbsvcs/tests/EC_Throughput/ECT_Driver.cpp:
          Fixed debug messages.

        * orbsvcs/tests/EC_Throughput/ECT_Scheduler_Info.h:
          Adjusted priorities for LynxOS.

        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.cpp:
          Use (min+max)/2 as default priority, to avoid problems on LynxOS
          where the lowest real-time priority is the lowest priority of
          the system!

        * orbsvcs/orbsvcs/Event/EC_Gateway_UDP.i:
          Inline functions where not declared as such, got duplicate
          symbols when compiling against static library.

        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.cpp:
          Do not exit the loop on exception, continue until shutdown
          event.

Thu May 06 14:34:31 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/tao_idl.dsp:
        * TAO_IDL/tao_idl_static.dsp:
        * tao/TAO.dsp:
        * tao/TAO_Static.dsp:
          Added the new files that support OBV.

        * orbsvcs/orbsvcs/orbsvcs.dsp:
        * orbsvcs/orbsvcs/orbsvcs_static.dsp:
          Added missing idl files CosTradingRepos.idl,
          CosTradingDynamic.idl and some new EC files too.

Thu May  6 12:11:22 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * Many thanks and kudos to Torsten Kuepper
          <kuepper2@uni-wuppertal.de> who contributes an initial
          implementation of Object-by-Value to TAO. His ChangeLog entry
          follows:

        * TAO/tao/Makefile:
        * TAO/TAO_IDL/Makefile:
        * TAO/tao/orbconf.h:
        * TAO/TAO_IDL/include/idl.h:
          Support of Valuetypes if TAO_HAS_OBV resp. IDL_HAS_OBV is
          defined.
          This is far from complete. However
          + you are able to pass valuetypes as arguments in operation
          signatures (see examples/OBV).
            - Valuetype as member of other types (union, sequence ...) is
            missing until the compiler backend is provided with visitors
            for that.
          + A valuetype could have a valuetype as state member, ...
            - ... but currently the sharing of valuetypes in the context
            of an invocation is not yet implemented. This means you got
            two out of one (if two references point to one object) and
            cyclic references are not feasible.
          + The marshalling code accesses the state member data directly
            for optimization (-Wb,obv_opt_accessor).
            - This will be changed for unoptimized (standard) valuetypes,
              where the implementer should be able to override the
              accessor/modifier functions even for marshalling. Currently
              she isn't able to do so.
            - The marshalling does no fragmentation (chunking) yet. But
              this is required for custom marshalling and truncation.
            - Ordinary (not hashed) repository ids are used. Some code is
              missing that would optimize sending repo ids away (if the
              formal parameter is equal the current type) or that
              backreferences earlier send repository ids, when marshalling
              a graph.
            - The code generated for typedefs and forwards of valuetypes
              is not complete and will not compile.
            - Support of an interface is not yet there. Perhaps the TIE to
              a valuetype may give comparable functionality.
            - Abstract interfaces are not implemented too.
            - TypeCode for valuetypes are missing, and without that,
              packing a valuetype into an any is not yet possible.
            - init () is not yet mapped to create () in the _init
              class. But you can declare create () on your own in your
              factory class.
            - Some helper classes (e.g. _var for ValueFactory) are
              missing.
          And I have confused a few issues on constness in modifier
          functions and members (in _init) which should be private and
          friend of another class, but it didn't want to compile right. I
          will correct these points, when I have the time.

        * TAO/examples/OBV/Typed_Events [new]:
          Demonstration of Typed Events, e.g. measuring values. The idea
          is to have common attributes (time and origin id) and operations
          (do_print()) in a base class.
          The event (temperature, position...) that is derived from the
          base is created in one process and is passed (type safe) to
          another process which invokes member function of the base class
          to do something with this concrete event (e.g. show, perform a
          test).
          (Naturally, the receiving process must have an implementation of
          the valuetypes.)

        * TAO_IDL/idl_global.h:
        * TAO_IDL/utl_global.cpp:
        * TAO_IDL/drv_args.cpp:
        * TAO_IDL/be/be_args.cpp:
          New TAO_IDL options
            -Gv   enable OBV (Valuetype)
            -Sv   disable OBV (Valuetype) (currently default)
                  read option with idl_global->obv_support()
            -Wb,obv_opt_accessor  Nonvirtual inline accessor/modifier
            functions
          Currently it is necessary to use compiled marshalling (-Gc) when
          using the valuetype feature.

        * TAO_IDL/fe/idl.ll:
        * TAO_IDL/fe/fe_init.cpp:
          Compiler FE recognizes the OBV token (abstract, custom, init,
          private, public, supports, truncatable, valuetype) (CORBA 2.3
          3.2.4), but only if it is compiled with IDL_HAS_OBV and -Gv is
          given.

        * TAO_IDL/fe/idl.yy:
          There are some new productions in the parser. member is now a
          wrapper for member_i, which previously was member but now
          accesses $0 as visibility parameter.

        * TAO_IDL/include/ast_generator.h:
        * TAO_IDL/be/be_generator.cpp:
        * TAO_IDL/include/ast_interface.h:
        * TAO_IDL/ast/ast_interface.cpp:
        * TAO_IDL/include/ast_interface_fwd.h:
        * TAO_IDL/ast/ast_interface_fwd.cpp:
        * TAO_IDL/include/ast_field.h:
        * TAO_IDL/ast/ast_field.cpp:
        * TAO_IDL/be_include/be_field.h:
        * TAO_IDL/be/be_field.cpp:
        * TAO_IDL/be_include/be_valuetype.h [new]:
        * TAO_IDL/be/be_valuetype.cpp [new]:
        * TAO_IDL/include/fe_interface_header.h:
        * TAO_IDL/fe/fe_interface_header.cpp:
          AST_Interface is currently used for valuetypes too.  (This
          attempt was made for better staying in sync with the rushing TAO
          development.)
          Though lots of code for name lookup and inheritance rules can be
          reused. AST_Interface has the new methods is_valuetype(),
          is_abstract_valuetype() and is_abstract_interface() which allows
          the frontend to distinguish them. Later on a new AST_ class
          should  be refactored which is a base class to the IDL types
          that provide inheritance.

          Some shared code in idl.yy is now in AST_Interface::redefine()
          and AST_Interface::fwd_redefinition_helper(). Forward definition
          is a little changed, that the dummy full definition be_ object
          stored in AST_InterfaceFwd is of the right type.

          FE_InterfaceHeader::compile_inheritance () is extended with the
          rules to check right inheritance of valuetypes and abstract
          interfaces.
          The constructor of FE_InterfaceHeader has now a default
          parameter which let the derived FE_obv_header invoke
          compile_inheritance () at later time.

        * TAO_IDL/be_include/be.h:
        * TAO_IDL/be_include/be_codegen.h:
        * TAO_IDL/be_include/be_visitor.h:
        * TAO_IDL/be_include/be_visitor_module/module.h:
        * TAO_IDL/be_include/be_visitor_root/root.h:
        * TAO_IDL/be_include/be_visitor_argument/arglist.h:
        * TAO_IDL/be_include/be_visitor_argument/compiled_marshal_cs.h:
        * TAO_IDL/be_include/be_visitor_argument/compiled_marshal_ss.h:
        * TAO_IDL/be_include/be_visitor_argument/post_docall_compiled_cs.h:
        * TAO_IDL/be_include/be_visitor_argument/upcall_ss.h:
        * TAO_IDL/be_include/be_visitor_argument/vardecl_ss.h:
        * TAO_IDL/be_include/be_visitor_field/field_ch.h:
        * TAO_IDL/be_include/be_visitor_operation/compiled_marshal.h:
        * TAO_IDL/be_include/be_visitor_operation/rettype*.h:
        * TAO_IDL/be_include/be_visitor_valuetype.h [new]:
        * TAO_IDL/be_include/be_visitor_valuetype_fwd.h [new]:
        * TAO_IDL/be_include/be_visitor_valuetype/*.h [new]:
        * TAO_IDL/be/be_visitor.cpp:
        * TAO_IDL/be/be_visitor_factory.cpp:
        * TAO_IDL/be/be_visitor_module/module.cpp:
        * TAO_IDL/be/be_visitor_root/root.cpp:
        * TAO_IDL/be/be_visitor_argument/arglist.cpp:
        * TAO_IDL/be/be_visitor_argument/compiled_marshal_cs.cpp:
        * TAO_IDL/be/be_visitor_argument/compiled_marshal_ss.cpp:
        * TAO_IDL/be/be_visitor_argument/post_docall_compiled_cs.cpp:
        * TAO_IDL/be/be_visitor_argument/upcall_ss.cpp:
        * TAO_IDL/be/be_visitor_argument/vardecl_ss.cpp:
        * TAO_IDL/be/be_visitor_field/field_ch.cpp:
        * TAO_IDL/be/be_visitor_operation/compiled_marshal.cpp:
        * TAO_IDL/be/be_visitor_operation/rettype*.cpp:
        * TAO_IDL/be/be_visitor_valuetype_fwd.cpp [new]:
        * TAO_IDL/be/be_visitor_valuetype/*.cpp [new]:

          The visiting of valuetype is integrated into the root and module
          visitors. The OBV_ classes resp. namespaces are generated in an
          extra pass over the syntax tree.

        * tao/corba.h:
        * tao/corbafwd.h:
        * tao/ValueBase.h [new]:
        * tao/ValueBase.i [new]:
        * tao/ValueBase.cpp [new]:
          All valuetypes inherit from the CORBA::ValueBase. It has
          abstract operations for the reference counting, which are
          implemented by multiply inherit from
          e.g. CORBA::DefaultValueRefCountBase.
          _copy_value () is not yet implemented.
          There is some internal stuff for doing [un]marshalling and
          dynamic type conversion (used by _downcast ()), whose
          underlaying mechanism is like in the tao_idl compiler
          itself:
            The static member _downcast () calls a virtual function, which
            is implemented from the IDL compiler, with an id of the wanted
            type. These it is compared against the actual id of the
            object. In case of mismatch the ancestors of the valuetype are
            called (in depth first order).
          _downcast () is used during unmarshaling too. This may result in
          quite undeterministic real time behaviour. The worst case would
          be that the _downcast walks the complete inheritance graph.
          The detailed marshaling is best studied from the comments in
          ValueBase.cpp.

        * tao/ValueFactory.h [new]:
        * tao/ValueFactory.i [new]:
        * tao/ValueFactory.cpp [new]:
        * tao/ValueFactory_Map.h [new]:
        * tao/ValueFactory_Map.i [new]:
        * tao/ValueFactory_Map.cpp [new]:
          The map of registered valuetype factories.
          TAO_OBV_REGISTER_FACTORY macro is for on the fly factory
          registration, but its not like in the OMG specs.

        * tao/ORB.h:
        * tao/ORB.cpp:
          Integration of the factory map for valuetypes with the ORB.
          It is accessed through CORBA_ORB::register_value_factory (),
          unregister_value_factory () and lookup_value_factory ().
          This needs some revision to make the changing of the map thread
          safe and changes to make it per ORB and not per process as it is
          currently.

        * */Makefile:
          Many makefile dependencies updated.

        * examples/Simple/chat/Makefile:
          The dependencies did not include Client_i.cpp or Server_i.cpp

        * orbsvcs/tests/Trading/Makefile:
          Added dependencies to for parallel compilation.

Thu May  6 09:24:30 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/EC_Throughput/ECT_Supplier.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Consumer.cpp:
          Small changes in debugging messages.

Wed May 05 15:11:26 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/Time_Utilities.i (Time_Value_to_TimeT):
          replaced static cast of ACE_ONE_SECOND_IN_NSECS to ACE_UINT32
          with ACE_U_ONE_SECOND_IN_NSECS, so we don't cast away
          constness.

Wed May 05 13:07:49 1999  David L. Levine  <levine@cs.wustl.edu>

        * all Makefiles: replaced /bin/rm with $(RM) and /bin/mv with mv.

Wed May  5 12:58:14 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
          Calibrate the High_Res_Timer before starting the test.

        * orbsvcs/tests/EC_Throughput/ECT_Supplier.cpp:
          The last shutdown event was not properly initialized.

        * orbsvcs/tests/EC_Throughput/ECT_Driver.cpp:
          Corrected variance computation and use the
          ACE_High_Res_Timer::global_scale_factor() to map from
          ACE_hrtime_t to microseconds.

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
          Minor cosmetic fixes.

        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.cpp:
          For experimentation purposes the dispatching thread runs at a
          higher priority that the supplier threads. This minimizes the
          latency because the dispatching thread becomes runnable as soon
          as there is data available.
          Of course this will be controlled by the scheduler in production
          code.

Wed May 05 12:20:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_ObserverStrategy.cpp: added missing
          template instantiations for ACE_RB_Tree_Iterator_Base.  Thanks
          to David Levine for reporting this.

Wed May 05 09:52:18 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/CosEvent_Service/Makefile: added subset dependency
          on Event2, because it needs the TAO_EC_Event_Channel ctor.

Wed May  5 02:20:15 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corbafwd.h:
        * tao/Environment.{h,i,cpp}:
          Added _var and _out classes.

        * tao/Any.{h,i,cpp}:
          Edited the comment for the Any_var extraction
          operators, added the Any_out -> operator, which
          was missing, and made a cosmetic change to Any.cpp.

        * tao/Typecode.{h,i}:
          Moved the operator assigning a TypeCode_var to a
          TypeCode_out to private: and removed the
          implementation - it's not allowed.

Tue May  4 23:50:04 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corbafwd.h:
        * tao/ORB.{h,cpp}:
        * tao/Typecode_Constants.cpp:
          Added typedef'd strings ORBid to CORBA and
          ObjectId to CORBA_ORB, along with their typecodes.

          Also moved the typecode initialization for the exception
          InconsistentTypeCode out of ORB.cpp and into
          Typecode_Constants. Also cosmetized Typecode_Constants
          a little.

Tue May  4 21:46:31 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/driver/drv_preproc.cpp:
          Fixed memory managment problems with the new implicit option
          -I$TAO_ROOT/tao, also use $ACE_ROOT/TAO if TAO_ROOT is not
          defined and print a warning message if none is defined.

Tue May  4 21:15:51 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.h:
        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.i:
        * orbsvcs/orbsvcs/Event/EC_Dispatching_Task.cpp:
        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.h:
        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.i:
        * orbsvcs/orbsvcs/Event/EC_Priority_Dispatching.cpp:
          Added new Dispatching strategy that uses multiple threads (one
          per priority) and a queues to dispatch the events. This strategy
          allows invocations from high-priority suppliers to low-priority
          consumers or vice-versa with minimum priority inversion.
          It also decouples the collocated suppliers from the time spent
          in the collocated consumers.

        * orbsvcs/orbsvcs/Event/EC_Null_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.cpp:
          Added support for the new dispatching strategy and for Immediate
          changes in the supplier sets, but with locking.

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
          Before passing data to the dispatching module we increment the
          reference count, that way the dispatching module doesn't have to
          do it and we minimize locking overhead.

        * orbsvcs/orbsvcs/Event/Dispatching_Modules.cpp:
          Minor cosmetic changes.

        * orbsvcs/tests/EC_Throughput/ECT_Consumer.cpp:
          Enabled debug message if an empty event is received.

        * orbsvcs/tests/EC_Throughput/ec.conf:
        * orbsvcs/tests/EC_Throughput/ec.mt.conf:
          Added new configuration for Priority_Dispatching strategy.
          Re-ordered options in old configuration to match the new one.

Tue May  4 20:23:37 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Any.{h.cpp}:
          Change the signature of the constructor
            CORBA_Any (CORBA::TypeCode_ptr type,
                       const ACE_Message_Block* mb)

          to

            CORBA_Any (CORBA::TypeCode_ptr type,
                       COREBA::UShort dummy,
                       const ACE_Message_Block* mb)

          in order to avoid ambiguity with a call to

            CORBA_Any (CORBA::TypeCode_ptr type,
             void *value = 0,
             CORBA::Boolean any_owns_data = 0)

          where the second arg is NULL and the third arg
          is left out.

        * tao/DynArray_i.cpp:
        * tao/DynEnum_i.cpp:
        * tao/DynSequence_i.cpp:
        * tao/DynStruct_i.cpp:
        * tao/DynUnion_i.cpp:
        * tao/Invocation.cpp:
        * tao/Typecode.cpp:
          Changed the signature of all the calls to the above
          constructor.

        * orbsvcs/orbsvcs/AV/AVStreams_i.cpp:
          Fixed the '*/ outside of comment' warning.

Tue May  4 20:17:41 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tao/CORBA.pidl: New file for adding entries that would generate
          new typecodes.

1999-05-04  Seth Widoff  <swidoff@cs.cmu.edu>

        * orbsvcs/orbsvcs/Makefile:
        * orbsvcs/orbsvcs/CosTrading.idl:
        * orbsvcs/orbsvcs/CosTradingRepos.idl:
        * orbsvcs/orbsvcs/CosTradingDynamic.idl:
          Broke the CosTrading.idl file up so that each idl file
          gets one module.

        * orbsvcs/orbsvcs/Trader/Offer_Iterators.{h,cpp}:
        * orbsvcs/orbsvcs/Trader/Trader.h:
        * orbsvcs/orbsvcs/Trader/Trader_Interfaces.{h,cpp}:
        * orbsvcs/orbsvcs/Trader/Trader_T.{h,cpp}:
        * orbsvcs/orbsvcs/Trader/Trader_Utils.{h,cpp}:
          For the stem_id used in federated query, obliterated the calls
          to rand_r, since they apparently return -1 on NT. Since random
          numbers were kind of a cludge anyway, the trader now establishes
          a unique sequence number space by generating a prefix consisting
          of IP address and process id. If the trader is running on a
          machine without an IP address, then it defaults to a random
          prefix (using plain old rand, this time). Thanks to
          Ulf Jährig <ujaehrig@desys.com> for pointing this problem out.

          I also adapted all servants in the trader to use POA reference
          counting.

        * orbsvcs/tests/Offer_Exporter.cpp:
        * orbsvcs/tests/TT_Info.cpp:
          Fixed the includes to respect the new idl file schema.

Tue May  4 17:45:43 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO/tao/orb.idl:
          Added this file as required by CORBA spec. Contains only
          empty interface defs for ORB, TypeCode and Object, inside
          module CORBA, so the IDL compiler can recognize 'CORBA::'
          scoped versions of the above. Interface defs suggested by
          Carlos, who also says we may need to add to them later.

        * TAO_IDL/driver/drv_preproc.cpp:
          Added a line to include the $TAO_ROOT/tao directory in the
          preprocessor invocation, so it can find orb.idl.

Tue May  4 14:11:43 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/sfp.cpp: Fixed the misinterpretation of the
          credit message where I was adding the cred_num field to the
          allowed credit. Its actually a sequence number and the credit
          doesn't change for a session. Thanks to Leif Jakobsmeier
          <leif@cs.uni-frankfurt.de> for pointing this out.

Tue May  4 12:34:08 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/orbconf.h:
        * TAO_IDL/be/be_helper.cpp:
          The IDL compiler can use either templates or explicit code for
          the classes mapped from IDL sequences.  I cleaned up the macros
          to control which scheme is used by default on each platform.
          The complete documentation is in orbconf.h next to
          TAO_USE_SEQUENCE_TEMPLATES

Tue May 04 12:15:06 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/Object_Adapter.cpp (dispatch_servant_i): replaced
          direct comparison of ACE_thread_t's with ACE_OS::thr_equal ().
          Thanks to Steven D. Chen <sdc2951@aw101.iasl.ca.boeing.com>
          for reporting this on HP-UX and for verifying the fix.

Tue May 04 12:03:52 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/Makefile,tmplinst-orbsvcs.cpp:
          removed tmplinst-orbsvcs.cpp, because none of its
          explicit instantiations appear to be used.

          Arranged orbsvcs subsets so that the Naming Service
          is always built.  Many examples and tests need it.

        * docs/configurations.html: removed note about orbsvcs
          subsets not considering dependencies between the services.
          The hard-coded dependencies and Makefile dependencies
          should take care of that now.

Tue May  4 09:47:04 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_ObserverStrategy.cpp:
          Completed implementation of the EC_Basic_ObserverStrategy.
          Fixed computation of the consumers subscription list.
          Thanks to J. Russell Noseworthy <rnosewor@objectsciences.com>
          for helping out with this.

        * orbsvcs/orbsvcs/Event/EC_Event_Channel.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
        * orbsvcs/orbsvcs/Event/EC_SupplierAdmin.h:
        * orbsvcs/orbsvcs/Event/EC_SupplierAdmin.cpp:
          Added locking on the SupplierAdmin object, the ConsumerAdmin
          does not need it since the locking is handled by its
          SupplierSet.

        * orbsvcs/orbsvcs/Event/EC_Gateway.cpp:
          Cleaned up publication list computation, thanks to J. Russell
          Noseworthy <rnosewor@objectsciences.com> for helping out with
          this.

        * orbsvcs/Event_Service/svc.conf:
          Added locks for the ConsumerAdmin and SupplierAdmin modules.

        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
          Minor cosmetic fixes.

        * orbsvcs/tests/EC_Mcast/svc.conf:
          Added the right configuration options for the new EC.

        * orbsvcs/tests/EC_Mcast/EC_Mcast.cpp:
          Added initialization of the EC_Default_Factory.
          Workaround what appears to be a bug in glibc2 implementation of
          rand_r(), it returns negative values but it should only return
          numbers in the range [0,RAND_MAX)

Mon May  3 23:46:31 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/driver/drv_preproc.cpp:
          Added a line to suppress inclusion of "fooC,h" and
          "fooS.h" if foo.idl is "orb.idl". We're not
          fully functional with '#include <orb.idl>' yet -
          more changes to come.

Mon May 03 22:02:34 1999  David L. Levine  <levine@cs.wustl.edu>

        * TAO_IDL/include/ast_expression.h: reverted replacement of
          LongLong with Long for GreenHills/Solaris, because it'll
          take a lot more than that.

Mon May 03 21:57:56 1999  David L. Levine  <levine@cs.wustl.edu>

        * TAO_IDL/tao_idl.cpp,TAO_IDL/be/be_init.cpp,
          TAO_IDL/driver/drv_{args,fork,preproc}.cpp,
          TAO_IDL/fe/fe_init.cpp,TAO_IDL/fe/lex.yy.cpp:
          replaced exit (n) with ACE_OS::exit (n).  Thanks
          to Steve Huston for reporting this abomination.

Mon May  3 18:31:25 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO/examples/POA/DSI/Database_i.{h,cpp}:
          Updated format of a CORBA::NO_IMPLEMENT exception and
          removed a leading underbar from an 'is_a' so that
          declaration, definition and call signature all agree.

Mon May  3 17:19:26 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Any.{h,i}:
          Added insertion and extraction operators for Any_var.
          CORBA spec requires these for all copying insertion
          operators defined as members of Any. The extraction
          operators are there as a tip of the hat to user of
          other ORBs that may be used to them.

Mon May  3 16:09:24 1999  Ossama Othman  <othman@cs.wustl.edu>

        * tao/IIOP_Server_Reqeust.*:
        * tao/GIOP_Server_Request.*:

          Changed all references to IIOP_ServerRequest to GIOP_ServerRequest
          since the implementation is GIOP-specific, not IIOP-specific.

        * tao/UIOP_Server_Request.*:

          A UIOP-specific ServerRequest class is no longer needed since
          the UIOP case falls under the GIOP case.  Removed these files.

        * tao/Connect.cpp:
        * tao/UIOP_Connect.cpp:

          Changed references to IIOP_ServerRequest and UIOP_ServerRequest
          to GIOP_ServerRequest since both transport protocols fall under
          GIOP.

Mon May  3 15:53:45 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/include/AST_Expression.h:
          Used #if defined (ACE_LACKS_LONGLONG_T) to conditionally
          define a longlong and unsigned longlong as a long and
          an unsigned long, respectively. This in only to make
          GreenHills/Solaris happy. Thanks to David Levine for
          reporting the problem.

Mon May 03 15:26:19 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/Object_Adapter.h: added "class" in friend
          declarations.

Mon May 03 10:39:33 1999  David L. Levine  <levine@cs.wustl.edu>

        * TAO version 0.3.21 released.

Mon May 03 10:18:24 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/NestedUpcall/MT_Client_Test/Makefile:
          removed unused orbsvcs references.

Mon May 03 10:04:00 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/POA/Demux/Makefile,
          tests/InterOp-Naming/Makefile: only build if the
          orbsvcs library was built with the Naming component.

Mon May 03 09:46:31 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/DII_Cubit/Makefile: removed
          use of orbsvcs headers and lib.  They're no longer needed.

Sun May 02 22:11:42 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/Makefile: always build Trader with LifeCycle.

Sun May 02 22:09:42 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/CosEvent/{Consumer,Supplier}Admin_i.cpp,
          EventChannel_i.cpp,ProxyPush{Consumer,Supplier}_i.cpp:
          added auto_ptr and ACE_Auto_Basic_Ptr explicit instantiations,
          for old g++.

Sun May 02 22:05:46 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Default_Factory.cpp (create_dispatching):
          put ??? in a comment, so that old g++ doesn't complain
          about encountering a trigraph.

Sun May  2 15:57:33 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_client/Command_Handler.cpp:
          Removed the call to remove_handlers () in the ~Command_Handler
          to avoid double deletion of the signal handler.

Sun May 02 14:47:58 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp: removed
          ACE_Reverse_Lock<ACE_Lock> and ACE_Guard<ACE_Reverse_Lock<ACE_Lock> >
          explicit template instantiations because they're in
          tao/Object_Adapter.cpp.

Sun May 02 14:32:44 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/Time_Utilities.i (Time_Value_to_TimeT):
          added static cast of ACE_ONE_SECOND_IN_NSECS to ACE_UINT32
          so that it will compile with ACE_LACKS_U_LONGLONG_T.

Sun May 02 14:02:23 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/Makefile: always build Sched with Event
          or Event2.  Added dependency on Event's IDL_SRC's.  Thanks
          to Carlos for letting me know that these are necessary.
          Reordered subset support to be top-to-bottom, so that
          lower level services can be easily included if needed
          only by higher level services.

        * orbsvcs/Event_Service/Makefile,orbsvcs/tests/EC_Throughput/Makefile:
          added dependency on TAO_ORBSVCS Naming.  Thanks to Carlos for
          pointing out that these modules use Naming.

Sun May 02 11:55:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * orbsvcs\orbsvcs\Sched\Reconfig_Scheduler.{cpp, h, i} (new)
          orbsvcs\orbsvcs\Scheduler_Factory.h: Very early draft
          of the reconfigurable scheduler implementation.

Sun May 02 08:15:50 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/Context.cpp: removed ACE_Unbounded_Queue<char *>
          explicit instantiations, because they're in ace/ARGV.cpp
          (except ACE_HAS_MOSTLY_UNICODE_APIS, which we only use on
          WIN CE).

Sun May  2 00:12:40 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_client/Command_Handler.cpp:
          Fixed the code to restart the event loop for Audio Buffer and
          Video Buffer process for the java init case when the Java Gui
          sends ior to the mpeg client.

        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_mib/mibButton.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_mib/mibLabel.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_mib/mibList.cpp:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_mib/mibToggle.cpp:
          Fixed compilation errors for using unsigned char * instead of
          XmString on SunOS5.7 CC 4.2. Thanks to Bala for helping with this.

        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_server/Globals.h:
          Fixed a redundant redinition warnings for macros nextByte and
          computePicSize.

        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_shared/routine.{h,cpp}:
          Fixed void usleep to int usleep to avoid ambiguity errors on
          SunOS5.7 CC 4.2.

        * orbsvcs/tests/AVStreams/mpeg/source/server/Machine_Properties.cpp:
          Redefined xdr_void to int xdr_void (XDR *,void *) to fix
          compilation errors on SunOS5.7 CC 4.2.

Sat May  1 23:30:08 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/AVStreams_i.{h,cpp}:
        * orbsvcs/orbsvcs/AV/AVStreams_i_T.{h,cpp}:
        * orbsvcs/orbsvcs/AV/Endpoint_Strategy_T.cpp:
          Added the correct implementation of destroy method according to
          Irfan's suggestion.  Also corrected some TAO_ macros used for
          exceptions.

Sat May  1 22:01:41 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/CosEvent_Service/CosEvent_Service.h:
          added virtual destructors.

Sat May  1 21:01:40 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_argument/compiled_marshal_cs.cpp: Stub
          code generation was not checking inout args for the char, wchar,
          boolean and octet cases, where the Any::to_* structs must be
          used when demarshaling. Result was 'ambiguous >> operator' error
          in compilation. Added the switch statement, checks and code
          generation. Thanks to englishmalc@my-dejanew.com for reporting
          this bug.

Sat May  1 17:44:34 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * tao/ORB.cpp (multicast_query): Make sure we close down the
          ACE_SOCK_Acceptor so we don't leak handles.  Thanks to Vishal
          and James Johnson for tracking this down.

1999-05-01  Vishal Kachroo  <vishal@cs.wustl.edu>

        * orbsvcs/orbsvcs/Time_Utilities.i: Fixed the precision error.
          Use 64-bit precision for 64bit*32bit operation.  Thanks to
          Tom Venturella <Thomas.Venturella@MW.Boeing.com> for reporting
          that is had been using only 32-bit precision.

Sat May  1 15:06:40 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * tao/Typecode.cpp (parameter): Changed the variable env to
          ACE_TRY_ENV in CORBA_TypeCode::parameter method.

Sat May  1 13:32:13 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * orbsvcs/orbsvcs/Property/CosPropertyService_i.cpp : Fixed the
        g++ warnings.

1999-05-01  Vishal Kachroo  <vishal@cs.wustl.edu>

        * orbsvcs/orbsvcs/IOR_Multicast.cpp (handle_input):
          Added stream.close () after stream.send_n () to explicitly
          close the socket.

          Thanks to James Johnson <jcej@lads.com> for finding this bug
          and suggesting the fix.

Sat May 01 08:22:12 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/IDL_Cubit/run_test.pl:
          check to see that the executables exist before trying
          to run them.

Sat May 01 03:03:47 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * orbsvcs/orbsvcs/CosEvent/ConsumerAdmin_i.h:
        * orbsvcs/orbsvcs/CosEvent/ProxyPushConsumer_i.{h,cpp}:
        * orbsvcs/orbsvcs/CosEvent/ProxyPushSupplier_i.{h,cpp}:
        * orbsvcs/orbsvcs/CosEvent/SupplierAdmin_i.h:
        * orbsvcs/orbsvcs/CosEvent/Event_Channel_i.h:
        * orbsvcs/orbsvcs/Event/Event_Channel.h: Disable MSVC's warning
          4250.

        * tao/tao[_static].dsp: Added IIOP_Server_Request.{h,i,cpp}.

Fri Apr 30 21:43:29 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * orbsvcs/tests/Property/server.cpp
        * orbsvcs/tests/Property/README
        * orbsvcs/tests/Property/client.cpp
        * orbsvcs/tests/Property/client.h
        * orbsvcs/tests/Property/main.cpp
        * orbsvcs/tests/Property/server.cpp
        * orbsvcs/orbsvcs/Property/CosPropertyService_i_T.h:
        * orbsvcs/orbsvcs/Property/CosPropertyService_i.cpp:
        * orbsvcs/orbsvcs/Property/CosPropertyService_i.h:
        * orbsvcs/orbsvcs/Property/CosPropertyService_i_T.cpp:
        Update the code to use ACE exception macros.
        Also updated the destroy method semantics to do POA deactivate.
        Removed unnecessary ACE_DEBUG's from the code.

Fri Apr 30 20:06:44 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Typecode_Constants.cpp:
          Fixed a bunch of 'Memory in Use' reports from Purify
          reported by Irfan. Of a group of 10 Policy-related
          Typecodes in init(), only 3 had been added to fini().

Fri Apr 30 19:55:26 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/orbsvcs/CosEvent/EventChannel_i.*:
        * orbsvcs/orbsvcs/CosEvent/ConsumerAdmin_i.*:
        * orbsvcs/orbsvcs/CosEvent/SupplierAdmin_i.*:
        * orbsvcs/orbsvcs/CosEvent/ProxyPushSupplier_i.*:
        * orbsvcs/orbsvcs/CosEvent/ProxyPushConsumer_i.*:
        modified the CosEvent Channel to use reference counted
        servants.

Fri Apr 30 19:05:32 1999  Ossama Othman  <othman@cs.wustl.edu>

        * tao/Server_Request.*:
        * tao/IIOP_Server_Request.*:
        * tao/UIOP_Server_Request.*:

          Moved IIOP specific stuff from Server_Request.* to
          IIOP_Server_Request.*.  Created UIOP-specific UIOP_Server_Request
          files based on the IIOP ones.

        * tao/Makefile:

          Added IIOP_Server_Request files to the Makefile and updated the
          dependencies.

        * tao/UIOP_Connect.{h,i,cpp}:

          Rough implementation of UIOP connection handlers based on the IIOP
          connection handlers.  Not operational yet.

        * tao/Connect.*:

          Changed all references of TAO_SVC_HANDLER to TAO_IIOP_SVC_HANDLER.

        * tao/LSOCK_*:
        * tao/UIOP_*:

          Changed all references of "LSOCK" to "UIOP" (except for ACE
          related LSOCK references).  Renamed all `LSOCK*' files to
          `UIOP*'.  Thanks to Fred for motivating these naming
          conventions.

Fri Apr 30 18:46:10 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_sunsoft.cpp:
          Added a couple of cases to the character constant switch
          that eliminated the IDL compiler error messages
          produced from one of the test IDL files in the OMG tests.
          I don't think all of the IDL compiler tests have been run
          yet, so there may remain more to be done.

Fri Apr 30 17:41:31 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Typecode.{h,cpp}:
          Added a parameter() function. Although this function is gone
          from CORBA2.3a, it is still in 2.2 (though deprecated).

          Also found twp methods, ulong_param and typecode_param, that
          were internal hacks to use until other member functions had
          been written. They were never part of the spec and not now
          used by anything in TAO, orbsvcs, or any of the tests or
          examples, so they have been removed.

Fri Apr 30 14:06:41 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * COPYING: Updated the COPYING file to reflect the use new of
          ACE(TM) and TAO(TM).

Fri Apr 30 12:42:06 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * TAO_IDL/be/be_interface.cpp:
        * TAO_IDL/be/be_visitor_interface/interface_ch.cpp:
        * TAO_IDL/be/be_visitor_interface/interface_sh.cpp:
        * TAO_IDL/be/be_visitor_interface/tie_sh.cpp:
        * TAO_IDL/be/be_visitor_operation/arglist.cpp:
        * TAO_IDL/be/be_visitor_operation/operation_sh.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_bounded_obj_sequence_ch.cpp:
        * TAO_IDL/be/be_visitor_sequence/gen_unbounded_obj_sequence_ch.cpp:
          Generate CORBA::default_environment() instead of
          CORBA::Environment::default_environment. It is easier to
          generate code for the TAO library that way and it is slightly
          more efficient.

        * orbsvcs/orbsvcs/Event/EC_ConsumerAdmin.cpp:
        * orbsvcs/orbsvcs/Event/EC_ConsumerAdmin.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.h:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.i:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.h:
        * orbsvcs/orbsvcs/Event/EC_SupplierAdmin.cpp:
        * orbsvcs/orbsvcs/Event/EC_SupplierAdmin.h:
          Added support for reference counting of ProxyPushConsumer and
          ProxyPushSupplier objects.
          Also fixed the initialization of the default_POAs for those
          classes and the Admin interfaces.
          Added strategized locking to the

        * tao/Context.h:
        * tao/Context.cpp:
          Use CORBA::defaul_environment() instead of
          CORBA::Environment::default_environment() that way we can
          include Context.h without requiring Environment.h
          Also reordered some includes in the .cpp file to validate the
          Context.h file on its own.

        * tao/IOR_LookupTable.cpp:
        * tao/ORB.cpp:
          Protected some debug messages with TAO_debug_level. Also added a
          few more to check the iioploc support.

Fri Apr 30 11:58:23 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/Request.{h,cpp} (operator[]): Changed the return type from
          "const CORBA::Request_ptr" to "const CORBA::Request*".

        * orbsvcs/orbsvcs/AV/AVStreams_i.cpp (connect): Reordered the code
          to avoid putting compiler specific code here.

Fri Apr 30 02:05:22 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * performance-tests/Cubit/TAO/IDL_Cubit/Cubit_i.cpp
          (Cubit_Factory_i): Make sure to deactivate the cubit servant (in
          addition to cubit factory servant) from the POA.

        * tao/TAO.cpp (deactivate_under_child_poa and deactivate): The
          code was incorrect in assuming that the <id> parameter is the
          object id; it is actually the ior. Anyway, it should work now.

Fri Apr 30 01:56:37 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corbafwd.h;
        * tao/Request.{h,cpp}:
        * tao/ORB.{h,cpp}:
          Added the RequestSeq class, inherited from
          TAO_Unbounded_Sequence. Used as an arg in the
          (no-op) new ORB functions send_multiple_requests_oneway()
          and send_multiple_requests_deferred(), although the
          RequestSeq class itself is fully functional, should any
          of this ever really get implemented.

          Added several spec-required ORB functions:
          - create_environment()
          - create_exceptions()
          - create_context_list()
          - create_named_value()
          - get_default_context()
          - send_multiple_requests_onewasy()
          - send_multiple_requests_deferred()
          - get_next_response()
          - poll_next_response()
          All of these are no-ops and just throw CORBA::NO_IMPLEMENT.

Fri Apr 30 00:40:44 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * examples/POA/On_Demand_Loading/Server_Manager.h:
        * examples/POA/On_Demand_Loading/Servant_Activator.h:
        * examples/POA/On_Demand_Loading/Servant_Loader.h:
          Changed TAO_TRY to ACE_TRY macros.
        * examples/POA/On_Demand_Loading/Server_Manager.cpp:
        * examples/POA/On_Demand_Loading/Servant_Activator.cpp:
        * examples/POA/On_Demand_Loading/Servant_Loader.cpp:
          Added ACE_NEW_DECLARE_CORBA_ENV instead of ACE_TRY_NEW_ENV
          and also changed the CORBA::OBJECT_NOT_EXIST() exception
          to fit the current api.
        * examples/POA/Loader/Server_Manager.h:
        * examples/POA/Loader/Servant_Activator.h:
        * examples/POA/Loader/Servant_Loader.h:
          Changed TAO_TRY to ACE_TRY macros.
        * examples/POA/Loader/Server_Manager.cpp:
        * examples/POA/Loader/Servant_Activator.cpp:
        * examples/POA/Loader/Servant_Loader.cpp:
          Added ACE_NEW_DECLARE_CORBA_ENV instead of ACE_TRY_NEW_ENV
          and also changed the CORBA::OBJECT_NOT_EXIST() exception
          to fit the current api.

Thu Apr 29 22:12:25 1999  Marina Spivak  <marina@cs.wustl.edu>

        * orbsvcs/tests/Simple_Naming/client.cpp:
        modified the dummy servants to use POA reference counting.

Thu Apr 29 19:58:03 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * examples/Simple: Added the new time-date example, which
          will illustrate how to dynamically link an ORB via the
          svc.conf!

Thu Apr 29 19:53:09 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/TAO.dsp:
        * tao/TAO_Static.dsp:
          Added corbafwd.h and Invocation.h to the projects.

Thu Apr 29 19:21:14 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Object_Adapter.cpp (find_servant_i): We are grabbing the
          lock in this function when we had already grabbed it in
          find_servant().  This causes a deadlock when the lock are
          non-recursive (i.e., on all non-NT platforms).  Thanks to Marina
          for helping with this.

Thu Apr 29 19:28:49 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Request.{h,i,cpp}:
        * tao/Object.cpp:
          Added the contexts() and env() operations to Request.
          Since this involved adding an env_ member to Request,
          I modified Objects's _create_request and _request
          methods to pass along their environment args to the
          Request constructors, whicn were also modified to
          accept them and initialize env_. This won't change the
          signature or the functionality of any existing code.

Thu Apr 29 19:16:04 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/AVStreams_i.cpp (connect):
          Fixed a Vxworks warning for ACE_NOTREACHED in the connect
          function.Thanks to Irfan for pointing this out.

Thu Apr 29 18:35:52 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Request.{h,cpp}:
          Added no-op versions of send_deferred, get_response,
          and poll_response. These just throw CORBA::NO_IMPLEMENT.

Thu Apr 29 17:28:36 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        Added support to allow Policy objects to be locality constraint.
        This reduces the footprint of TAO when policy objects will never
        be accessed remotely.  You can enable this feature by defining
        TAO_HAS_LOCALITY_CONSTRAINT_POLICIES.

        * tao/POAC.{h,cpp}:
        * tao/CurrentS.cpp:
        * tao/POAS.{h,i,cpp}:
        * tao/POA_CORBA.h
        * tao/PolicyS.cpp: Other than supporting locality constraint
          policies, also removed unused op_tables, skeletons, stubs.

Thu Apr 29 16:33:31 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp: added
          ACE_Guard<ACE_Reverse_Lock<ACE_Lock> > explicit instantiation,
          for old g++.

Thu Apr 29 16:23:15 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * TAO_IDL/COPYING.sun: Split out the copyright information
          from the INSTALL.sun file.

Thu Apr 29 15:58:30 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO/performance-tests/Pluggable/PP_Test_Server.{h,cpp}:
        * TAO/performance-tests/Pluggable/server.dsp:
          Fixed servant deletion to deactivate under the POA
          before doing so. Also added some files to the server
          MSVC project for convenience.

Thu Apr 29 13:59:23 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/Context.cpp: replaced # that was inadvertantly
          removed by last change.

Thu Apr 29 13:57:33 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Context.cpp:
          Fixed an include problem that was causing string_dup
          and string_free not to be found when linking to TAO.

Thu Apr 29 12:15:22 1999  Marina Spivak  <marina@cs.wustl.edu>

        * orbsvcs/orbsvcs/Naming/Hash_Naming_Context.cpp
        * orbsvcs/orbsvcs/Naming/Persistent_Naming_Context.cpp:
        Provided a temporary fix for the <destroy> methods, to avoid
        crashing since the new POA changes.  Appropriate fix will be
        committed soon together with the restructured version of Naming
        implementation classes.

        * orbsvcs/tests/Simple_Naming/client.cpp:
        Updated for servants to deregister from POA before being destroyed.

Thu Apr 29 10:36:59 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/Servant_Base.{h,cpp}: Changed the type of ref_count_ to
          CORBA::ULong and removed the template instantiation for
          Atomic_Ops.

Thu Apr 29 09:34:40 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/MT_Cubit_Test:
          check to see that the executables exist before trying
          to run them (and wait for the ior file to be created).

Thu Apr 29 06:41:34 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/Context.cpp: removed ACE_Atomic_Op<ACE_SYNCH_MUTEX, CORBA::ULong>
          explicit instantiation because it was already in
          Exception.cpp.

Thu Apr 29 02:54:04 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * lots of .cpp files: Removed "TAO_DEFAULT_MINOR_CODE,
          CORBA::COMPLETED_NO" from many system exception instantiations
          because they are what the default constructors use.  Thanks to
          Irfan for suggesting this.

Thu Apr 29 01:23:03 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/POA (policies): Fixed destroy() methods of the policies by
          (a) removing "delete this" from the destroy() function, and (b)
          using servant/POA reference counting.

          The new destroy() function simply removes self from POA.
          Because of reference counting, the POA will automatically delete
          the servant when all pending requests on this servant are
          complete.

        * tao/Object_Adapter.cpp (TAO_Object_Adapter): Fixed memory leak
          by deleting dynamically allocated lock.

Wed Apr 28 21:16:55 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/MessagingS.h: Removed inclusion of MessagingS_T.h.  Old g++
          cannot handle nested template classes properly.  This is the
          same reason we cannot compile examples/POA/TIE with old g++.

        * docs/Options.html: Removed -ORBpoa <global/tss> option since it
          does not make sense in the new ORB/POA architecture.

        * examples/Simple/echo/server.dsp:
        * examples/Simple/echo/client.dsp:

          Added release dependencies to the IDL compiler.

        * examples/POA/Reference_Counted_Servant/server.dsp: Updated this
          since some source files were removed.

        * examples/POA/Explicit_Activation/server.cpp (main): Added the
          use of SINGLE_THREAD_MODEL POA policy.  This helps in MT
          debugging of the POA.

Wed Apr 28 19:03:34 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/corbafwd.h:
        * tao/Context.{h,i,cpp}:
          Added an implementation of ContextList, based on TAO's
          implementation of ExceptionList, since the IDL definitions
          and the C++ mappings are very similar. Also added
          ContextList_var and ContextList_out classes.

          Added the methods from the OMG C++ mapping for Context.
          Since our support for Context is intentionally minimal,
          these methods just throw CORBA::NO_IMPLEMENT. Wherever
          a Context_ptr is used as an argument in TAO, the only
          value it may have is 0 (or the above exception is raised).

        * Exception.h:
          Added the _var_type typedef to class Exception. It wouldn't
          compile before, because of a (just-discovered) typo in
          corbafwd.h.

Wed Apr 28 18:52:49 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Object_Adapter:

          - Single_Threaded_POA_Lock: This class helps us by locking
            servants in a single threaded POA for the duration of the
            upcall.  Single_Threaded_POA_Lock has a magic constructor and
            destructor.  We acquire the servant lock in the constructor.
            We release the servant lock in the destructor.

        * tao/POA:

          - Added appropriate code for establishing and tearing down locks
            for servants in POAs with the SINGLE_THREAD_MODEL policy.

        * tao/Servant_Base:

          - Added a lock pointer to the servant base class.  This lock
            will be created when the servant is registered with a single
            threaded poa and removed/deleted when the servant is
            deactivated from the POA.

            Note that because a servant maybe registered with multiple
            single threaded POAs simultaneously, we do reference counting
            on this lock.

Wed Apr 28 18:05:38 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * orbsvcs/orbsvcs/orbsvcs[_static].dsp: Fixed dependencies of some
          idl files.

Wed Apr 28 15:21:33 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/TAO.cpp (deactivate_under_child_poa and deactivate): Changed
          object_id to object_id.in ().

Wed Apr 28 16:21:02 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/DII_Cubit/Makefile:
          moved BUILD definition to after wrapper_macros.GNU include,
          because that would always clobber it.  Thanks to Irfan
          for reporting that the IDL_Cubit server didn't get built
          first without this change.

Wed Apr 28 15:56:23 1999  Carlos O'Ryan  <coryan@JIG>

        * tao/orbconf.h:
        * tao/MessagingC.h:
        * tao/MessagingC.cpp:
        * tao/MessagingS.h:
        * tao/MessagingS.cpp:
        * tao/Policy_Manager.h:
        * tao/Policy_Manager.cpp:
        * tao/TAO.dsp
        * tao/TAO_Static.dsp
          Added the Messaging components to the NT build, not very
          relevant since this are just the skeleton features that we will
          need, but good for validation.

        * tao/MessagingS_T.i:
        * tao/MessagingS_T.cpp:
          Fixed problems under HP-UX/aCC thanks to Brian Wallis
          <Brian.Wallis@sr.com.au> for initially reporting this problem
          and helping us with the fix validation.

Wed Apr 28 14:00:20 1999  Carlos O'Ryan  <coryan@JIG>

        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.h:
        * orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp:
        * orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i.cpp:
          Added @@ comments for Pradeep.

Wed Apr 28 10:07:54 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/POA/Reference_Counted_Servant/Makefile: added PSRC
          and re-ran make depend.  The old dependencies had a syntax error.

Wed Apr 28 09:47:05 1999  David L. Levine  <levine@cs.wustl.edu>

        * TAO/tests/CDR/octet_sequence.cpp: replaced use of cout
          with ACE_DEBUG statements.  Thanks to James D. Rucker
          <jdrucker@huey.jpl.nasa.gov> for reporting that it
          didn't build on VxWorks.

Wed Apr 28 09:19:24 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/ORB_Core.cpp:
          ORB_init() was crashing if argv was nil or argc was 0, thanks to
          David for reporting this one.

        * tao/ORB.cpp:
          Use double checked pattern to reduce locking overhead in
          CORBA::instance(), the method is invoked on the critical path,
          that needs fixing too. Thanks to Irfan for reporting this
          problem.

        * tao/Exception.cpp:
          Added missing template instantiation.

Wed Apr 28 09:09:03 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/Event_Service/Makefile,
          orbsvcs/tests/EC_Mcast/Makefile,
          orbsvcs/tests/EC_Throughput/Makefile:
          require Event2 TAO_ORBSVCS component, instead of Event.

Wed Apr 28 03:20:42 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/Exception.{h,i,cpp}: Added a new class
          CORBA_ExceptionList_var and changed the class
          CORBA_ExceptionList to enable reference counting.  Fixed the
          constructor's signature of all CORBA_SystemException's derived
          classes.  Thanks to Ian Pepper <ian@aptest.ie> for reporting
          this.

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp: Added a typedef
          TAO_EC_Unlock to avoid MSVC errors.
          (reactive_push_to_consumer): Declared reverse_lock as
          TAO_EC_Unlock.

        * tao/corbafwd.h: Added typedef of ExceptionList_ptr and
          ExceptionList_var in CORBA's namespace.
          Added a macro definition TAO_DEFAULT_MINOR_CODE.

        * orbsvcs/orbsvcs/Trader/Locking.h: Changed system exception
          initialization signature using TAO_DEFAULT_MINOR_CODE.

        * lots of *.cpp files: Fixed system exception instantiations.

Wed Apr 28 02:07:42 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * created the directories orbsvcs/examples/CosEC/Factory
        * added the following files:
           orbsvcs/examples/CosEC/Factory/CosEventChannelFactory.idl:
            idl definition of the CosEventChannelFactory module.
           orbsvcs/examples/CosEC/FactoryCosEventChannelFactory_i.h:
           orbsvcs/examples/CosEC/Factory/CosEventChannelFactory_i.cpp:
            servant implementation of the CosEC Factory.
           orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i.h:
           orbsvcs/examples/CosEC/Factory/FactoryCosEventChannel_i.cpp:
            Decorator for the CosEventChannelAdmin::EventChannel servant.
           orbsvcs/examples/CosEC/Factory/FactoryClient.cpp:
            Client to test the Factory.
           orbsvcs/examples/CosEC/Factory/Makefile

Wed Apr 28 01:45:33 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * examples/POA/Generic_Servant/MyFooServant.cpp (timed_operation):
          Added a timed operation.  This can be used to see how the POA
          dispatches multiple upcalls simultaneously.

        * examples/POA/Reference_Counted_Servant/server.cpp
          (Reference_Counted_Foo): There is no need to completely redefine
          Reference_Counted_Foo.  Simply use the magic of multiple
          inheritance and inherit from PortableServer::RefCountServantBase
          and MyFooServant.

Wed Apr 28 00:44:59 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/CosEvent_Service/CosEvent_Service.{h,cpp}:
           modified to use the new RtEC.

Tue Apr 27 23:32:52 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/TAO.cpp (deactivate_under_child_poa and deactivate): Added
          new methods to deactivate the servant.

        * performance-tests/Cubit/TAO/IDL_Cubit/Cubit_Server.cpp
          (~Cubit_Server): Deactivate servant before deleting it.

Tue Apr 27 23:01:30 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        Added the directory $TAO_ROOT/performance-tests/POA/Demux and the
        following files for the POA Demux tests.

        * Makefile
        * README
        * client.cpp : client for the tests.
        * demux_stats.cpp : To calculate statistics out of the timeprobe
          data generated.
        * demux_test.idl : IDL used for the test.
        * demux_test_client.cpp : Makes calls on the remote objects
          parameterized by the no. of POAs, servants and operations.
        * demux_test_client.h:
        * demux_test_client.i: Helper class for the client.
        * demux_test_i.cpp : Servant Implementation.
        * demux_test_i.h:
        * demux_test_macros.h: Some #defines for the test.
        * demux_test_server.cpp: Server for the test. Parameterized by the
          POA ID policy, lifespan policy, no. of servants, operations.
        * demux_test_server.h
        * names_file: Names used by the servants.
        * poa_names_100.dat: Names used by the POAs.
        * server.cpp : server main program.
        * write_names.cpp : generates the names_file.

Tue Apr 27 22:35:10 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Object_Adapter.cpp: Fixed template instantiations and
          constructor initialization order problems.

Tue Apr 27 21:46:08 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * Eliminated priority inversion in the reactive dispatcher, we
          release the lock during the upcall to limit the time during
          which it is held.

        * orbsvcs/orbsvcs/Event/EC_Dispatching.cpp:
          Use the "reactive_push_to_consumer()" method in the
          ProxyPushSupplier to ensure that the lock is released during the
          upcall.

        * orbsvcs/orbsvcs/Event/EC_Filter_Builder.h:
        * orbsvcs/orbsvcs/Event/EC_Filter_Builder.cpp:
        * orbsvcs/orbsvcs/Event/EC_Basic_Filter_Builder.h:
        * orbsvcs/orbsvcs/Event/EC_Basic_Filter_Builder.cpp:
          The timeout "filters" need direct access to the
          ProxyPushSupplier.

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.h:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
        * orbsvcs/orbsvcs/Event/EC_Timeout_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Timeout_Filter.cpp:
        * orbsvcs/orbsvcs/Event/EC_Timeout_Generator.cpp:
          Added a new callback method to the ProxyPushSupplier used by the
          Timeout filters to correctly grab the lock before dispatching
          the timeout.
          We need to control access to this kind of callback interfaces,
          possibly using helper classes with "friend" access.

        * orbsvcs/tests/EC_Throughput/ec.conf:
        * orbsvcs/Event_Service/svc.conf:
          By default use a regular mutex in the ProxyPushSupplier, it is
          more efficient and works correctly.

Tue Apr 27 17:27:16 1999  Ossama Othman  <othman@cs.wustl.edu>

        * tao/LSOCK_Acceptor.{h,cpp}:
        * tao/LSOCK_Connector.{h,cpp}:
        * tao/LSOCK_Profile.{h,i,cpp}:
        * tao/LSOCK_Transport.{h,cpp}:

          These are the Unix Domain Socket pluggable protocol files for TAO.
          They are not operational yet, but getting them under CVS
          control at this point seems like a good thing to do.

Tue Apr 27 16:48:24 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/POA:

          - destroy_i: If the <wait_for_completion> parameter is TRUE, the
            destroy operation will return only after all requests in
            process have completed and all invocations of etherealize have
            completed. Otherwise, the destroy operation returns after
            destroying the POAs.

            If a servant manager is associated with the POA,
            ServantLocator::etherealize will be invoked with the oid and
            the servant. (The deactivate_object operation does not wait
            for the etherealize operation to complete before
            deactivate_object returns.)

            If the POA has no ServantActivator associated with it, the POA
            implementation calls _remove_ref when all operation
            invocations have completed. If there is a ServantActivator,
            the Servant is consumed by the call to
            ServantActivator::etherealize instead.

        * tao/Object_Adapter:

          - Non_Servant_Upcall: This class helps us with a recursive
            thread lock without using a recursive thread lock.
            Non_Servant_Upcall has a magic constructor and destructor.  We
            unlock the Object_Adapter lock for the duration of the
            non-servant (i.e., adapter activator and servant activator)
            upcalls; reacquiring once the upcalls complete.  Even though
            we are releasing the lock, other threads will not be able to
            make progress since
            <Object_Adapter::non_servant_upcall_in_progress_> has been
            set.

          - Outstanding_Requests: This class helps us by increasing
            <POA::outstanding_requests_> for the duration of the servant
            upcall. Outstanding_Requests has a magic constructor and
            destructor.  We increment <POA::outstanding_requests_> in the
            constructor.  We decrement <POA::outstanding_requests_> in the
            destructor.  Note that the lock is released after
            <POA::outstanding_requests_> is increased and
            <POA::outstanding_requests_> is decreased after the lock has
            been reacquired.

        * tao/Active_Object_Map:

          - Added <deactivated_> flag to each entry in the map. This flag
            is needed because there is a period of time between an
            object's deactivation and the etherealization (during which
            outstanding requests are being processed) in which arriving
            requests on that object should not be passed to its
            servant. During this period, requests targeted for such an
            object act as if the POA were in holding state until
            etherealize completes. If etherealize is called as a
            consequence of a deactivate call with a etherealize_objects
            parameter of TRUE, incoming requests are rejected.

          - bind_using_system_id(): Removed extra code: entry->system_id_
            = entry->user_id_; this was already happening in
            TAO_Active_Hint_Strategy::bind().

          - unbind_using_user_id(): Only unbind servant if non-zero.

        * tao/Servant_Base.h (TAO_ServantBase): Change reference count
          from ACE_Atomic_Op<ACE_SYNCH_MUTEX, CORBA::ULong> to
          ACE_Atomic_Op<ACE_SYNCH_MUTEX, long>.  This way we can utilize
          the InterlockedIncrement / InterlockedDecrement specializations
          for Atomic_Op on NT.

        * tao/ORB_Core.cpp (create_and_set_root_poa): Fixed POA
          constructor call.

        * tao/default_server.cpp (enable_poa_locking): Changed server
          factory to simply inform Object Adapter if POA locking should be
          enabled.  The Object Adapter will create the proper lock.

Tue Apr 27 16:40:00 1999 Chris Gill  <cdgill@cs.wustl.edu>

        * orbsvcs/orbsvcs/Sched/Config_Scheduler.cpp: added some additional
          structure member initializations to remove uninitialized memory
          reads that were being reported by Purify.

Tue Apr 27 15:04:14 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_union_branch/public_ci.cpp:
          Removed an incorrect "var" string appended to the
          local member name in the case where a union contains
          another union. Was causing a compile error in fooC.i.
          Thanks to Srikumar Kareti <skareti@htc.honeywell.com>
          for reporting this.

Tue Apr 27 12:01:38 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * orbsvcs/Event_Service/Event_Service.cpp (main): Changed to use
          TAO_EC_Default_Factory::init_svcs () to add the static service
          into service configurator.

        * orbsvcs/orbsvcs/AV/AVStreams_i.cpp (connect):
        * orbsvcs/orbsvcs/Naming/Persistent_Context_Index_T.cpp (init):
          Added ACE_NOTREACHED macros.  KAI compiler is pretty good at
          figuring out unreachable statements.

Mon Apr 26 16:49:24 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * TAO_IDL/fe/lex.yy.cpp: Redefined TAO_YY_BREAK as ACE_NOTREACHED
          (break;) and made sure it is used properly in the file.

Mon Apr 26 10:44:18 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Default_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
          Added helper method to register the default factory with the
          service configurator. This is needed on NT where the
          export/import madness does no allow us to use the static service
          declaration from outside the DLL.

        * orbsvcs/orbsvcs/orbsvcs.dsp:
        * orbsvcs/orbsvcs/orbsvcs_static.dsp:
          Added the new Event Channel files.

Mon Apr 26 09:16:51 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/tests/EC_Throughput/ECT_Driver.h:
        * orbsvcs/tests/EC_Throughput/ECT_Driver.i:
        * orbsvcs/tests/EC_Throughput/ECT_Driver.cpp:
          Encapsulated throughput measurements in a helper class.
          Added support for accumulating several latency measurements.

        * orbsvcs/tests/EC_Throughput/ECT_Consumer.h:
        * orbsvcs/tests/EC_Throughput/ECT_Consumer.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Consumer_Driver.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Supplier.h:
        * orbsvcs/tests/EC_Throughput/ECT_Supplier.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Supplier_Driver.cpp:
        * orbsvcs/tests/EC_Throughput/ECT_Throughput.h:
        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
          Added support for accumulated throughput and per-consumer
          latency.

        * orbsvcs/orbsvcs/Event/EC_Type_Filter.cpp:
          Fine tuned.

        * orbsvcs/orbsvcs/Event/EC_ProxyPushSupplier_Set.cpp:
          We should not raise an exception when removing a supplier,
          because we would need to filter out supplier removal too. It is
          enough to raise the exception from the SupplierAdmin module.

        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.cpp:
          Added debugging messages (currently commented out).

        * orbsvcs/orbsvcs/Event/EC_Filter.cpp:
          Added some @@ comments.

Mon Apr 26 05:35:12 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/TAO_Internal.{h,cpp}: Changed *_args to of type const char
          *.  Thanks to Andy for reporting this.

        * tao/TAO_Internal.{i,cpp} (default_svc_conf_entries): Moved to
          .cpp file and remove TAO_Internal.i from repository.

Sun Apr 25 16:59:59 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * TAO_IDL/fe/lex.yy.cpp: Added ACE_NOTREACHED to two redundant
          break statements.

        * TAO_IDL/ast/ast_expression.cpp (coerce_value): Removed a
          redundant return statement.

Sun Apr 25 16:05:19 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Basic_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Basic_Factory.i:
        * orbsvcs/orbsvcs/Event/EC_Basic_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Null_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Null_Factory.i:
        * orbsvcs/orbsvcs/Event/EC_Null_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.i:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp:
          The EC_Factories create a Supplier_Filter_Builder now. This
          simplifies some of the memory managment in the system: now the
          EC must handle the builder and the builder handles the object it
          creates.  I was able to lift a restriction of the factories
          implemented so far: they can be used from multile ECs now.

        * orbsvcs/orbsvcs/Event/EC_Supplier_Filter_Builder.h:
        * orbsvcs/orbsvcs/Event/EC_Supplier_Filter_Builder.i:
        * orbsvcs/orbsvcs/Event/EC_Supplier_Filter_Builder.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.h:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.i:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.cpp:
          The EC_Factory creates a factory object for the supplier-side
          filters. Analogous to the consumer-side filter builder.
          The ProxyPushConsumer uses this object to create its filter, but
          the creation is deferred until the user connects to the
          ProxyConsumer (as it is done in the consumer side).

        * orbsvcs/orbsvcs/Event/EC_SupplierFiltering.h:
        * orbsvcs/orbsvcs/Event/EC_SupplierFiltering.cpp:
        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.i:
        * orbsvcs/orbsvcs/Event/EC_Trivial_Supplier_Filter.cpp:
          Moved the trivial supplier-side filter to its own filter. Added
          a builder for it.

        * orbsvcs/orbsvcs/Event/EC_ConsumerAdmin.cpp:
        * orbsvcs/orbsvcs/Event/EC_SupplierAdmin.cpp:
          Fixed some problems with late registration of
          suppliers/consumers.

        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.h:
        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.i:
        * orbsvcs/orbsvcs/Event/EC_Per_Supplier_Filter.cpp:
          Fixed several bugs during consumer/supplier match. Also added a
          supplier filter builder for this type.
          The EC_Default_Factory has support for it too.

        * orbsvcs/orbsvcs/Event/EC_Filter_Builder.h:
          Fixed comments.

        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
          Use the new EC by default.
          Start the threads at the right priority.

        * orbsvcs/tests/EC_Throughput/ec.conf:
          Enabled the per-supplier filters by default.

        * Updated many makefiles.

Sat Apr 24 22:57:42 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_interface.cpp:
          Fixed a typo that was causing a derived interface's
          _set_xxx_skel method to call the base class'
          _get_xxx_skel method. Thanks to Kris Johnson
          <kjohnson@gardnersys.com> for pointing this out.

Sat Apr 24 08:51:11 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Factory.cpp:
          IRIX required an extra #include

Sat Apr 24 07:21:24 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/Global.cpp (get_high_priority):
          on VxWorks, fixed access of default_priority.  It's in the
          Globals singleton.

Fri Apr 23 18:11:42 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/ORB.cpp:
          Modified file_string_to_object() to use ACE::fopen
          instead of ACE::open. Formerly it was crashing when
          called from the MSVC debugger, due to a recent change
          made to plug a memory leak. This change (suggested by
          Carlos) will not support cool filename-within-file
          recursive behavior (past the file descriptor limit), but
          has the advantage of working with NT and causing no
          leaks on Unix.

Fri Apr 23 16:09:41 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/orbsvcs.dsp:
        * orbsvcs/orbsvcs/orbsvcs_static.dsp:
          Added EC_Default_Factory to the project files.

        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp:
          Added include file that is required on NT, but not on Unix,
          beats me.

Fri Apr 23 16:17:04 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/Globals.{h,cpp}:
          use ACE_THR_PRI_OTHER_DEF instead of ACE_THR_PRI_FIFO_DEF,
          and THR_NEW_LWP instead of THR_BOUND, if not using FIFO scheduling.
          Thanks to David H. Whittington <david.h.whittington@boeing.com>
          for testing these changes on HP/UX (where we're still not
          successful) and Irix (where we are successful), not running
          as root.

Fri Apr 23 11:12:29 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/Event_Service/Event_Service.cpp:
        * orbsvcs/orbsvcs/Event/EC_Basic_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Basic_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Basic_Factory.i:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
        * orbsvcs/orbsvcs/Event/EC_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Null_Factory.cpp:
        * orbsvcs/orbsvcs/Event/EC_Null_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Null_Factory.i:
        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
        * orbsvcs/tests/Event_Latency/Event_Latency.cpp:
          Cleaned up EC_Event_Channel initialization: now it takes the POA
          for the consumer and suppliers in the constructor instead of
          using the factory.  This is was required since not all factories
          can be initialized with the right POAs.

        * orbsvcs/tests/EC_Mcast/EC_Mcast.cpp:
        * orbsvcs/tests/EC_Mcast/svc.conf:
          This test also uses the default factory now.

Fri Apr 23 10:15:26 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Factory.cpp:
          The factory is a service object now.
          Some factories will require the user to set the POA objects.

        * orbsvcs/orbsvcs/Event/EC_Default_Factory.h:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.i:
        * orbsvcs/orbsvcs/Event/EC_Default_Factory.cpp:
          Added new EC_Factory that uses the command line arguments to
          control which strategies and objects are created, it is not very
          efficient, but is very useful for experimentation.

        * orbsvcs/orbsvcs/Event/EC_Event_Channel.h:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.i:
        * orbsvcs/orbsvcs/Event/EC_Event_Channel.cpp:
          Added new methods to set the POAs in the factory, they should be
          used for factories that require them.
          Added support for controlling ownership of the factory
          class.
          If the user does not specify any factories explicitly we try to
          dynamically load the abstract factory. If that fails we fall
          back of the EC_Default_Factory.

        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxyConsumer.cpp:
          The proxy was not reporting its destruction to the EC, thus it
          wasn't removed from all the data structures.

        * orbsvcs/Event_Service/Event_Service.h:
        * orbsvcs/Event_Service/Event_Service.cpp:
        * orbsvcs/Event_Service/svc.conf:
          The new Event Service is configured using the EC_Default_Factory
          and the svc.conf file.

        * orbsvcs/tests/EC_Throughput/run_test.pl:
        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp:
        * orbsvcs/tests/EC_Throughput/ec.conf:
          Added support for the new "dynamically loadable"
          EC_Default_Factory.
          The ec.conf file contains the proper configuration for this
          test.

        * orbsvcs/tests/EC_Throughput/ECT_Consumer_Driver.h:
        * orbsvcs/tests/EC_Throughput/ECT_Consumer_Driver.cpp:
          Added option to disable EC shutdown on program exit.

        * orbsvcs/tests/EC_Throughput/ECT_Supplier_Driver.cpp:
          Minor fixes in debugging messages.

Fri Apr 23 000:39:51 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Marshal.{h,i}:
          TAO_Marshal_Any::deep_free() was a no-op! I just forced
          the Any's destructor call. This may not be portable, but
          the alternative would probably necessitate un-inlining
          the function. Time will tell. Anyway, this fixed memory
          leaks due to Anys containing Anys.
        * tao/append.cpp:
          TAO_Marshal_Any::append() was causing client side memory
          leaks due to unreleased typecodes. Also fixed some Any
          weirdness I noticed by chance in TAO_Marshal_Union.
        * tao/skip.cpp:
          TAO_Marshal_Any::skip() was causing server side memory
          leaks due to unreleased typecodes.

          Thanks to Frank Buschmann <Frank.Buschmann@mchp.siemens.de>
          for providing a tortuous Any test idea.

Thu Apr 22 20:18:58 1999  Ossama Othman  <othman@cs.wustl.edu>

        * man/man7/TAO.7:

          Moved `man/man1/TAO.1' to `man/man7/TAO.7' since TAO.1 doesn't
          describe a user program.  It seems to fit better in
          "Miscellaneous," i.e. man section 7.

        * man/man1/*:

          Updated to reflect move of TAO.1 to man/man7/TAO.7.

Thu Apr 22 17:24:27 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Typecode.cpp:
          Cosmetic changes to ~TC_Private_State so I can read it.

Thu Apr 22 13:37:49 1999  Ossama Othman  <othman@cs.wustl.edu>

        * man/man1/tao_idl.1:

        Moved tao_idl man page to newly created man page directory.

        * man/man1/TAO.1:
        * man/man1/TAO_Concurrency_Service.1:
        * man/man1/TAO_CosEvent_Service.1:
        * man/man1/TAO_Event_Service.1:

        Started added man pages for TAO and TAO's ORB services.  There are
        still several more to complete.  Some of the ones listed above need
        to be revised.

Thu Apr 22 07:53:07 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * examples/POA/Reference_Counted_Servant/Makefile:
          Fixed small compilation problems.

Wed Apr 21 22:15:43 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/POA: Phase three of the POA rearchitecturing is now
          complete.  This phase includes:

          - Addition of reference counting to servants.  This includes:

          (a) obeying reference counting protocol between the POA and the
              servant
          (b) addition of the ServantBase_var class to TAO
          (c) addition of the RefCountServantBase class to TAO
          (d) addition of reference counting hooks to the ServantBase
              class
          (e) addition of reference counting to active object map entries
              to help in counting the number of outstanding requests on
              the servant

          - Etherealization of servants has now been fixed.
            <remaining_activations> and <cleanup_in_progress> should both
            have correct values.

          - New methods were added that help in deactivating and cleaning
            up servants.  These methods are used by both the POA and the
            POA Manager.

          - New example was added. Reference_Counted_Servant shows how to
            use reference counted servants to automatically manage dynamic
            memory for servants.

          - Setting up of POA Current object id was only done with the
            RETAIN policy.  This has now been fixed such that it works
            properly for all policies.  Thanks to Steve Totten
            <totten_s@ociweb.com> for pointing this out.

Wed Apr 21 21:56:01 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/Quoter/client.cpp (main): adding missing ,
          between arguments to activate ().

Wed Apr 21 19:11:00 1999 Chris Gill  <cdgill@cs.wustl.edu>

        * examples/Simulator/DOVEBrowser/NS_Resolve.java:
          New NS resolution method based on CORBA standard approach.
          Many thanks to Margaret Reitz <margaret@veritas.com> and
          Hans Ridder <ridder@veritas.com> for contributing these changes.

        * examples/Simulator/NavWeap.idl
          examples/Simulator/Event_Supplier/{DualEC_Sup, Event_Sup,
                                             Logging_Sup}.dsp:
          Changes to use the new CORBA standard TimeBase.idl

Wed Apr 21 14:45:28 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Event/EC_Basic_Factory.cpp:
          Use Recursive_Mutexes for the Basic_Factory, otherwise we risk a
          dead-lock if the user decides to disconnect or push a new event
          that it finally reaches the same consumer.

        * orbsvcs/orbsvcs/Event/EC_Dispatching.h:
        * orbsvcs/orbsvcs/Event/EC_Dispatching.cpp:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.h:
        * orbsvcs/orbsvcs/Event/EC_ProxySupplier.cpp:
          Added new method push_to_consumer() to the ProxyPushSupplier
          implementation, this method is invoked by the dispatching module
          to really push the event. Its job is to verify that the consumer
          is not disconnected and/or suspended.
          The Dispatching module does not need to receive the consumer
          anymore.

        * orbsvcs/orbsvcs/Event_Service_Constants.h:
        * orbsvcs/orbsvcs/Event_Utilities.i:
          Added new macro for the ANY_SOURCE source id.

        * orbsvcs/orbsvcs/Event/EC_Timeout_Filter.cpp:
        * orbsvcs/orbsvcs/Event/EC_Timeout_Generator.cpp:
          Timeout filters should not accept any events in the filter()
          methods.
          The Timeout generator passes the event directly to their
          push_nocopy() methods.

        * orbsvcs/orbsvcs/Makefile:
          Fixed little problem with the Time -> ImplRepo dependency in
          TAO_ORBSVCS

        * orbsvcs/tests/Event_Latency/Event_Latency.cpp:
          Added compile-time support for the new Event Channel, just for
          experimentation purposes.

Wed Apr 21 11:06:57 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/Globals.{h,cpp},
          server.cpp,client.cpp:  factored out thread creation flags to
          Globals::thr_create_flags.  Only set THR_SCHED_FIFO flag if
          sched_fifo_init operation to set process FIFO scheduling succeeded.

Wed Apr 21 09:37:27 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/summarize:
          added 0 low-priority thread case to example usage.

        * performance-tests/Cubit/TAO/MT_Cubit/MT_Cubit_Test:
          added exit at end of trap statement, so that the script
          will die after catching a signal and cleaning up.

Wed Apr 21 09:25:16 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/NestedUpcall/MT_Client_Test/client.cpp (main),
          examples/Quoter/client.cpp (main),
          performance-tests/Cubit/COOL/MT_Cubit/client.cpp
            (do_priority_inversion_test):
          replaced ACE_SCHED_FIFO with THR_SCHED_FIFO in activate calls.
          Thanks to Carlos for finding this subtle error.

Wed Apr 21 09:12:20 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/client.cpp:
        * performance-tests/Cubit/TAO/MT_Cubit/server.cpp:
          The activate() function was called with the wrong flag,
          ACE_SCHED_FIFO was used, but THR_SCHED_FIFO is the Right
          Thing[tm]

Wed Apr 21 03:41:51 1999  Douglas C. Schmidt  <schmidt@cs.wustl.edu>

        * TAO version 0.3.20 released.

Wed Apr 21 01:24:26 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/default_resource.cpp: Removed extra #pragma instantiates for
          TAO_Collocation_Table_Lock.

Wed Apr 21 00:56:21 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * orbsvcs/orbsvcs/Property/CosPropertyService_i_T.cpp
          (operator=): Added an empty implementation to stop MSVC from
          complaining.

Tue Apr 20 23:21:22 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Typecode.cpp:
          Removed a superfluous duplication of an ACE_Message_Block
          in private_member_label(). This got rid of another memory
          leak associated with unions. In general, it's never necessary
          to duplicate a message block before calling the Any
          constructor that takes a message block or either of the
          Any::_tao_replace() functions. All of these duplicate the
          message block themselves.

Tue Apr 20 22:57:57 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_union/any_op_cs.cpp:
          <<= was causing a memory leak. Removed the ->clone ()
          from the message block being inserted into the Any.
          Tested both copying and non-copying versions of <<=,
          over the wire, with a dynamically allocated type inside
          the union. All worked ok, and the leak was gone.

Tue Apr 20 20:43:25 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/Property/CosPropertyService_i_T.h: Added a
        operator= declaration to avoid this being generated which leads to
        undefined operator= for the PropertyTypes member when linking orbsvcs.
        Thanks to Irfan Pyarali for the fix.

Tue Apr 20 20:27:48 1999  Darrell Brunsch <brunsch@cs.wustl.edu>

        * orbsvcs/ImplRepo_Service/*:  Added an options class for storing
          program options and also changed the repository class to not
          use the ACE Naming Context.  It doesn't have persistence now,
          but that will be added soon.

        * orbsvcs/tests/ImplRepo/*:  Changed to work with the above changes.

Tue Apr 20 17:31:28 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * docs: Performed copy editing on a bunch of documentation and
          added the new Interoperable Naming Service documentation to the
          main documentation page.

Tue Apr 20 15:24:00 1999  Darrell Brunsch <brunsch@cs.wustl.edu>

        * tests/MT_Client/orb_creation.dsp:
        * tests/MT_Client/MT_Client.dsp:
          New MSVC project file for orb_creation.

Tue Apr 20 15:18:35 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        * TAO_ROOT/docs/INS.html: Added this page. It documents the
          InterOperable Naming Service.
        * TAO_ROOT/docs/releasenotes/index.html: Added a link to INS.html

Tue Apr 20 14:27:07 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/deep_free.cpp:
          Removed local variable discrim_size_with_pad, which is no
          longer being used.

Tue Apr 20 11:09:07 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/ORB_Core.cpp:
          Removed several memory leaks, including the ORB_Core itself: it
          wasn't destroyed when the last ORB reference went away.

        * tao/ORB.cpp:
          Fixed resource leak in file_string_to_object()

        * tao/default_resource.h:
        * tao/default_resource.i:
        * tao/default_resource.cpp:
          Merged the App_Allocated and Pre_Allocated classes into a single
          class, it is easier to control their lifetime and it didn't make
          sense to have two.

        * tao/IIOP_Connector.cpp:
          Fixed comment.

        * tests/MT_Client/client.global.conf:
        * tests/MT_Client/client.tss.conf:
          Use static services.

        * tests/MT_Client/orb_creation.cpp:
        * tests/MT_Client/server.cpp:
        * tests/MT_Client/client.cpp:
          Use the ACE macros to print out exceptions.

        * tao/MessagingC.cpp:
          Fixed warnings about unitialized variables.

        * tests/MT_Client/Makefile:
          Updated dependencies

        * tests/MT_Client/run_test.pl:
          Added support for the orb_creation test.

Tue Apr 20 02:47:32 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/Param_Test/param_test_i.cpp (test_exception): It was still
          using environment to throw exceptions.  Changed to use ACE_THROW.

        * tests/Param_Test/except.{h,cpp}: Differentiated results based on
          the exception received in that iteration so we can determine if
          the exception is the one the test is waiting.  Egcs on Linux
          seems to have trouble downcasting exceptions.

Mon Apr 19 22:17:28 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_interface/interface_ss.cpp
          (visit_interface): Removed access to input CDR since it is not
          used in this function.  Thanks to David for pointing this out.

Mon Apr 19 20:17:02 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Any.{h,i}:
          Changed the signature of the constructor for Any::to_object
          to reflect the change set out in issue 154 of the 1.3 RTF.
          This makes the caller responsible for disposing of the
          results of extracting to to_object, and allows the constructor
          to be passed an Object_var to facilitate this.
          Also had to add '#include Object.h' to keep sunc++ happy.

Mon Apr 19 17:09:14 1999  Douglas C. Schmidt  <schmidt@ace.cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/client.cpp (start_servant):
          Arrgh!  There was a missing comma that caused the test to fail!
          Thanks to David H. Whittington <david.h.whittington@boeing.com>
          for reporting this.

Mon Apr 19 16:26:43 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/deep_free.cpp:
          Updated TAO_Marshal_Union::deep_free to use the
          Union class virtual functions. The old code was
          bumpint the void *data pointer along to point to
          the discriminator value, then to the member value.
          This wasn't working on NT where the first thing
          in the union class memory layout is the vptr. Also
          changed the use of value() to _tao_get_cdr() on
          the elements of the member label list. That
          wouldn't work on any platform because those Anys
          are all created with void *value = 0;

        * tao/decode.cpp,
        * tao/encode.cpp,
        * tao/skip.cpp:
          Changed the tk_enum case for the discriminator inside
          the TAO_Marshal_Union versions to use CORBA::ULong as
          was determined to be the correct mapping earlier today.
          Also finished implementing the tk_wchar cases, which
          Andy had marked TODO.

Mon Apr 19 15:23:56 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * orbsvcs/tests/Trading/colocated_test.cpp (main):
        * orbsvcs/tests/EC_Throughput/ECT_Throughput.cpp (run):
        * orbsvcs/tests/EC_Multiple/EC_Multiple.cpp (run):
        * orbsvcs/Trading_Service/Trading_Service.cpp (init):
        * tao/Stub.cpp (set_policy_overrides):
        * tao/POA.cpp (create_POA):

          Avoided annoying g++ warning about <auto_ptr> by explicitly
          making a temporary. Thanks to David for pointing this out.

Mon Apr 19 13:54:10 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/configurations.html: removed TAO_ORBSVCS limitation
          that said we don't check for the macro in the each of the
          orbsvcs and orbsvcs/tests subdirectories.  We do now.

Mon Apr 19 13:15:25 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/POA: Fixed POA code to pass and use the environment when
          calling _add_ref and _remove_ref on servants.

        * tao/Servant_Base (_add_ref and _remove_ref): Added default
          environment parameter to call.  Thanks to David for pointing
          this out.

        * tao/ORB.cpp (resolve_root_poa and resolve_poa_current): Now that
          resolve_initial_references takes a environment, we don't need to
          create temporary environments.  Changed these functions to take
          the environment as a parameter.  Thanks to Carlos for pointing
          this out.

        * tao/POA: The following changes were made to comply with the new
          servant reference counting schemes in the upcoming CORBA 2.3
          specification:

          - Changed type of <default_servant_> from Servant to
            ServantBase_var.  This will help in (a) calling _remove_ref()
            on <default_servant_> when it is replaced with a new
            <default_servant_> and (b) calling _remove_ref() on
            <default_servant_> when the POA goes away.

          - Added servant reference counting to the following methods:

            get_servant
            set_servant
            activate_object
            activate_object_with_id
            servant_to_id
            servant_to_reference
            reference_to_servant
            id_to_servant

          - To be done: Calling _remove_ref() on deactivation of objects,
            deactivation of POAs, and destruction of POAs.

Sun Apr 18 12:32:15 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * TAO_IDL/driver/drv_args.cpp (DRV_parse_args): Added check of
          validity of temp directory.  If tao_idl can't access the temp
          directory, spit out some warning and switch to use current
          directory.

Sun Apr 18 09:08:13 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/ORB.cpp: removed ACE_Atomic_Op<ACE_SYNCH_MUTEX, u_int>
          explicit template instantiation.  It duplicated the one
          in Servant_Base.cpp.

Sun Apr 18 03:34:33 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Servant_Base.h (class ServantBase_var): Added reference
          counting servant auto pointer class (as per CORBA spec).

        * tao/Servant_Base (class RefCountServantBase): Added reference
          counted mix-in class (as per CORBA spec).

        * tao/Servant_Base.cpp (operator= and TAO_ServantBase):

          - Fixed the copy constructor and assignment operator to copy the
            optable pointer from the <rhs> object.

          - Made the assignment operator protected (as per CORBA spec).

          - Also added _remove_ref() and _add_ref() (as per CORBA spec).

        * tao/Servant_Base.h (TAO_ServantBase): Made _is_a public and add
          _non_existent.

        * tao/Object.cpp (_non_existent): Added collocation optimization
          similar to the ones in _is_a().

        * TAO_IDL/be/be_visitor_interface/collocated_ss.cpp
        * TAO_IDL/be/be_visitor_interface/collocated_sh.cpp
          (visit_interface): Removed the generation of the _is_a from the
          collocated class since there is already a call to the servant
          from the object if the object is collocated.

        * TAO_IDL/be/be_visitor_interface/interface_cs.cpp
          (visit_interface): Removed the incorrect comment that said that
          CORBA_Object::_is_a is a remote call.

        * TAO_IDL/be/be_visitor_interface/interface_ss.cpp
          (visit_interface): Changed the _is_a skeleton to use compiled
          marshaling.  Also, changed the _non_existent skeleton to use
          compiled marshaling and to call the servant instead of simply
          returning false.

        * tao/Sequence.cpp (operator==): Moved the comparison of octet
          sequences from Stub.cpp to Sequence.cpp.  Also, removed the
          comparison of object keys.

Sat Apr 17 17:41:12 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/AVStreams_i.{h,cpp} :
        * orbsvcs/orbsvcs/AV/AVStreams_i_T.cpp :
          Fixed g++ warnings/errors. Thanks to David Levine and JM Strauss
          for reporting this.

Fri Apr 16 21:57:15 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/Simple/{bank,echo,grid,time}/Makefile:
          only build if the orbsvcs library was built with
          the Naming TAO_ORBSVCS component.

Fri Apr 16 19:40:27 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Typecode.cpp:
          Okay, here goes. A recent bug report concerning crashes
          upon exit after inserting a union into an Any led to this
          discovery. When the Any goes away, it calls free_value()
          on the union (since it owns it). This leads eventually to
          TAO_Marshal_Union::deep_free(). The union wants to free
          its contents, so it goes to its own typecode's
          private_member_label() to find out which case is active.
          The private_state member_label_list is not constructed
          until a member_label is asked for, so one is often constructed
          at this point. It is an array of Any_ptrs, and each Any
          is constructed on the heap from an output CDR stream
          which is formed from a message block read from an input
          CDR stream formed from the typecode's buffer_. So far so
          good? The output CDR stream was constructed using the
          default ORB allocators. Then, when the typecode's destructor
          is called, it wants to free the member_label_list, which means
          freeing the Any(s), which means freeing their message blocks,
          which means freeing their data blocks. But by this time, the
          ORB has gone away, so the data block(s) are hanging, and we
          crash. The solution is to construct the output CDR with
          specified allocators, namely ACE_Allocator::instance (). This
          class seems to have been designed especially for problems like
          this, since it hangs around longer than anybody. As far as I
          can tell, there are no more instances in Typecode where a CDR
          stream hangs around, so this should be the only place where
          this fix is needed (but a better one will come along someday).
          Thanks to Irfan for mucho help with this and to Frank Buschmann
          <frank.buschmann@mchp.siemens.de> for reporting the problem.

Fri Apr 16 19:02:07 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/AVStreams_i.cpp: Fixed a few warnings in g++
          and also added TAO_McastConfigIf and TAO_Negotiator class declarations.

Fri Apr 16 16:39:22 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Connect: Added a new connection handling strategy that
          simply blocks in recv() when waiting for a response from the
          server instead of waiting in the Reactor.  This strategy only
          works when the application does not have to worry about new
          requests showing up when waiting for a response. Therefore, this
          strategy is appropriate only for "pure" clients.

          Note that applications with nested upcalls are not "pure"
          clients. Also note that this strategy will only effect two way
          calls, since there is no waiting for one way calls.

          This strategy can also be used in an application that is both a
          client and a server, if the server side is handled by a separate
          thread and the client threads are "pure" clients.

          Carlos has promised to add policies that will make the selection
          of these connection handling policies finer grain than the "all
          or nothing" selection that currently exists.  The aim would be
          to allow some clients (maybe invocations) to use one connection
          handling policy and while others to use other policies.

          If applications can use this strategy, they can improve their
          performance since the Reactor will not get involved in this code
          path.

          Descriptive comparison of the different connection handling
          strategies is available in:
          http://www.cs.wustl.edu/~schmidt/ACE_wrappers/TAO/docs/Options.html

          Here are some numbers that compare the effect of different
          policies on the performance of a simple two way call:

          Policy                                            Performance        Speedup percentage
                                                            (calls/second)     (relative to MT)
          ------                                            -----------        ----------------

          MT Connection Handler (with a Reactor lock)          4346                 0.0
          ST Connection Handler (with a Reactor lock)          4416                 1.6
          ST Connection Handler (without a Reactor lock)       4473                 2.9
          RW Connection Handler                                4676                 7.6

          The above numbers were obtained from the
          examples/POA/Generic_Servant/client and
          examples/POA/Explicit_Activation/server examples (with the other
          usual optimizations turned on) using the following configuration
          in loopback mode:

          MSVC 6.0, release mode, NT4.0 SP 3, on a quad CPU Zeon (400 MHz)

        * performance-tests/Cubit/TAO/IDL_Cubit/svc.conf:
        * performance-tests/Cubit/TAO/IDL_Cubit/svc.conf.dynamic:
        * performance-tests/Cubit/TAO/MT_Cubit/svc.conf:

          Added the new RW connection handling option to these tests.

        * performance-tests/Cubit/TAO/MT_Cubit/svc.conf.static: Removed
          this file is it was now identical to the svc.conf file.

Fri Apr 16 17:16:23 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/Simulator/{DOVEMIB,Event_Supplier}/Makefile:
          only build if the orbsvcs library was built with the necessary
          TAO_ORBSVCS components.  Also, ran make depend on DOVEMIB
          Makefile.

Fri Apr 16 17:02:43 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * examples/Simple/bank
        * examples/Simple/time
        Update the README files

Fri Apr 16 15:31:04 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/Trader/Trader.h :
          Added TAO_ORBSVCS_Export to TAO_String_Hash_Key as it is used in
          AVStreams implemtation.

Fri Apr 16 14:49:04 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        * tests/InterOp-Naming/Makefile (LDLIBS):
          Removed the -lorbsvcs.

Fri Apr 16 14:17:08 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/be_include/be_visitor_field/cdr_op_cs.h:
        * TAO_IDL/be/be_visitor_field/cdr_op_cs.cpp:
          Added a visit_typedef() method to
          be_visitor_cdr_op_field_decl, so that we can
          generate cdr operations for typedef'd members
          of structs as well as anonymous ones. Previously,
          cdr operation code for this type of struct member
          would just be missing. Thanks to Torsten Kuepper
          <kuepper2@uni-wuppertal.de> for pointing out the
          problem and suggesting a fix.

Fri Apr 16 13:41:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * examples/Simulator/Event_Supplier/DOVE_Supplier.cpp
          examples/Simulator/Event_Supplier/Logging_Sup.cpp
          examples/Simulator/Event_Supplier/DualEC_Sup.cpp:
          changed a number of instances of ORBSVCS_Time::zero
          to ORBSVCS_Time::zero ()

Fri Apr 16 09:39:47 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/NestedUpcall/Triangle_Test/Makefile:
          removed unnecessary use of orbsvcs include path and library.

        * tests/NestedUpcall/Reactor/Makefile,
          performance-tests/Demux/Makefile,
          examples/Callback_Quoter/Makefile,
          examples/Event_Comm/Makefile:
          only build if the orbsvcs library was built with the Naming
          TAO_ORBSVCS component.

        * examples/Quoter/Makefile:
          only build if the orbsvcs library was built with the Naming
          and LifeCycle TAO_ORBSVCS components.

Fri Apr 16 09:36:14 1999  David L. Levine  <levine@cs.wustl.edu>

        * tao/default_resource.cpp: removed ACE_*Guard instantiation
          pragmas.  There were no corresponding template class
          instantiation directives, and the pragmas duplicated those
          in ORB_Core.cpp.

Fri Apr 16 08:24:58 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tests/MT_Client/Makefile:
        * tests/MT_Client/orb_creation.cpp:
          Added new test to check if the simultaneous creation of multiple
          ORB works and to check for memory leaks in the ORB
          lifecycle.

        * tests/MT_Client/client.cpp:
          Minor cosmetic fix.

        * tao/default_resource.cpp:
          Re-order the destruction of objects in the
          TAO_App_Allocated_Resources class, otherwise we get seg faults
          on shutdown. Thanks to Irfan for reporting this problem.

Fri Apr 16 07:25:25 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/Dump_Schedule/Makefile,orbsvcs/Event_Service/Makefile,
          orbsvcs/Scheduling_Service/Makefile,orbsvcs/tests/EC_Basic/Makefile,
          orbsvcs/tests/EC_Custom_Marshal/Makefile,
          orbsvcs/tests/EC_Mcast/Makefile,orbsvcs/tests/EC_Multiple/Makefile,
          orbsvcs/tests/EC_Throughput/Makefile,
          orbsvcs/tests/Event_Latency/Makefile
          orbsvcs/tests/Sched/Makefile,orbsvcs/tests/Sched_Conf/Makefile:
          only build if the orbsvcs library was built with the respective
          TAO_ORBSVCS component.

Thu Apr 15 16:35:27 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/ORB_Core.cpp:
        * tao/Environment.cpp:
          Fixed initialization problem, to query the default environment
          we don't need the ORB_Core, only its TSS resources, this allow
          us to use CORBA_init() without the environment argument.

Thu Apr 15 15:58:52 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Trader/Trader_Utils.h:
        * orbsvcs/orbsvcs/Trader/Trader_Utils.cpp:
        * orbsvcs/tests/AVStreams/server_discovery/Trader_Client.cpp:
        * orbsvcs/tests/Trading/Offer_Importer.cpp:
        * orbsvcs/tests/Trading/Offer_Importer.h:
          Changed the name of the TAO_Policy_Manager class in Trader_Utils
          to TAO_Policy_Creator, the previous name had conflicts with the
          new TAO_Policy_Manager in $TAO_ROOT/tao.

        * docs/releasenotes/TODO.html:
          A small update

Thu Apr 15 15:40:53 1999  David L. Levine  <levine@cs.wustl.edu>

        * all orbscvs/tests/AVStreams Makefiles: added BIN2, LIB2,
          and SHLIB2 support, for make realclean.

        * orbsvcs/tests/AVStreams/server_discovery/Makefile:
          added Video_Discovery.idl to make realclean target.

Thu Apr 15 13:22:15 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/ORB.h:
        * tao/ORB_Core.h:
        * tao/TAO.dsp:
        * tao/TAO_Static.dsp:
          Fixed some problems with compilation under NT.

Thu Apr 15 10:44:12 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/ORB_Core.h:
        * tao/ORB_Core.i:
        * tao/ORB_Core.cpp:
        * tao/TAO_Internal.cpp:
        * tao/ORB.h:
        * tao/ORB.cpp:
          Each ORB creates its own ORB_Core.  The ORB_Core is no longer a
          TSS singleton, instead it keeps some of its resources in TSS
          storage, but it is a per-ORB resource.
          TAO_ORB_Core_instance() returns the ORB_Core of the default ORB.

        * tao/default_server.h:
        * tao/default_server.cpp:
        * tao/Server_Strategy_Factory.h:
        * tao/Server_Strategy_Factory.cpp:
          The open() method receives the ORB_Core as a parameter to avoid
          recursive calls to TAO_ORB_Core_instance() during startup.

        * tao/default_client.h:
        * tao/default_client.cpp:
          Moved the {MT,ST}_Connect_Creation_Strategy classes to this file
          because here is where they are used, not in the ORB_Core.

        * tao/IIOP_Connector.cpp:
          Moved template instantiations required on this file from
          ORB_Core.cpp

        * tao/Servant_Base.cpp:
        * tao/POAManager.cpp:
        * tao/Object_Adapter.h:
        * tao/Object_Adapter.i:
        * tao/Invocation.cpp:
        * tao/IIOP_Profile.cpp:
        * tao/Connect.cpp:
          Added some includes because they were removed from ORB_Core.h

        * tao/Connect.h:
        * tao/params.h:
        * tao/params.i:
        * docs/Options.html:
          Removed deprecated OA options.

        * tao/Resource_Factory.h:
        * tao/Resource_Factory.cpp:
        * tao/default_resource.h:
        * tao/default_resource.i:
        * tao/default_resource.cpp:
          Separated the Resource_Factory from the ORB_Core files, also
          separated the Resource_Factorty from its default implementation,
          as we do for the client and server strategy factories.

        * tests/MT_Client/client.global.conf:
        * tests/MT_Client/client.tss.conf:
        * tests/NestedUpcall/MT_Client_Test/client.conf:
        * examples/POA/On_Demand_Loading/svc.conf:
        * examples/Quoter/client.conf:
        * examples/Quoter/server.conf:
        * examples/Simulator/DOVEMIB/svc.conf:
        * examples/Simulator/Event_Supplier/svc.conf:
        * orbsvcs/tests/AVStreams/benchmark/clnt.conf:
        * orbsvcs/tests/AVStreams/benchmark/svc.conf:
        * orbsvcs/tests/AVStreams/mpeg/source/client/svc.conf:
        * orbsvcs/tests/AVStreams/mpeg/source/server/svc.conf:
        * orbsvcs/tests/ImplRepo/implrepo.conf:
        * orbsvcs/tests/ImplRepo/svc.conf:
        * orbsvcs/tests/Time/implrepo.conf:
        * performance-tests/Cubit/TAO/IDL_Cubit/svc.conf.dynamic:
        * performance-tests/Thruput/TAO/svc.conf:
          Updated the configuration files, to reflect the new name of the
          default resource factory.

Wed Apr 14 20:38:51 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/PolicyC.cpp: Added missing template instantiations.  Thanks
          to Robert V. Head <rhead@virtc.com> for reporting them.

        * orbsvcs/orbsvcs/AV/AVStreams_i.cpp: Added missing instantiation
          for TAO_PropertySet<POA_AVStreams::StreamEndPoint>.

        * tao/Object_Adapter.cpp: Removed trailing semi-colon from #pragma
          instantiate.

Wed Apr 14 16:43:32 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/ORB_Core.cpp:
          One of the strings removed in ORB_Core::init() was not
          duplicated first.

Wed Apr 14 15:33:35 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/Endpoint_Strategy_T.cpp:
        * orbsvcs/orbsvcs/AV/Endpoint_Strategy.cpp:
        * orbsvcs/orbsvcs/AV/AVStreams_i_T.cpp:
        * orbsvcs/orbsvcs/AV/AVStreams_i.cpp:
          Replaced all uses of TAO_TRY macros with ACE_TRY macros.

Wed Apr 14 15:25:53 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * TAO_IDL/be_visitor_sequnce/gen_object_manager_ch.cpp
        * TAO_IDL/be_visitor_sequnce/gen_object_manager_ci.cpp
        Added a new -> operator and also removed a 'const' signature
        for the .in method in TAO_Object_Manager_{Name}_Sequence classes
        that are generated by the IDL compiler. This has been in TAO
        for sometime now..
        ---------------------------------------------
        tao/Sequence_T.i (operator->): Added operator-> to
          TAO_Object_Manager.  Also, made the in() method return a
          non-const pointer
        -------------------------------------------
Wed Apr 14 13:01:13 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/AVStreams_i.cpp: Fixed template instantiation
        errors. Thanks to Andy Gokhale for reporting this.

Wed Apr 14 07:06:11 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/orbsvcs/Property/CosPropertyService_i.cpp:
          fixed semicolons at ends of explicit template
          instantiations.

Wed Apr 14 00:24:42 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/Object_Adapter.cpp: Added missing template instantiations.
          Thanks to Robert V. Head <rhead@virtc.com> for reporting them.

Tue Apr 13 17:02:39 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Stub.cpp:
          auto_ptr<> requires an explicit constructor, thanks to David and
          the green hills compiler for detecting this.

Tue Apr 13 13:59:32 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO/performance-tests/Cubit/TAO/IDL_Cubit/server.cpp:
        * TAO/performance-tests/Cubit/TAO/IDL_Cubit/client.cpp:
          Added inlcudes and macros to send output to a file, as
          the tests in ACE_wrappers/tests do. The macros are
          commented out, so the cubit tests will work exactly
          the same as before unless client.cpp and server.cpp are
          built with those macros uncommented. Especially useful
          for dealing with timeprobes, where there might be
          hundreds of entries in the output

Tue Apr 13 12:35:18 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Connect.h:
        * tao/Connect.cpp:
          The MT_Client_Connection handler was using ORB_Core_instance()
          all over the place. Now it uses the ORB_Core provided in the
          send_request call.
          We will need to revisit this class, right now it allocates one
          condition variable per-connection, but allocating one on a
          per-thread (many per-thread-per-ORB) basis should be enough.
          We are also careful to use the ORB_Core's reactor to send the
          request and to implement the leader-follower model.

        * tao/ORB_Core.cpp:
          Changed bunch of calls to TAO_ORB_Core_instance() in an ORB_Core
          method, using <this> is enough in that case.

        * tests/MT_Client/client.cpp:
        * tests/MT_Client/server.cpp:
        * tests/MT_Client/test_i.cpp:
        * tests/MT_Client/server.conf:
        * tests/MT_Client/client.tss.conf:
        * tests/MT_Client/client.global.conf:
        * tests/MT_Client/run_test.pl:
          Added configuration files for the client, it can use TSS storage
          now. Also added some (optional) debugging information to monitor
          the client progress.
          The script supports this new features too.
          Simplified the server configuration file.

        * performance-tests/Cubit/TAO/MT_Cubit/svc.conf:
        * performance-tests/Cubit/TAO/MT_Cubit/svc.conf.static:
        * performance-tests/Cubit/TAO/IDL_Cubit/svc.conf:
        * performance-tests/Cubit/TAO/IDL_Cubit/svc.conf.dynamic:
          We can use TSS allocators in this examples.

Tue Apr 13 09:52:20 1999  David L. Levine  <levine@cs.wustl.edu>

        * orbsvcs/Concurrency_Service/Makefile,
          orbsvcs/CosEvent_Service/Makefile,
          orbsvcs/ImplRepo_Service/Makefile,
          orbsvcs/Logging_Service/Makefile,
          orbsvcs/Naming_Service/Makefile,
          orbsvcs/tests/Concurrency/Makefile,
          orbsvcs/tests/CosEC_Basic/Makefile,
          orbsvcs/tests/CosEC_Multiple/Makefile,
          orbsvcs/tests/ImplRepo/Makefile,
          orbsvcs/tests/Logger/Makefile,
          orbsvcs/tests/Simple_Naming/Makefile: added BIN2 support,
          for make realclean.

Mon Apr 12 22:12:27 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        Removed the resolve_commandline_ref (). This was no longer
        being used. Also passed ACE_TRY_ENV as a parameter to the
        following functions. Carlos suggested these changes :

        resolve_service ()
        multicast_to_service ()
        resolve_trading_service ()

        * tao/ORB.h
        * tao/ORB.cpp

Mon Apr 12 17:13:37 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/orbsvcs.dsp: Added the AVStreams_i_T.{h,cpp} and
          CosPropertyService_i_T.{h,cpp} to the project file.

        * orbsvcs/tests/AVStreams/benchmark/AV_benchmark.dsw:
        * orbsvcs/tests/AVStreams/benchmark/av_benchmark_client.dsp:
        * orbsvcs/tests/AVStreams/benchmark/av_benchmark_server.dsp:
        * orbsvcs/tests/AVStreams/benchmark/av_benchmark_child.dsp:
                Added the NT VC++ project files and worspace files.

        * orbsvcs/tests/AVStreams/benchmark/server.cpp:
        * orbsvcs/tests/AVStreams/benchmark/client.cpp:
                Fixed the compilation errors on NT.
                Works fine on Unix platforms.
        * orbsvcs/tests/AVStreams/benchmark/child_process.cpp:
          Added the new file which has just the main() for the child
          process. Thanks to David Hooker <DHooker@uniview.net> for
          reporting the errors.

        * orbsvcs/orbsvcs/AV/AVStreams_i_T.{h,cpp}: Moved the
        TAO_StreamEndpoint classes from AVStreams_i.{h,cpp} as it was made
        a template to avoid interface inheritance errors on NT VC++.

        * orbsvcs/orbsvcs/Property/CosPropertyService_i_T.{h,cpp}: Moved the
        TAO_PropertySet classes from AVStreams_i.{h,cpp} as it was made
        a template to avoid interface inheritance errors on NT VC++.

        * orbsvcs/orbsvcs/Makefile: Added the new AVStreams_i_T.{h,cpp}
        and CosPropertyService_i_T.{h,cpp}.

Mon Apr 12 14:24:12 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/ORB.cpp: The resolve_policy_manager() and
          resolve_policy_current() only worked if TAO_HAS_CORBA_MESSAGING
          was defined.

        * tao/ORB_Core.cpp:
        * tao/Stub.cpp: More problems if TAO_HAS_CORBA_MESSAGING is not
          defined.

Mon Apr 12 14:19:45 1999  David L. Levine  <levine@cs.wustl.edu>

        * LifeCycle_Service/Makefile,tests/Property/Makefile,
          Trading_Service/Makefile,tests/Trading/Makefile: only build if
          the orbsvcs library was built with the necessary component.

        * Time_Service/Makefile,tests/Time/Makefile: added BIN2 support,
          for make realclean.

Mon Apr 12 14:09:06 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_interface/interface_ss.cpp,
        * tao/Servant_Base.h,
        * tao/Server_Request.i,
        * tao/Operation_Table.h,
        * tao/Servant_Base.cpp,
        * tao/Server_Request.cpp,
        * tao/Operation_Table.cpp: Committed again the changes related to
          Removing strlen calculation for the Operation Name from the
          critical path. Length as it is obtained during demarshalling is
          stored in the IIOP_Request object and passed to the Perfect
          Hash's find operation. ACE_CString is used to store the
          operation as opposed char *. Thanks to Irfan for suggesting this
          change.

Mon Apr 12 13:41:23 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Timeprobe.h,
        * tao/Connect.cpp,
        * tao/Invocation.cpp:
          Added four new timeprobes to measure client outgoing process
          time and server process time. Whereas the pluggable protocols
          timeprobes were a subset of the regular timeprobes, these are a
          disjoint set. If both the pluggable and minimal timeprobes
          macros are uncommented in Timeprobe.h, pluggable will override.

Mon Apr 12 12:37:39 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Stub.cpp:
          Added missing template instantiations.

Mon Apr 12 10:38:46 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/MessagingC.cpp:
        * tao/PolicyC.cpp:
          Removed warnings about unused variables, the variables are
          required for platforms without native C++ exceptions.

        * docs/Options.html:
          Fixed description of the ORBinputcdrallocator option.

Mon Apr 12 09:52:58 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Makefile:
          Keep working on the CORBA Messaging framework.

        * tao/orbconf.h:
        * tao/ORB.h:
        * tao/ORB.cpp:
          Added support for "PolicyCurrent" and "ORBPolicyManager" into
          resolve_initial_references()

        * tao/ORB_Core.h:
        * tao/ORB_Core.i:
        * tao/ORB_Core.cpp:
          Added methods to set and query the TSS PolicyCurrent and the
          per-ORB PolicyManager.

        * tao/Object.h:
        * tao/Object.cpp:
          Implemented the standard methods to access and query policies,
          but they just delegate on the TAO_Stub methods.

        * tao/Stub.h:
        * tao/Stub.cpp:
          Added methods to set and query the policies.

        * tao/Policy_Manager.h:
        * tao/Policy_Manager.i:
        * tao/Policy_Manager.cpp:
          Simple implementation of the CORBA::PolicyManager and
          CORBA::PolicyCurrent interfaces. There is a helper class shared
          between both implementations that is also used by the
          corresponding methods in CORBA::Object (and TAO_Stub).

        * tao/MessagingC.cpp:
          Added missing template instantiation

        * tests/Param_Test/Makefile:
        * examples/Event_Comm/Makefile:
        * examples/Quoter/Makefile:
        * performance-tests/Cubit/TAO/IDL_Cubit/Makefile:
        * performance-tests/Pluggable/Makefile:
        * performance-tests/Thruput/TAO/Makefile:
          Removed extra rules to compile .idl files, they were giving me
          headaches when running parallel compiles.

Mon Apr 12 03:30:18 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * TAO_IDL/be/be_visitor_union/any_op_cs.cpp (gen_extraction):
          modified ACE_static_cast to ACE_dynamic_cast to fix a compile
          error on SunCC 5.0 when casting to void* from non-void pointer.
          Thanks to Darren Whobrey <whobrey@fecit.co.uk> for reporting
          this bug.

Mon Apr 12 00:26:31 1999  Douglas C. Schmidt  <schmidt@cs.wustl.edu>

        * TAO version 0.3.19 released.

Sun Apr 11 23:55:50 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tests/Param_Test/driver.cpp
        * tests/Param_Test/multdim_array.cpp
        * tests/Param_Test/param_test.idl
        * tests/Param_Test/param_test_i.cpp
        * tests/Param_Test/param_test_i.h
          Temporarily comments out test code for Multi-dimensional arrays
          due to nasty compile bugs on NT.

Sun Apr 11 19:38:39 1999  Marina Spivak  <marina@cs.wustl.edu>

        * orbsvcs/orbsvcs/Naming/Naming_Utils.cpp
        * orbsvcs/orbsvcs/Persistent_Naming_Context.{h, cpp}
        * orbsvcs/orbsvcs/Persistent_Context_Index_T.cpp
          Changed the use of the <index> variable name to <context_index>
          to avoid conflict with the macro of the same name.

Sun Apr 11 18:29:47 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * orbsvcs/orbsvcs/Naming/Naming_Utils.cpp (TAO_Naming_Client):
          Fixed the use of ACE_Thread_Mutex to ACE_SYNCH_MUTEX to ensure
          this will run properly on non-threaded platforms.  Thanks to
          Alex for reporting this.

Sun Apr 11 15:36:33 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * examples/POA/DSI/Database_i.cpp
        * examples/POA/DSI/Database_i.h
          Fixed some warnings on IRIX

Sun Apr 11 11:45:49 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * orbsvcs/orbsvcs/Naming/Persistent_Naming_Context.cpp:
          Added missing template instantiation.


Sat Apr 10 20:55:00 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * tests/Param_Test/multdim_array.cpp:
        * tests/Param_Test/multdim_array.h
        * tests/Param_Test/Makefile
        * tests/Param_Test/driver.cpp
        * tests/Param_Test/options.cpp
        * tests/Param_Test/param_test.idl
        * tests/Param_Test/param_test_i.cpp
        * tests/Param_Test/param_test_i.h
        * tests/Param_Test/tests.h: Added a new test case for
          multi-dimensional array checking.

Sat Apr 10 16:22:59 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        * doc/papers/COOTS-99/poa.tex (): Made the Nos. in the table
          consistent with the figure.

Sat Apr 10 14:26:48 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * tao/POA.cpp: Removed #POA_NO_TIMESTAMP according to Irfan's
          suggestion to get things to work on Soalris.

Fri Apr  9 22:18:08 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_interface/interface_ss.cpp:
        * tao/Servant_Base.h :
        * tao/Server_Request.i :
        * tao/Operation_Table.h :
        * tao/Servant_Base.cpp:
        * tao/Server_Request.cpp :
        * tao/Operation_Table.cpp :

        Reverted the earlier changes related to saving strlen calculation
        on the critical path.

Fri Apr  9 17:49:25 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Server_Request.h:
        * tao/Server_Request.i:
          Removed extra <const> in return type. The return was by-value,
          no sense in putting const in that case. Further, some compilers
          bark when you do so.

Fri Apr  9 17:14:09 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * rules.tao.GNU:
          Fixed typos in the alternative extensions for generated files.

Fri Apr  9 16:23:47 1999  Marina Spivak  <marina@cs.wustl.edu>

        * orbsvcs/orbsvcs/Naming/README:
          Added a short blurb about persistent Naming Service

        * orbsvcs/orbsvcs/Naming/Persistent_Context_Index_T.cpp: Removed
          the use of nested typedefs, as this was breaking old g++
          compiler.  Surrounded Debug statements by <if>.  Added a return
          statement to avoid warnings.

        * orbsvcs/Naming_Service/README: Added description of persistence
          command-line option.

        * orbsvcs/orbsvcs/Naming/Naming_Utils.{h,cpp}: Changed the order
          of arguments in <init> method and constructor, to avoid breaking
          old code with the addition of the new parameter.

Fri Apr 09 16:19:12 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/POA.cpp (create_object_key and parse_key): We must include
          the persistent bit even when the POA_NO_TIMESTAMP is defined.
          Otherwise, we won't know which POA map to search. Thanks to Russ
          Noseworthy for reporting this.

Fri Apr  9 15:20:10 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * TAO_IDL/be/be_visitor_interface/interface_ss.cpp (visit_interface):
        * tao/Servant_Base.h (TAO_ServantBase):
        * tao/Server_Request.i (operation):
        * tao/Operation_Table.h (TAO_Operation_Table):
        * tao/Servant_Base.cpp:
        * tao/Server_Request.cpp (retval_):
        * tao/Operation_Table.cpp (TAO_Dynamic_Hash_OpTable): Removed
          strlen calculation for the Operation Name from the critical
          path. Length as it is obtained during demarshalling is stored in
          the IIOP_Request object and passed to the Perfect Hash's find
          operation.

Fri Apr 09 12:52:24 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * examples/POA/DSI/Database_i.cpp (_is_a): Removed
          ACE_UNUSED_ARG(named_value_1) since named_value_1 was removed.

Fri Apr  9 14:29:42 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tao/Any.{h,cpp}: Changed the argument of the static dump()
          function from const value to const reference. Thanks to Ulf
          Jaehrig <jaehrig@desys.com> for suggesting this.

Fri Apr  9 13:28:06 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        Added the following .xls files :

        * TAO/performance-tests/Demux/operation_demux2d.xls
        * TAO/performance-tests/Demux/operation_demux3d.xls
        * TAO/performance-tests/Demux/servant_dispatch2d.xls
        * TAO/performance-tests/Demux/servant_dispatch3d.xls
        * TAO/performance-tests/Demux/poa_lookup2d.xls
        * TAO/performance-tests/Demux/poa_lookup3d.xls

        Updated the following .dsp files to incorporate the recent file
        name changes for Time service server and clerk.

        * Time_Service_{Server,Clerk}.dsp

Fri Apr  9 11:30:37 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/default_server.cpp:
        * tao/default_client.cpp:
        * tao/ORB_Core.cpp: Removed ACE_STATIC_SVC_REQUIRE.

        * tao/TAO_Internal.cpp (open_services): Added in TAO's default
          static services here.

Fri Apr 09 08:19:42 1999  David L. Levine  <levine@cs.wustl.edu>

        * Logging_Service/Makefile,Naming_Service/Makefile,
          tests/Logger/Makefile,tests/Simple_Naming/Makefile:
          only build if the orbsvcs library was built with the
          necessary component.

Fri Apr 09 01:51:52 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/PolicyC.i (_duplicate and _nil): Non-inlined these to remove
          "used before defined" warning.

        * tao/Object_Adapter.i (lock and find_persistent_poa): Rearranged
          to remove "used before defined" warning.

Fri Apr  9 00:49:35 1999  Balachandran Natarajan  <bala@cs.wustl.edu>

        * examples/POA/On_Demand_Activation/server.cpp (main),
        * examples/POA/On_Demand_Activation/Servant_Activator.cpp,
        * examples/POA/On_Demand_Activation/Servant_Locator.cpp: Made some
          cosmetic changes.  Basically changed some ACE_TRY macros

Fri Apr  9 00:04:45 1999  Pradeep Gore  <pradeep@flamenco.cs.wustl.edu>

        * orbsvcs/CosEvent_Service/CosEvent_Service.cpp:
        * orbsvcs/tests/CosEC_Basic/CosEC_Basic.cpp:
        * orbsvcs/tests/CosEC_Multiple/CosEC_Multiple.cpp:
          added trailing ";" to ACE_DECLARE_NEW_CORBA_ENV

Thu Apr  8 23:12:18 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * orbsvcs/orbsvcs/Naming/Naming_Utils.h (TAO_Naming_Server): Added
          a default value of 0 to the persistence_location so that the
          code will build again...

        * tao/ORB.cpp: Rewrote the multicast_query() method to test a
          theory about what might be causing the problem on NT.  Thanks to
          Margaret Reitz <margaret@veritas.com> for motivating this.

Thu Apr 08 18:45:56 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tao/ORB_Core.cpp (root_poa_reference): Had to non-inline this
          function because of reference to the TAO_POA class.

        * tao/POA:
        * tao/POAManager:

          Changed a bunch of functions to be non-virtual.

        * tao/Active_Object_Map.cpp:
        * tao/Object_Adapter.cpp:

          Inlined a bunch of functions.

        * tao/Object_Adapter: Moved the timeprobes from the POA to this
          class.

Thu Apr 08 20:36:39 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tao/TAO[_Static].dsp:
        * orbsvcs/orbsvcs/orbsvcs[_static].dsp: Reworked.

Thu Apr  8 15:30:55 1999  Marina Spivak  <marina@cs.wustl.edu>

        * docs/releasenotes/index.html: Updated to reflect the
          availability of the Persistent Naming Service.

        * orbsvcs/tests/Simple_Naming/client.cpp: Added a missing coma
          after macro.

        * orbsvcs/orbsvcs/Naming/Persistent_Context_Index.{h, cpp}
        * orbsvcs/orbsvcs/Naming/Persistent_Bindings_Map.{h, cpp}
        * orbsvcs/orbsvcs/Naming/Persistent_Entries.{h, cpp}: Fixed
          various compiler warnings/errors, e.g., order of member
          initialization, explicit template instantiation, qualifying
          types with class names, etc.

        * orbsvcs/orbsvcs/Naming/Persistent_Context_Index_T.{h, cpp}:
          Added the files to separate template code from non-template code
          in Persistent_Context_Index.{h,cpp}.

        * orbsvcs/orbsvcs/Naming/Shared_Hash_Map.{h, cpp}: Changed the
          name to Shared_Hash_Map_T.{h, cpp}.

Thu Apr 08 14:48:15 1999  David L. Levine  <levine@cs.wustl.edu>

        * performance-tests/Cubit/TAO/IDL_Cubit/svc.conf.dynamic,
          performance-tests/Cubit/TAO/MT_Cubit/svc.conf.static: Added
          -ORBallowreactivationofsystemids 0.

Thu Apr 08 14:31:19 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * performance-tests/Cubit/TAO/MT_Cubit/svc.conf:
        * performance-tests/Cubit/TAO/IDL_Cubit/svc.conf: Added
          -ORBallowreactivationofsystemids 0 to the svc.conf files since
          no reactivation of servants was taking place.

Thu Apr  8 14:17:31 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/tests/AVStreams/sfp/sfp_client.dsp:
        * orbsvcs/tests/AVStreams/sfp/sfp_server.dsp:
        * orbsvcs/tests/AVStreams/sfp/sfp_tests.dsw: Added these project/
          worspace files for VC++.

        * orbsvcs/tests/AVStreams/sfp/server.cpp:
        * orbsvcs/tests/AVStreams/sfp/client.cpp: Added a ORB shutdown so
          that the tests terminate when the SFP stream terminates.

        * orbsvcs/tests/AVStreams/sfp/common.h: Added a #include
          "orbsvcs_export.h" for VC++.

        * orbsvcs/orbsvcs/AV/sfp.{h,cpp}: Changed the DUMP_BUF macro to a
          function. Fixed the signed/unsigned warnings on NT.Fixed a
          missing return 0 so that the tests work on NT.

Thu Apr  8 13:49:16 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Active_Object_Map.cpp:
        * orbsvcs/orbsvcs/Event/EC_ObserverStrategy.cpp: Added missing
          template instantiations. Thanks to Dave Meyer <dmeyer@saic.com>
          for this one.

        * rules.tao.GNU:
        * orbsvcs/orbsvcs/Makefile: Fixed some dependencies and rules
          problems with the IDL generated files, now we can do "make -j 4"
          in orbsvcs (and apparently all the TAO directories)

Thu Apr 08 14:05:28 1999  David L. Levine  <levine@cs.wustl.edu>

        * CosEvent_Service/Makefile,tests/CosEC_Basic/Makefile,
          tests/CosEC_Multiple/Makefile: only build if the orbsvcs library
          was built with the CosEvent TAO_ORBSVCS component.

Thu Apr 08 13:47:03 1999  David L. Levine  <levine@cs.wustl.edu>

        * BUG-REPORT-FORM,PROBLEM-REPORT-FORM,
          README,VERSION,Makefile,Makefile.am: moved BUG-REPORT-FORM to
          PROBLEM-REPORT-FORM.  Thanks to Thomas Lockhart
          <Thomas.G.Lockhart@jpl.nasa.gov> for suggesting this.

Thu Apr  8 12:59:21 1999  Vishal Kachroo  <vishal@cs.wustl.edu>

        * tao/orbconf.h (TAO_DEFAULT_SERVICE_RESOLUTION_TIMEOUT): Changed
          the value from 1 to 4 to prevent premature timeouts.  Thanks to
          Margaret Reitz <margaret@veritas.com> for motivating this.

          Also removed the #ifdef for TAO_DEFAULT_MULTICAST_SEND_ATTEMPTS
          since this is obsolete now.

Thu Apr  8 11:40:59 EDT 1999  Aniruddha Gokhale  <gokhale@sahyadri.research.bell-labs.com>

        * orbsvcs/orbsvcs/Naming_Service/Persistent_Context_Index.cpp:
          Missing implementation of the virtual destructor for TAO_Index
          added.

Wed Apr  7 20:28:03 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * orbsvcs/tests/CosEC_Multiple/CosECConsumer.cpp:
        * orbsvcs/tests/CosEC_Multiple/CosECSupplier.cpp:
        * orbsvcs/tests/CosEC_Multiple/CosEC_Multiple.cpp:  Added trailing
          semi-columns after ACE_DECLARE_NEW_CORBA_ENV.

Wed Apr  7 19:34:44 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * orbsvcs/tests/Property/{server, client}.dsp:Made the release
          versions.

Wed Apr  7 18:49:41 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/Typecode_Constants.cpp: Added missing _tc_ static in the
          CORBA module.

        * tao/Object_Adapter.cpp: Removed duplicate template
          instantiations.

        * tao/MessagingS_T.i: Commented out code for CORBA::Poller and
          friends.

        * tao/MessagingC.cpp: Removed unwanted template instantiations.

Wed Apr  7 17:31:40 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * orbsvcs/orbsvcs/AV/sfp.{h,cpp}: Replaced CDR with ACE_CDR.  Also
          moved the FRAGMENT_SET_ITERATOR typedef outside the
          TAO_SFP_Fragment_Table_Entry.  Thanks to David Hooker
          <DHooker@uniview.net> for reporting this.

Wed Apr  7 16:36:26 1999  Darrell Brunsch <brunsch@cs.wustl.edu>

        * TAO-INSTALL.html: Added a note about rebuilding all when
          upgrading releases.

Wed Apr  7 16:32:05 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * TAO_IDL/ast/ast_expression.cpp:
        * TAO_IDL/include/ast_expression.h: A quick fix for the DEC bug
          report by Rod Joseph <rodjoseph@adt.com> and Hoggard
          <hoggard@cfx.com>. More extensive changes are in progress. This
          fix just removes the declaration and definition of
          AST_Expression constructors taking ACE_CDR::LongLong and
          ACE_CDR::ULongLong args.

Wed Apr  7 16:25:49 1999  Darrell Brunsch <brunsch@cs.wustl.edu>

        * orbsvcs/orbsvcs/orbsvcs.dsp: Renamed references to CosTimeBase
          to TimeBase.

        * tao/GIOP.cpp: Removed what looked to be a rogue "o".

Wed Apr  7 15:52:06 1999  Ossama Othman  <othman@cs.wustl.edu>

        * Makefile.am: Added `clean-local' targets to all Makefile.am
          files.  Minor updates to the top-level TAO Makefile.am.

Wed Apr 07 15:17:02 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tao/POA_CORBA.h:
        * tao/Typecode_Constants.cpp: Fixed problems with the
          (unimplemented) CORBA::Poller and friends. Thanks to Darrell for
          pointing this out.

Wed Apr  7 15:13:23 1999  Ossama Othman  <othman@cs.wustl.edu>

        * configure.in:
        * tao-config.1.in:
        * tao-config.in:
        * taoConf.sh.in:
        * Makefile.am:
        * TAO_IDL/ast/Makefile.am:
        * TAO_IDL/be/Makefile.am:
        * TAO_IDL/be_include/Makefile.am:
        * TAO_IDL/driver/Makefile.am:
        * TAO_IDL/fe/Makefile.am:
        * TAO_IDL/include/Makefile.am:
        * TAO_IDL/narrow/Makefile.am:
        * TAO_IDL/util/Makefile.am:
        * TAO_IDL/Makefile.am:
        * orbsvcs/Concurrency_Service/Makefile.am:
        * orbsvcs/CosEvent_Service/Makefile.am:
        * orbsvcs/Dump_Schedule/Makefile.am:
        * orbsvcs/Event_Service/Makefile.am:
        * orbsvcs/ImplRepo_Service/Makefile.am:
        * orbsvcs/LifeCycle_Service/Makefile.am:
        * orbsvcs/Logging_Service/Makefile.am:
        * orbsvcs/Naming_Service/Makefile.am:
        * orbsvcs/Scheduling_Service/Makefile.am:
        * orbsvcs/Time_Service/Makefile.am:
        * orbsvcs/Trading_Service/Makefile.am:
        * orbsvcs/Makefile.am:
        * orbsvcs/orbsvcs/AV/Makefile.am:
        * orbsvcs/orbsvcs/Concurrency/Makefile.am:
        * orbsvcs/orbsvcs/CosEvent/Makefile.am:
        * orbsvcs/orbsvcs/Event/Makefile.am:
        * orbsvcs/orbsvcs/Makefile.am:
        * orbsvcs/orbsvcs/Log/Makefile.am:
        * orbsvcs/orbsvcs/Naming/Makefile.am:
        * orbsvcs/orbsvcs/Property/Makefile.am:
        * orbsvcs/orbsvcs/Sched/Makefile.am:
        * orbsvcs/orbsvcs/Time/Makefile.am:
        * orbsvcs/orbsvcs/Trader/Makefile.am:
        * orbsvcs/tests/AVStreams/benchmark/Makefile.am:
        * orbsvcs/tests/AVStreams/mpeg/source/client/Makefile.am:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_client/Makefile.am:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_mib/Makefile.am:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_server/Makefile.am:
        * orbsvcs/tests/AVStreams/mpeg/source/mpeg_shared/Makefile.am:
        * orbsvcs/tests/AVStreams/mpeg/source/server/Makefile.am:
        * orbsvcs/tests/AVStreams/mpeg/source/Makefile.am:
        * orbsvcs/tests/AVStreams/mpeg/Makefile.am:
        * orbsvcs/tests/AVStreams/server_discovery/Makefile.am:
        * orbsvcs/tests/AVStreams/sfp/Makefile.am:
        * orbsvcs/tests/AVStreams/Makefile.am:
        * orbsvcs/tests/Makefile.am:
        * tao/Makefile.am:
          Checked these files into the CVS repository.  These files are
          part of the TAO+auto{conf,make}/libtool integration work.  There
          are still some missing files and some of the above files need to
          be modified before they will work.  I just wanted to get these
          files under CVS control so that I can easily recover from a
          mishap or for some reason beyond my control.

Wed Apr 07 14:34:31 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * examples/POA/DSI/Database_i.cpp (_is_a): Removed unused
          variable.

        * examples/POA/Loader/Servant_Activator.cpp (ServantActivator_i):
        * examples/POA/Loader/Servant_Locator.cpp (ServantLocator_i):
